/* The SREhttp/2 content management system (CMS) program 

   This module will ask user to select an action

*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/******** End of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir


cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_lib=cmsdir||'\LIB'
okk=dosisdir(cmsdir_lib)
if okk=0 then do
  return 'string unable to find CMS lib directory: 'cmsdir_lib
end

cmsdir_files=cmsdir||'\FILES'
okk=dosisdir(cmsdir_files)
if okk=0 then do
  return 'string unable to find CMS input/output files directory: 'cmsdir_files
end

cmsdir_uploads=cmsdir||'\UPLOADS'
okk=dosisdir(cmsdir_uploads)
if okk=0 then do
  return 'string unable to find CMS upload files directory: 'cmsdir_uploads
end

cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'
root=left(uri,jj)


optname.=''
m=0
if list='' then list='action=1'

do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    optname.avar1=aval

    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

if optname.!action='1' then do   /* use the CMS_DEF.HTM template */
  dafile=cmsdir||'\CMS_1.HTM'
  return 'file type text/html name 'dafile 
end 

if optname.!action='11' then do   /* use the CMS_c.HTM template */
  dafile=cmsdir||'\CMS_c.HTM'
  return 'file type text/html name 'dafile 
end 

if optname.!action='2' then do   /* the documentation */
  dafile=cmsdir||'\CMS.HTM'
  return 'file type text/html name 'dafile 
end 


if optname.!action='33' then do   /* return FILE in lib directory */
  dafile=optname.!FILE
  dafile=cmsdir_lib||'\'||strip(dafile,,'\')
  if stream(dafile,'c','query exists')='' then do
      return 'String Sorry, unable to find example of file:<tt>'||dafile','optname.!file||'</tt>'
  end 
  return 'file type text/plain  name ' dafile
end

if optname.!action='3' then do   /* display file in lib directory */
  dafile=optname.!FILE
  dafile=cmsdir_lib||'\'||strip(dafile,,'\')
  if stream(dafile,'c','query exists')='' then do
      return 'String Sorry, unable to find example of file:<tt>'||dafile','optname.!file||'</tt>'
  end 
  stuff=sre_file_read(dafile,2,2,1)
  if stuff='' then do
      return 'String Sorry, unable to read example of file:<tt>'||optname.!file||'</tt>'
  end 
  call lineout tempfile,' <html><head><title>Example of CMS customizable form</title></head>'
  call lineout tempfile,'<font size=-1><a href="javascript:close()">close window</a></font><hr>'
  call lineout tempfile,'<h3>Example of a CMS customizable form</h3>'
  call lineout tempfile,'The following is an example of a customizable form:<tt>'||dafile||'</tt>'
  stuff=sre_html_encode(stuff)
  call lineout tempfile,'<hr><pre>'||stuff||'</pre>'
  call lineout tempfile,'</body></html>'
  call lineout tempfile 
  return 'file type text/html erase name 'tempfile 
end 

if optname.!action='31' then do   /* list currently available dataseries */
   call show_series
   return rcode
end  

if optname.!action='55' | optname.!action='551' then do   /* use the CMS_DEF.HTM template */
  dafile=optname.!DEFFILE
  dafile=cmsdir_index||'\'||strip(dafile,,'\')
  if stream(dafile,'c','query exists')='' then do
      return 'String Sorry, unable to find example of file:<tt>'||dafile||'</tt>'
  end 
  call lineout tempfile,' <html><head><title>A CMS .DEF file</title></head><body>'
  if optname.!action=55 then
     call lineout tempfile,'<font size=-1><a href="javascript:close()">close window</a></font><hr>'
  else
     call lineout tempfile,'<font size=-1><a href="javascript:history.go(-1)">back</a></font><hr>'

  call lineout tempfile,'<h3>Viewing a CMS .DEF file</h3>'
  call lineout tempfile,'<b>Filename:</b> <tt>'||dafile||'</tt>'
  call lineout tempfile,'<table border=1><tr><td><pre>'
  foo=sre_read_file(dafile,2,2,1)
  call lineout tempfile,foo
  call lineout tempfile,'</pre></td></table>'
  call lineout tempfile,' </body></html>'
  return 'file erase type text/html  name ' tempfile
end

return 'string No such CMS action: 'optname.!action



/**********************/
/* currently available dataseries */
show_series:

call lineout tempfile,'<html><head><title>CMS: List of CMS dataseries</title></head> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Currently available CMS dataseries</h3>'

ff=cmsdir_index||'\'||host_nickname||'*.DEF'
goo=sysfiletree(ff,'ff2','FO')


call lineout tempfile,'For host: <Tt>'||host_nickname||'</tt>, <b>'||ff2.0||'</b>  CMS dataseries are available.'

call lineout tempfile,'<p><table border=1><th>Series name</th> <th> Other info</th>'
do jj=1 to ff2.0
   call lineout tempfile,'<tr>'
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<td align="center"><a href="'||root||'CMS_REDO.CMD?deffile='||daname||'&action=2&closeit=1" target="viewer">'||stuff.!series||'</a>'
   call lineout tempfile,'<p><font size=-1><a href="'||root||'CMS?deffile='||daname||'&action=55" target="viewer">view</a> the .DEF file</a></font>'
   call lineout tempfile,'</td>'
   call lineout tempfile,'<td><ul>'
   call lineout tempfile,'<li><b>Description:</b> <em>'||stuff.!desc||'</em>'
   call lineout tempfile,'<li><b>Created:</b> <tt>'||stuff.!created||'</tt>'
   parse var stuff.!varnames p1 '$STATUS' p2 ; varnames=p1||' '||p2
   call lineout tempfile,'<li><b>Variables:</b> <tt>'||varnames||'</tt>'
   parse upper var stuff.!varnames p1 '$STATUS' p2 ; varnames=p1||' '||p2

   parse upper var stuff.!commentvars p1 '$STATUS' p2
   cvars=p1||' '||p2
   parse upper var cvars p1 '$RECID' p2
   cvars=p1||' '||p2
   
   call lineout tempfile,'<li><b>Comment Variables:</b> <tt>'||cvars||'</tt>'

   call lineout tempfile,'<li><B># of owners:</b><tt>'||words(stuff.!OWNERS)||'</tt>'
   call lineout tempfile,'<li><a  target="viewer" href="'||root||'CMS_DEF3.CMD?action=2&deffile='||daname||'&closeit=1">Upload directory:</a><tt>'||stuff.!uploaddir||'</tt><br>'
   call lineout tempfile,'<tt>&amp; </tt> <b>File directory:</b><tt>'||stuff.!filedir||'</tt>'
   ff=stuff.!template
   ffi=0
   do until ff=''
      if ff='' then leave
      parse var ff a1 '0d0a'x ff
      if a1<>'' then ffi=ffi+1
   end
   call lineout tempfile,'<li><B># of </b><a  target="viewer" href="'||root||'CMS_DEF2.cmd?action=2&deffile='||daname||'&closeit=1">template definitions</a>:<tt>&nbsp;&nbsp;'||ffi||'</tt>'

   a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
   if a>0 then do
      amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
      call lineout tempfile,'<li><b>Unable to open database file</b> ('||stuff.!file||')<br>Error:</b> '||amess
   end
   else do
       a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
       parse var a astat a ; astat=strip(astat)
       if astat<>'0' then do
         amess=sre_cache_data('INFO','ERROR',astat)
         call lineout tempfile,'<li><b>Unable ... to retrieve information from database file</b> ('||stuff.!file||')<br>Error:</b> '||amess
       end
       else do
          parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords0 '09'x  vlist_sre '09'x  desc
          nrecords=nrecords0-4
          call lineout tempfile,'<li><b># of </b><a  target="viewer"  href="'||root||'CMS_REM.CMD?action=2&deffile='||daname||'&closeit=1"> records</a>:&nbsp; '||nrecords||', &nbsp;'          
          call lineout tempfile,'<b>last modified</b>:&nbsp; <tt>'||modified||'</tt> '
       end  
    end
    a=sre_cache_data(stuff.!series,'CLOSE')

/* comment info */
   a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!commentfile)
   if a>0 then do
      amess=sre_cache_data('OPEN','ERROR',a,stuff.!commentfile)
      call lineout tempfile,'<li><b>Unable to open database file</b> (<br>Error:</b> '||amess
   end
   else do
       a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
       parse var a astat a ; astat=strip(astat)
       if astat<>'0' then do
         amess=sre_cache_data('INFO','ERROR',astat)
         call lineout tempfile,'<li><b>Unable to retrieve information from database file</b> ('||stuff.!commentfile||')<br>Error:</b> '||amess
       end
       else do
          parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords0 '09'x  vlist_sre '09'x  desc
          nrecords=nrecords0-3
          call lineout tempfile,'<li><b># of </b><a target="viewer" href="'||root||'CMS_CMT.CMD?action=2&deffile='||daname||'&closeit=1">comments</a>:&nbsp; '||nrecords||', &nbsp;'          
          call lineout tempfile,' <b>last modified</b><tt> '||modified||'</tt>'
       end  
    end
    a=sre_cache_data(stuff.!series,'CLOSE')

    call lineout tempfile,'</ul></td>'
end


call lineout tempfile,'</body><html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname='!'||strip(translate(aname))
   stuff.aname=strip(avalue)
end

return 1

