/* The SREhttp/2 content management system (CMS) program 

   This module will add comments


*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_lib=cmsdir||'\LIB'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS lib directory: 'cmsdir_lib
end


cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'
root=left(uri,jj)

optname.=''
m=0
if list='' then list='action=1'
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/
if optname.!action='1' then do   /* find the list of defined for this host*/
  call show_datafiles
  foo=result
  return foo
end

if optname.!action='2' then do   /* choose a record */
  call ask_record
  foo=result
  return foo
end


if optname.!action='3' then do   /* display a comment form */
  call comment_form
  foo=result
  a=sre_cache_data(stuff.!series,'CLOSE')
  return foo
end

if optname.!action='5' then do   /* display a record's values */
  call add_comment
  foo=result
  return foo
end

if optname.!action='4' then do   /* display a record's values */
  call show_record
  foo=result
  return foo
end


/*******************/
/* pick one of the current cms datafiles (for this host) */
show_datafiles:

call lineout tempfile,'<html><head><title>CMS: Choose a CMS datafile</title></head> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Select a CMS dataseries</h3><em> containing the record for which you want to add a comment  ...</em><p> '

ahost=host_nickname

/* look for files, in cmsDIR_index dir, of the form: ahost_nnnn.DEF
   These .DEF files define "CMS indices" --- nnnn is a number from 0 to 9999
*/


cookie_value=sreh2_get_cookie('CMS') 

call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="2">'
ff=cmsdir_index||'\'||ahost||'*.DEF'
goo=sysfiletree(ff,'ff2','FO')

call lineout tempfile,'For host: <Tt>'||ahost||'</tt>, the following CMS dataseries have been created'

call lineout tempfile,'<table border=1>'
do jj=1 to ff2.0
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<tr><th align="left">' 

   if daname=cookie_value  | (cookie_value='' & jj=1) then
      call lineout tempfile,'<INPUT TYPE="RADIO" checked name="deffile" value="'||daname||'">' 
   else
      call lineout tempfile,'<INPUT TYPE="RADIO"  name="deffile" value="'||daname||'">' 

   gob=strip(stuff.!series)||'</th>'
   call lineout tempfile,gob||'<td> <em>&nbsp;'||stuff.!desc||'</em></td>'
end

call lineout tempfile,'</table>'


call lineout tempfile,''
call lineout tempfile,'<br>'

call lineout tempfile,'<table><tr><td><em>Range of records: </em><br> Display records entered <br>between </td>'
call lineout tempfile,'<td><table><tr><td><input type="text" name="SDAY" value="1">'
call lineout tempfile,' <select name="SMONTH" size=1>'
call lineout tempfile,'   <Option selected value="Jan">Jan '
call lineout tempfile,'   <Option value="Feb">Feb '
call lineout tempfile,'   <Option value="Mar">Mar '
call lineout tempfile,'   <Option value="Apr">Apr '
call lineout tempfile,'   <Option value="May">May '
call lineout tempfile,'   <Option value="Jun">Jun '
call lineout tempfile,'   <Option value="Jul">Jul '
call lineout tempfile,'   <Option value="Aut">Aug '
call lineout tempfile,'   <Option value="Sep">Sep '
call lineout tempfile,'   <Option value="Oct">Oct '
call lineout tempfile,'   <Option value="Nov">Nov '
call lineout tempfile,'   <Option value="Dec">Dec '
call lineout tempfile,'</select>'
call lineout tempfile,'<Input type="text" name="SYEAR" value="2003">'
call lineout tempfile,'</td>'
call lineout tempfile,' <tr><th>and</th>'
call lineout tempfile,'<tr valign="top" ><td>'
call lineout tempfile,'<input type="text" name="EDAY" value="31">'
call lineout tempfile,' <select name="EMONTH" size=1>' 
call lineout tempfile,'   <Option selected value="Jan">Jan '
call lineout tempfile,'   <Option value="Feb">Feb '
call lineout tempfile,'   <Option value="Mar">Mar '
call lineout tempfile,'   <Option value="Apr">Apr '
call lineout tempfile,'   <Option value="May">May '
call lineout tempfile,'   <Option value="Jun">Jun '
call lineout tempfile,'   <Option value="Jul">Jul '
call lineout tempfile,'   <Option value="Aut">Aug '
call lineout tempfile,'   <Option value="Sep">Sep '
call lineout tempfile,'   <Option value="Oct">Oct '
call lineout tempfile,'   <Option value="Nov">Nov '
call lineout tempfile,'   <Option selected value="Dec">Dec '
call lineout tempfile,'</select>'
call lineout tempfile,'<Input type="text" name="EYEAR" value="2004">'
call lineout tempfile,'</td></table>'
call lineout tempfile,'</td></table>'

call lineout tempfile,''
call lineout tempfile,'<p><INPUT name="sub2" TYPE="submit" VALUE="Choose a CMS dataseries">'
call lineout tempfile,'</form>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* pick a record to add comment to */
ask_record:

call lineout tempfile,'<html><head><title>CMS: Choose record to add comment to</title></head> '
call lineout tempfile,' '


call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1>'
if optname.!CLOSEIT=1 then call lineout tempfile,'<a href="javascript:close()">Close window</a> || '
call lineout tempfile,'<a href="'||mainaddon||'?action=1">Another CMS action</a>'
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Add a comment to a record in a CMS dataseries</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff

got_abs=wordpos('$ABSTRACT',translate(stuff.!SPECIALS))

/* check for access rights */
rcode=check_access(stuff.!OwnersComment,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN INDEX ',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

astat=sreh2_set_cookie('CMS',daindx,1,root,,1) 

a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   amess=sre_cache_data9('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving info:</b> '||amess
   signal gooble
end

parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords0 '09'x  vlist_sre '09'x  desc
nrecords=nrecords0-4


call lineout tempfile,'<FORM name="docomment" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="3">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'

call lineout tempfile,'<em>For the CMS dataseries: </eM><b>'||stuff.!series||'</b><br>'
call lineout tempfile,'<table>'
call lineout tempfile,'<tr><th align="left">Last comment modified:</th><td>'||modified||'</td>'
call lineout tempfile,'<tr><th align="left"># of comments:</th><td>'||nrecords||'</td>'
call lineout tempfile,'<tr><th align="left">Description:</th><td>'||desc||'</td>'
call lineout tempfile,'</table>'
call lineout tempfile,'<p>Select a <u>record</u> to add a <em>comment</em>  about, or <u>click on a record id</u> to view a record''s contents<p>'


gaa='ABSTRACT=$STATUS '
if got_abs>0 then gaa='ABSTRACT=$ABSTRACT&$STATUS '

a=sre_cache_data(stuff.!series,'EXTRACT ID7 ID '||gaa,"1-"||nrecords0)

parse var a astat ndo '0d0a'x a
if astat<>0 then do
      amess=sre_cache_data9('EXTRACT','ERROR',astat)
      call lineout tempfile,'<b>Error retrieving info:</b> '||amess
      signal gooble
end

/* determine range */
s1=optname.!sday||' '||optname.!Smonth||' '||optname.!SYEAR
e1=optname.!eday||' '||optname.!emonth||' '||optname.!eYEAR

foo=dateconv(s1,'n','b')
if foo='' then 
 s2=0             /* error, no lower limit */
else
  s2=foo-726467

foo=dateconv(e1,'n','b')
if foo='' then 
 e2=1111110             /* error, no upper limit */
else
  e2=foo-726467

ndo_real=0
nall=0

call lineout tempfile,'<ol type="i">'
do nn=1 to ndo

   if got_abs>0 then
     parse var a id7 id '09'x abstract '09'x astatus '0d0a'x a
   else
      parse var a id7 id  '09'x astatus  '0d0a'x a
   if pos('*',id7)>0 then iterate                /* skip this */
   if id7=id then iterate               /* CMS meta data */
   if datatype(id)<>'NUM' then do 
      call lineout tempfile,'<li><input  '
      call lineout tempfile,'            type="radio" name="comment" value="'||id||'">'
      call lineout tempfile,'<em>Contaminated record...</em><u>'||id7||'</u>'
      nall=nall+1
      iterate
   end 

   nall=nall+1
   nid=trunc(id)
   if nid<s2 | nid>e2 then do
     iterate
   end
   ndo_real=ndo_real+1

   parse var astatus . 'CMT_CNT=' ncomments . ; if datatype(ncomments)<>'NUM' then ncomments=0

   call lineout tempfile,''
   call lineout tempfile,'<li><input   '
   call lineout tempfile,'            type="radio" name="comment" value="'||id||'">'
   call lineout tempfile,'<a target="val"'
   call lineout tempfile,' href="'thisaddon||'?action=4&deffile='||daindx||'&id='||id7||'">'||id||'</a>'
   if ncomments>0 then  call lineout tempfile,'<tt> ['||ncomments||' comments] </tt>'
   if got_abs>0 then call lineout tempfile,' <em>'||abstract||'</em>'
end 
call lineout tempfile,'</ol>'

call lineout tempfile,'<input name="sub2" type="submit" value="Add a comment to selected record ">'

call lineout tempfile,'</form>'

call lineout tempfile,'<br>Note: displaying <tt>'ndo_real'</tt> of <tt>'nall'</tt> total records.'

gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode




/*******************/
/* display a form that request values for the comment's fields  */
comment_form:

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   return 'string Error: could not find index file: '||ff
   signal gooble1
end

call read_deffile ff
/* check for access rights */

rcode=check_access(stuff.!OwnersComment,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN INDEX ',stuff.!commentfile)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!commentfile)
   return 'string COMMENT. Error opening comment file:</b> '||amess
end

a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   amess=sre_cache_data('INFO','ERROR',astat)
   return 'string COMMENT. Error retrieving info on comment file:</b> '||amess
end

parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords0 '09'x  vlist '09'x  desc
nrecords=nrecords0-3

dafile=optname.!FILE
if dafile=0 | dafile='' then dafile='CMS_CMT.HTM'

cmtdir=stuff.!FILEDIR
if cmtdir<>'' then
   tfile=fix_file(dafile,strip(cmtdir,,'\')||'\')
else
   tfile=fix_file(dafile,strip(cmsdir_lib,,'\')||'\')
if stream(tfile,'c','query exists')='' then do
  tfile=fix_file(dafile,strip(cmsdir_lib,,'\')||'\')
  if stream(tfile,'c','query exists')='' then do
     return 'string CMS Error: unable to find CMS data file: '||dafile
  end
end
dafile=tfile


stuff=sre_file_read(dafile,2,2,1)
if stuff='' then do
 return 'string CMS Error: unable to read CMS data file: '||dafile
end

ii=pos('<!--FORM_START-->',stuff)
if ii=0 then do
 return 'string COMMENT Error: no FORM_START replaceable string in comment template: 'dafile
end

aa='<FORM name="cmsd" ACTION="'||thisaddon||'" METHOD="POST">'
aa=aa||'<input type="hidden" name="series" value="'||stuff.!series||'"> '
aa=aa||'0d0a'x||'<input type="hidden" name="action" value=5>'
aa=aa||'0d0a'x||'<input type="hidden" name="deffile" value="'||daindx||'">'
aa=aa||'0d0a'x||'<input type="hidden" name="_recid" value="'||optname.!comment||'">'

rsp=optname.!respfile
if rsp=0 then rsp=''
if rsp<>'' then do
   aa=aa||'0d0a'x||'<input type="hidden" name="respfile" value="'||rsp||'">'
end

stuff=sre_replacestrg(stuff,'<!--FORM_START-->',aa,'ALL')

stuff=sre_replacestrg(stuff,'<!--TOTALCOMMENTS-->',nrecords,'ALL')

cc=''
do jjj=1 to words(stuff.!commentvars)
   aw=strip(word(stuff.!commentvars,jjj))
   if abbrev(aw,'$')=1 then iterate
   cc=cc||' '||aw
end 
stuff=sre_replacestrg(stuff,'<!--COMMENTVARS-->',strip(cc),'ALL')

cc=''
do jjj=1 to words(stuff.!specials)
   aw=strip(word(stuff.!specials,jjj))
   if abbrev(aw,'$STATUS')=1 then iterate
   cc=cc||' '||aw
end 
stuff=sre_replacestrg(stuff,'<!--VARS-->',strip(cc),'ALL')

stuff=sre_replacestrg(stuff,'<!--SERIES-->',stuff.!series,'ALL')
stuff=sre_replacestrg(stuff,'<!--RECORD-->',optname.!comment,'ALL')
stuff=sre_replacestrg(stuff,'<!--DATETIME-->',fig_time(optname.!comment),'ALL')
stuff=sre_replacestrg(stuff,'<!--CURRENT_DATETIME-->',sre_datestamp(),'ALL')

aa=aa||'has <tt>'nrecords' </tt>comments recorded.<br>'

    aa='Dataseries: <tt> '||stuff.!series||'</tt> '
aa=aa||'has <tt>'nrecords' </tt>comments recorded.<br>'
aa=aa||'For record: <tt> '||optname.!comment||'</tt>'

/*
         FORM_START: this is the ONLY required "replaceable string".
                     It is used at the beginning of the FORM.
                     It will be replaced by a <FORM ..> element, and
                     by some crucial hidden elements.

         RECORD    : The record-id 
         ABSTRACT  : If the dataseries was defined with an abstract variable,
                     the contents of this variable will be used. Otherwise,
                     a blank string is used.
         DATETIME  : The date and time when the record was entered (using 'N' format).
         SERIES    : The name of this dataseries 
         #COMMENTS : Current number of comments for this record
         LASTADD   : Date and time the last comment was added         
         TOTALCOMMENTS: Total # of comments for all records in dataseries

*/


/* is #COMMENTS or LASTADD used */

gooa=sre_cache_data('TMP_'||stuff.!series,'OPEN INDEX',stuff.!file)

if gooa=0 then do
 ii1=pos('<!--#COMMENTS-->',stuff)
 ii2=pos('<!--#LASTADD-->',stuff)

 if ii1+ii2>0 then do
   vv=sre_cache_data('TMP_'||stuff.!series,'FIND ',strip(optname.!comment),'$STATUS')
   if abbreV(vv,0)=1 then do
     parse var vv . '0d0a'x vv2
     do until vv2=''
        parse var vv2 a1 vv2
        parse upper var a1 a1a '=' a1b ; a1b=strip(a1b); a1a=strip(a1a)
        if a1a='CMT_CNT' then
           stuff=sre_replacestrg(stuff,'<!--#COMMENTS-->',a1b,'ALL')
        if a1a='CMT_MOD' then do
            if a1b=0 then 
                tdo=''
            else
                tdo=fig_time(a1b)
            stuff=sre_replacestrg(stuff,'<!--LASTADD-->',tdo,'ALL')
        end
     end                /* parse $STATUS */
   end                  /* retrieve $STATUS */
 end                    /* need $status */ 

/* check the sortable variables */
 sortables=stuff.!specials
 vnames=translate(stuff.!VARNAMES)
 vtypes=translate(stuff.!VARTYPES)
 
 do until sortables=''
     parse var sortables aw sortables
     aw=strip(translate(aw))
     aw2='<!--%'||aw||'-->'
     if pos(aw2,stuff)>0 then do
       iww1=pos(aw,vnames)
       vtype1=strip(word(vtypes,iww1))
       vv=sre_cache_data('TMP_'||stuff.!series,'FIND ',strip(optname.!comment),aw)
       if abbreV(vv,0)=1 then do
         parse var vv . '0d0a'x tdo
         if vtype1='M' then tdo=sre_pack64(tdo)
         stuff=sre_replacestrg(stuff,aw2,tdo,'ALL')
       end
     end                /* found a <!--%VARNAME--> */
 end /* do the sortable variables */

 gooa=sre_cache_data('TMP_'||stuff.!series,'CLOSE')

end             /* okay OPEN */


gooble1:         /* jump here on error */
rcode=sre_command('var expires 30s type text/html ',stuff)

a=sre_cache_data(stuff.!series,'CLOSE')

return rcode

/*******************/
/* add a comment */
add_comment:
daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   return 'String error: could not find index file: '||ff
end

call read_deffile ff
/* check for access rights */

rcode=check_access(stuff.!OwnersComment,stuff.!SERIES)
if rcode<>1 then return rcode

call lineout tempfile,'<html><head><title>CMS: Adding comment </title></head> '
call lineout tempfile,' '

call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="javascript:history.go(-1)">another comment for this record</a>'
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Adding a comment </h3> '

a=sre_cache_data(stuff.!series,'OPEN INDEX',stuff.!commentfile)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!commentfile)
   call lineout tempfile,'<b>Error opening comment file:</b> '||amess
   signal gooble
end

vv='!_RECID'
recid=optname.vv
call lineout tempfile,'Adding comment to record: <tt> '||recid||'</tt><br>'
if optname.!name<>'' then
   call lineout tempfile,'from <tt> '||optname.!name||'</tt><br>'

cmt_vars=stuff.!commentvars
specs.=''
alladd=0
do mm=1 to words(cmt_vars)
   aw=strip(translate(word(cmt_vars,mm)))
   if abbrev(aw,'$')=1 then iterate             /* skip meta vars */

 /* note: fields in form that do not match commentVars are ignored 
          vars beggining with _ are stored verbatim */
    if abbrev(aw,'_')=1 then do
       vaw='!!'||aw
       specs.mm=sre_pack64_make(optname.vaw)
    end
    else do
      vaw='!'||aw
      specs.mm=optname.vaw 
    end
    alladd=alladd+length(specs.mm)
end 

do mm=1 to 100
  daid=sre_gmt(,,'JS',0)
  poo=sre_cache_data(stuff.!series,'ADD WRITE',daid,,
              recid,'',specs.3,specs.4,specs.5,specs.6,specs.7,specs.8,specs.9,specs.10)

  if poo=6 then do              /* on the slight chance that someone else added a record 
                                   within the last second */
     call syssleep(1)
     iterate
  end 

  leave
end 

if lengtH(poo)>1 then
  call lineout tempfile,'<p>New comment added using id: <TT>'||daid||'</tt><em> ( '||poo||' ) </em>'
else
  call lineout tempfile,'<p>Unable to create new comment -- try again later <p>'

gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')
a=sre_cache_data(stuff.!series,'REWRITE',stuff.!file) 

totcomments='n.a.'
/* now updated status */
a=sre_cache_data(stuff.!series,'OPEN INDEX',stuff.!file)
if abbrev(a,0)<>1 then do
     amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
     call lineout tempfile,'<br><b>Error augmenting comment counter:</b> '||amess
end
else do
     a=sre_cache_data(stuff.!series,'FIND',strip(recid),'$STATUS')
     if abbrev(a,'0')<>1 then do
       amess=sre_cache_data('FIND','ERROR',left(a,1),recid' in 'stuff.!series)
       call lineout tempfile,'<br><b>An error augmenting the comment counter for :</b>  'amess
     end
     else do
       parse var a . '0d0a'x aa
       poo='' ; didct=0 ;didmod=0
       do until aa='' 
          parse var aa a1 aa
          parse upper var a1 xavar '=' xaval
          select
             when xavar='CMT_CNT' then do
                 xaval=strip(xaval) ; if datatype(xaval)<>'NUM'  then xaval=0
                 xaval=xaval+1
                 poo=poo||' CMT_CNT='||xaval
                 totcomments=xaval
                 didct=1
             end 
             when xavar='CMT_MOD' then do
                 poo=poo||' CMT_MOD='||daid
                 didmod=1
             end
             otherwise do
                 poo=poo||' '||a1
             end
           end          /* select */
       end  /* aa='' */
       if didct=0 then poo=poo||' CMT_CNT=1 '           /* in case of wierd errors */
       if didmod=0 then poo=poo||' CMT_MOD='||daid||' '   /* insert these values */
       a=sre_cache_data(stuff.!series,'MODIFY VAR ',recid,'$STATUS',poo)
       if length(a)=1 then do
         call lineout tempfile,'<b>Error saving comment status info:</b> 'a
       end
     end                        /* okay FIND */
end                   /* okay open */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile


/* use response file? */
rfile=space(optname.!RESPFILE,0)
if rfile=0 then  rfile=''
rfileuse=''

if rfile<>'' then do
  cmtdir=stuff.!FILEDIR 
  if cmtdir='' then cmtdir=cmsdir_lib
  rfileuse=strip(cmtdir,,'\')||'\'||strip(rfile,,'\')
  if stream(rfileuse,'c','query exists')='' then do
     rfileuse=strip(cmsdir_lib,,'\')||'\'||strip(rfile,,'\')  /* often redundant, but so what */
     if stream(rfileuse,'c','query exists')='' then do
        rfileuse=''
     end 
  end
end

if rfileuse<>'' then do
    stuff=sre_read_file(rfileuse,2,2,1)
    if stuff='' then rfileuse=''
end

if rfileuse='' then do
  rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
  return rcode
end

/* else, use response file (delete tempfile) */
foo=sysfiledelete(tempfile)

/* make replacements in response file (stuff) */

stuff=sre_replacestrg(stuff,'<!--$RECID-->',recid,'ALL')
stuff=sre_replacestrg(stuff,'<!--#COMMENTS-->',totcomments,'ALL')
stuff=sre_replacestrg(stuff,'<!--$COMMENT_ID-->',daid,'ALL')
stuff=sre_replacestrg(stuff,'<!--$NAME-->',optname.!name,'ALL')
stuff=sre_replacestrg(stuff,'<!--$TITLE-->',optname.!title,'ALL')
stuff=sre_replacestrg(stuff,'<!--$LENGTH-->',alladd,'ALL')


rcode=sre_command('VAR ETAG_AUTO EXPIRES 30s NOCACHE NOIF  TYPE text/html ',stuff,idinfo)
return rcode




/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname='!'||strip(translate(aname))
   stuff.aname=strip(avalue)
end

return 1


/*******************/
/* display a record  */
show_record:

call lineout tempfile,'<html><head><title>CMS: Display a record </title></head> '


call lineout tempfile,'<font size=-1>'
call lineout tempfile,'<a href="javascript:close()">Close window</a></font><br>'

call lineout tempfile,'<h3>Display a CMS record</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OwnersComment,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

varnames=stuff.!varnames
vartypes=stuff.!vartypes
vartypes.=''
varnames.=''
varnames.0=0
do mm=1 to words(varnames)
  avar=strip(translate(word(varnames,mm)))
  varnames.mm=avar
  atype=strip(translate(word(vartypes,mm)))
  varnames.mm.!type=atype
  vv='!'||avar
  vartypes.vv=atype
end
varnames.0=words(varnames)

getvs='%ID VALS VALINDEX '||stuff.!SPECIALS
a=sre_cache_data(stuff.!series,'FIND ID7',optname.!id,getvs)

parse var a astat a
if astat>0 then do
   amess=sre_cache_data('FIND','ERROR',astat)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

/* find real id (in the actual data)
vars are: VALS VALINDX [$abstract] [Special1 ... ] */
parse var a . '0d0a'x realid '0d0a'x morea ; realid=strip(realid)


call lineout tempfile,'<FORM name="domodify" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="4">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'
call lineout tempfile,'<input type="hidden" name="id7" value="'||optname.!ID||'">'
call lineout tempfile,'<input type="hidden" name="realid" value="'||realid||'">'

call lineout tempfile,'<em>From the CMS dataseries: </eM><b>'||stuff.!series||'</b><br>'

parse var a id7 vlist '0d0a'x a

call lineout tempfile,"<table border=1>"
av1='Record ID<br>Entered on'
tim=fig_time(realid)
aval1=realid||'<br>'||tim
call lineout tempfile,'<tr bgcolor="#998899"><th align="left" >'||av1||'</th><td>'||aval1||'</td>'

parse var morea vals '0d0a'x indx '0d0a'x morea
vvals.=''
if words(stuff.!pack)>0 then do               /* there are some packed variables */
  if strip(indx)=0 then do
     call lineout tempfile,'<b>Error</b>: packed variables specified, but no data '
     signal gooble
  end 
  iat=1
  do mm=1 to words(stuff.!pack)
      aww=strip(translate(word(stuff.!pack,mm)))
      vv='!'||aww
      vvals.vv.!name=aww
      vvals.vv.!type=vartypes.vv
      ilen=strip(word(indx,mm))
      if ilen=0 then iterate
      vvals.vv=substr(vals,iat,ilen)
      iat=iat+ilen
  end
end

/* add the special variables */
if stuff.!specials<>'' then do
  do jj=1 to words(stuff.!specials)
      aww=strip(translate(word(stuff.!specials,jj)))
      vv='!'||aww
      vvals.vv.!name=aww
      vvals.vv.!type=vartypes.vv
      parse var morea vvals.vv '0d0a'x morea
  end
end

do ii=1 to varnames.0
   aww=varnames.ii ; vv='!'||aww
   atype=vvals.vv.!type
   aname=vvals.vv.!name
   if abbrev(aname,'$A')=1 then aname='Abstract'
   if abbrev(aname,'$S')=1 then aname='Status'

   aval1=vvals.vv

   if atype='T' then do
       use_time=fig_time(aval1)
       aval1=aval1||' ('||use_time||')'
    end

   if atype='M' then do
      aval1=sre_pack64(aval1)
      aval1=sre_replacestrg(aval1,'0d0a'x,'<BR>','ALL')
   end 
   call lineout tempfile,"<tr><th align="left" >"||aname||'</th><td>'||aval1||'</td>'
end 
call lineout tempfile,"</table>"


gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode







/******************************/
/* check access rights. Return 1 if okay. Otherwise, return a string to be
  sent back to SREhttp/2 (an authorization response string) */
check_access:procedure expose privset host_nickname idinfo uri aiter
parse  upper arg owners,series

if owners='' then return 1      /* no owners listed, means open access */


tpr=translate(privset)
pneeded=space(translate('CMS:'||strip(series)),0)
if wordpos(pneeded,tpr)>0 then return 1          /* explicit privilege for this */
if wordpos('SUPERUSER',tpr)>0 then return 1

/*  DO not set cookie for comment adding */
/* === look_cook='CMS_'||series
aa=sreh2_get_cookie(lookcook)
if aa=1 | aa  then return 1
====== */

if aiter=''  then do            /* first time, so recheck privs */
  return 'PRIVS   Access to this dataseries is restricted to specific users '
end 

/* otherwise, see if a username has been sent  */
username=''
authh=sre_reqfield('Authorization')
if authh<>'' then username=sre_extract_username(authh) 
if username='' then do             /* no username available */
  return  'AUTH  Access to this dataseries is restricted to specific users '
end

/* is this one of the OWNERS? */
if pos('*',owners)=0 then do            /* * means "any user" */
if wordpos(translate(username),translate(owners))=0 then do
   return 'AUTH  Access to this dataseries is restricted to specific users '
end
end

/* One of the OWNERS, now check password */
stuff=sreh2_get_userinfo(authh,host_nickname,idinfo)
if stuff='' then do
  return 'AUTH   Access to this dataseries is restricted to specific users. Please enter a new username/password.'
end

/*  on comment add, do NOT set cookie
parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
pp=left(thisaddon,jj)
foo=sreh2_set_cookie(lookcook,1,'30m',pp,,1) 
*/

return 1

/************/
/* convert from CMS id  (JS time stamp) to "N" time stamp */
fig_time:procedure
parse arg atime0

if datatype(atime0)<>'NUM' then return ''

parse var atime0 adate1 '.' atime
adate=adate1+726467
atime='0.'||atime

dd=dateconv(adate,'B','N')

/* else, convert to hr min second */
zz=digits()
numeric digits 16
secs=trunc(atime*86400)
tmp0=secs/3600
parse var tmp0 hour '.' tmp1 ; if tmp1='' then tmp1=0
hour=right(hour,2,'0')
tmp1='0.'||tmp1
tmp2=tmp1*60
parse var tmp2 minute '.'tmp3 ; ; if tmp3='' then tmp3=0
minute=right(minute,2,'0')
tmp3='0.'||tmp3
tmp3=tmp3*60 ; parse var tmp3 second '.' .
second=right(second,2,'0')
numeric digits zz

dd=dd||' '||hour||':'||minute||':'||second
return dd


/************/
/* figure out a filename, possibly randomized, possibly relative to a directory of a 
reference file*/
fix_file:procedure
parse arg afile,reffile,noast,ith,doover

afile=strip(afile)
if abbrev(afile,'\')=0 & pos(':',afile)=0 then do     /* relative filename */
  afile=strip(filespec('d',reffile)||filespec('p',reffile),,'\')||'\'||afile
end
if pos('*',afile)+pos('?',afile)=0 then return afile  /* no randomization component */

if noast=1 then return afile

if doover=1  then do                    /* use ITH to determine file name (don't search for unused name)*/
  if pos('*',afile)=0 then return afile||'_'||ith
   parse var afile p1 '*' p2 ; afile=p1||ith||p2
  return afile
end

if pos('*',afile)>0 then do
     parse var afile p1 '*' p2 ; afile=p1||'????'||p2
end 
fpath=filespec('d',afile)||filespec('p',afile)
fname=filespec('n',afile)
aname=sre_tempfile(fname,'?',fpath)

return aname

