/* The SREhttp/2 content management system (CMS) program 

   This module will define (create) a CMS dataseries

*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''

/* Set to 1 to force the user to select a file upload directory (if she specified
  a "file" type of variable.
   Otherwise, if nothing entered, then use the CMS\UPLOADS directory. */
force_uploadir=0

/******** End of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

cmsdir_lib=cmsdir||'\LIB'
okk=dosisdir(cmsdir_lib)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_lib
end

cmsdir_pol=cmsdir||'\LIB\POL'
okk=dosisdir(cmsdir_pol)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_pol
end


cmsdir_files=cmsdir||'\FILES'
okk=dosisdir(cmsdir_files)
if okk=0 then do
  return 'string unable to find CMS input/output files directory: 'cmsdir_files
end



vers=sre_cache_data(' ','INFO',,'VERSION')
parse var vers . '0d0a'x aversion ; aversion=strip(translate(aversion,' ','09'x))
if aversion<1.19 then do
  return 'SRE2003 version is too old (must at least support SRE_DCSH version 1.19) '
end

optname.=''
m=0
if list='' then list='action=1'

do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval

    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    if optname.avar2<>'' then
       optname.avar2=optname.avar2||' '||aval2
    else
       optname.avar2=aval2

end

/* check for access rights */
call sec_check          /* use security_level to control access */
ares=result
if ares<>0 then return ares


if optname.!action='1' | optname.!regen=1 then do   /* use the CMS_DEF.HTM template */
  call gen_form
  return rthing
end 

if optname.!action='2' then do   /* popup help */
  foo=help_1(optname.!ITEM)
  return foo
end 

if optname.!action='3' then do   /* step 2  */
  call step_2
  rr=result
  if rr<>1 then return rr
  return rthing
end

/* ================ If here, create the CMS dataseries */

/* any "designated" vars ? */                         
specials=optname.!specials
varlist=strip(translate(optname.!varlist))
vartypes=strip(translate(optname.!vartypes))

do jj=1 to words(specials)
   aww=translate(strip(word(specials,jj)))
   if wordpos(aww,varlist)=0 then return 'String Error: a special variable ('||aww||') is not defined in 'varlist
end

/* any option files */
sels.='' ; isel=0
do ll=1 to words(optname.0)
   aww=strip(translate(word(optname.0,ll)))
   if abbrev(aww,'SEL_')=1 then do
     isel=isel+1
     parse var aww . '_' selname
     if wordpos(selname,translate(optname.!varlist))=0 then do
        return 'String Error: a Select list variable ('||selname||') does not exist in '||optname.!varlist
     end 
     vv='!!'||aww
     sels.isel=selname ; sels.isel.!ofile=optname.vv
     if sels.isel.!ofile='-' then do
        return 'String Error: you forgot to assign an options file to the variable: 'selname||'<br><a href="javascript:history.go(-1)">Go back and fix it</a>'
     end 
     sels.0=sels.0||' '||selname
   end
end 
sels.!0=isel

/* any poll-definition files */
pols.='' ; ipol=0
do ll=1 to words(optname.0)
   aww=strip(translate(word(optname.0,ll)))
   if abbrev(aww,'POL_')=1 then do
     ipol=ipol+1
     parse var aww . '_' polname
     if wordpos(polname,translate(optname.!varlist))=0 then do
        return 'String Error: a Poll variable ('||polname||') does not exist in '||optname.!varlist
     end 
     vv='!!'||aww
     pols.ipol=polname ; pols.ipol.!ofile=optname.vv
     if pols.ipol.!ofile='-' then do
        return 'String Error: you forgot to assign a poll-definition file to the  variable: 'polname||'<br><a href="javascript:history.go(-1)">Go back and fix it</a>'
     end 
     pols.0=pols.0||' '||polname
   end
end 
pols.!0=ipol
 
/*  Are all Poll vars SORTABLE */
do mm=1 to words(varlist)
    atype=translate(strip(word(vartypes,mm)))
    if atype<>'P' then iterate
    avar=translate(strip(word(varlist,mm)))
    if wordpos(avar,specials)=0 then do
       return 'String Poll variable 'avar ' <b>must be sortable</b>. <br><a href="javascript:history.go(-1)">Go back and fix it</a>'
    end 
end

cc=optname.!comment_vars
if cc='' then do
  optname.!comment_vars='$RECID $STATUS NAME EMAIL TITLE _CONTENTS'
end
else do
   if words(cc)>8  then do
        return 'String Error: you can only specify 8 (or fewer) comment variables.<br><a href="javascript:history.go(-1)">Go back and fix it '
   end
   optname.!comment_vars='$RECID $STATUS '||optname.!COMMENT_VARS
end

/* make the stub of the cms dataseries file */
vstore='VALS VALINDEX '         /* these always are used */


/* always store $STATUS */
vstore=vstore||' $STATUS '
var_STATUS='$STATUS '
type_STATUS='1 '

var_abstract='' ; type_abstract=''
if optname.!ABSTRACT=1 then  do  /* add an "abstract" as one of the "special" variables */
   vstore=vstore||' $ABSTRACT '
   var_abstract='$ABSTRACT '
   type_abstract='A '
end


vstore=vstore||specials         /* and add the other special variables */

series=optname.!series
a=sre_cache_data(series,'DEFINE',optname.!series_file,vstore,optname.!desc,optname.!!comment)
if a<>0 then do
  amess=sre_cache_data('DEFINE','ERROR',a,optname.!series_file)
  oo='<b>Error</b>: '||amess||crlf
  parse var uri xx "?" .
  oo=oo||'<p><a href="'||xx||'?action=1">Try again (to create a CMS data file)</a>'
  return 'string '||oo
end

/* create a !STATUS and !INFORM record */

a=sre_cache_data(series,'OPEN',optname.!series_file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,series.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

tt=''
do jj=1 to sels.!0
  tt=tt||sels.jj||' '||sels.jj.!ofile
  if jj<>sels.!0 then tt=tt||','
end

poo=sre_cache_data(series,'ADD WRITE ID7','_INFORM ', ,
   'Varnames='||var_status||' '||var_abstract||' '||varlist||'; VarTypes='||type_status||' '||,
   type_abstract||' '||vartypes||'; SORTABLE='||var_status||' '||var_abstract||' '||specials||'; SELECTS='tt) 
poo=sre_cache_data(series,'ADD WRITE ID7','_LOOKUP',space(' ',70,' '))
poo=sre_cache_data(series,'ADD WRITE ID7','_STATUS','                 ')

a=sre_cache_data(series,'CLOSE')


/* now create comments file */

tt=optname.!series_file
ii=lastpos('.',tt)
if ii=0 then do
   optname.!series_commentfile=tt||'_CMT'
end 
else do
   optname.!series_commentfile=left(tt,ii-1)||'$CMT'||substr(tt,ii)
end

cseries=optname.!series||'_CMT'
cvstore=optname.!COMMENT_VARS
a=sre_cache_data(cseries,'DEFINE',optname.!series_commentfile,cvstore,'Comments for: '||optname.!desc,optname.!!comment)
if a<>0 then do
  amess=sre_cache_data('DEFINE','ERROR',a)
  oo='<b>Error creating comment data series file</b>: '||amess||crlf
  parse var uri xx "?" .
  oo=oo||'<p><a href="'||xx||'?action=1">Try again ... (to create a CMS data file)</a>'
  return 'string '||oo
end

/* create a !STATUS and !INFORM record */
a=sre_cache_data(cseries,'OPEN',optname.!series_commentfile)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,series.!commentfile)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end


poo=sre_cache_data(cseries,'ADD WRITE ID7','_INFORM ',left('Comments for 'optname.!series_file,70,' '))

poo=sre_cache_data(cseries,'ADD WRITE ID7','_STATUS',left(' ',70,' '))

a=sre_cache_data(cseries,'CLOSE')


/* now create index */

/* remove specials from varlist to get packed-vars */
pack_vars=varlist
do ii=1 to words(specials)
   aww=strip(translate(word(specials,ii)))
   parse var pack_vars p1 (aww) p2
   pack_vars=p1||' '||p2
end


oo='; CMS index file created '||time('n')||' '||date('n')||crlf
oo=oo||'Series: '||series||crlf
oo=oo||'File: '||optname.!series_file||crlf
oo=oo||'CommentFile: '||optname.!series_commentfile||crlf
oo=oo||'Created: '||time('n')||' '||date('n')||crlf
oo=oo||'Desc: '||optname.!desc||crlf
oo=oo||'Owners: '||optname.!OWNERS||crlf
oo=oo||'OwnersComment: '||optname.!OWNERS_COMMENT||crlf

oo=oo||'VarNames: '||var_status||' '||var_abstract||' '||varlist||crlf
oo=oo||'VarTypes: '||type_status||' '||type_abstract||' '||vartypes||crlf
oo=oo||'Pack: '||pack_vars||crlf
oo=oo||'Specials: '||var_status||' '||var_abstract||' '||specials||crlf
oo=oo||'CommentVars: '||optname.!comment_vars||crlf

tsel=''
do jj=1 to sels.!0
  tsel=tsel||sels.jj||' = '||sels.jj.!ofile||';'
end
oo=oo||'Select: '||tsel||crlf


tpol=''
do jj=1 to pols.!0
  tpol=tpol||pols.jj||' = '||pols.jj.!ofile||';'
end
oo=oo||'Poll: '||tpol||crlf


if optname.!UPLOADDIR<>'' then do
  oo=oo||'UploadDir: '||optname.!uploaddir||crlf
end

if optname.!FILEDIR<>'' then do
  oo=oo||'FileDir: '||optname.!filedir||crlf
end

/* template files */
vv=optname.0
tlist.='' ; tlist.0=0
do until vv=''
  parse upper var vv avv vv
  if abbrev(avv,'OUTPUT_')+abbrev(avv,'TEMPLATE_')+abbrev(avv,'DESC_')=0 then iterate
  parse var avv att '_' nn
  att='!'||STrip(att)
  avv0='!'||avv
  tlist.nn.att=optname.avv0
  tlist.0=max(nn,tlist.0)
end

do jj=1 to tlist.0
   if tlist.jj.!OUTPUT='' | tlist.jj.!TEMPLATE='' then iterate
   oo=oo||'Template: '||tlist.jj.!OUTPUT||' '||tlist.jj.!TEMPLATE||' , '||tlist.jj.!DESC||crlf
end 

t0=strip(left(series,6,' '))
t1=host_nickname||'_'||t0||'_???.DEF'
cmsindx_file=sre_tempfile(t1,,cmsdir_index)

arf=sre_append_file(cmsindx_file,oo,2,,1)
if arf<0 then return 'String Error: data series created, but unable to write CMS index file 'cmsindx_file

oo='<html><head><Title>CMS dataseries defined </title></head>'||crlf
oo=oo||'<h3>CMS dataseries succesfully defined</h3>'||crlf
oo=oo||'<ul><li><b>Series: </b>'||series||crlf
oo=oo||'<li><b>File:</b> '||optname.!series_file||crlf
oo=oo||'<br><b>CommentFile:</b> '||optname.!series_commentfile||crlf

oo=oo||'<li><b>Owners:</b> '||optname.!owners||'<br><b>(owners for comments): </b>'||optname.!owners_comment||crlf

oo=oo||'<li><b>Variables: </b> '||varlist||crlf
oo=oo||'<br><em>sortable </em> '||specials||crlf
if optname.!UploadDIR<>'' then
  oo=oo||'<li><b>Uploaded files: </b> '||optname.!UPLOADDIR||crlf
if optname.!FILEDIR<>'' then
  oo=oo||'<li><b>Output files: </b> '||optname.!FILEDIR||crlf



/* create subdirectories? */
todir=''
if optname.!CREATE_DIRS=1 then do

   errs.='problem creating directory '
   errs.0='Success.'
   errs.3='error: Path not found'
   errs.5='error: access denied'
   errs.108='error: drive locked'

    ddir=strip(optname.!filedir,,'\')

    if right(ddir,1)=':' then do 
         ddir=ddir||'\'
    end 
    else do
      if pos(':',ddir)=0 & abbrev(ddir,'\')=0 then do
          ddir=cmsdir_files||'\'||ddir
      end 
    end 
    if dosisdir(ddir)=0 then do
        oo=oo||'<li>Error: no such file directory<tt> '||optname.!filedir||'</tt>'
    end 
    else do
        a1=strip(ddir,,'\')
        todir=a1
        a1a=a1||'\COMMENTS'        
        a1b=a1||'\ARCHIVES'        
        a1c=a1||'\UPLOADS'        
        a1d=a1||'\POLLS'        
        t1=sysmkdir2(a1a)
        t2=sysmkdir2(a1b)
        t3=sysmkdir2(a1c)
        t4=sysmkdir2(a1d)

        oo=oo||'<li>Creating<tt> '||a1a||'</tt>. '||errs.t1
        oo=oo||'<li>Creating<tt> '||a1b||'</tt>. '||errs.t2
        oo=oo||'<li>Creating<tt> '||a1c||'</tt>. '||errs.t3
        oo=oo||'<li>Creating<tt> '||a1d||'</tt>. '||errs.t4

    end 
end 

/* copy sample forms */
if optname.!COPY_FORMS=1 & todir<>'' then do

  errs.='unspecified copy error '
  errs.0='Success.'
  errs.2 ='Error: source file not found '
  errs.3 ='Error: source or target path not found '
  errs.5 ='Error: target file exists but  A  or  R  mode not specified '
  errs.32 ='Error: sharing violation for source or target file '
  errs.108 ='Error: source or target drive locked '
  errs.112 ='Error: disk full '
  errs.206 ='Error: invalid source or target file name '
  errs.267 ='Error: source name is a directory '
  errs.282 ='Error: extended attributes not supported for target '

  oo=oo||'<li>Copying files to <tt>'||todir||'</tt><menu>'
  a1=cmsdir_lib||'\CMS_CMT.HTM'
  a2=todir||'\CMS_CMT.HTM'
  foo1=doscopy(a1,a2,'R')
    oo=oo||'<li>Copying <tt>CMS_CMT.HTM</tt>: '||errs.foo1

  a1=cmsdir_lib||'\CMT_RESP.HTM'
  a2=todir||'\CMT_RESP.HTM'
  foo2=doscopy(a1,a2,'R')
    oo=oo||'<li>Copying <tt>CMT_RESP.HTM</tt>: '||errs.foo2

  a1=cmsdir_lib||'\CMS_ADD.HTM'
  a2=todir||'\CMS_ADD.HTM'
  foo3=doscopy(a1,a2,'R')
    oo=oo||'<li>Copying <tt>CMS_ADD.HTM</tt>: '||errs.foo3

  a1=cmsdir_lib||'\ADD_RESP.HTM'
  a2=todir||'\ADD_RESP.HTM'
  foo3=doscopy(a1,a2,'R')
    oo=oo||'<li>Copying <tt>ADD_RESP.HTM</tt>: '||errs.foo3
    oo=oo||'</menu>'
end

oo=oo||'</ul>'||crlf

parse var uri xx '?' .
jj=lastpos('/',uri)
xx2=left(uri,jj)||'/cms.cmd?action=1'
oo=oo||'<hr><a href="'||xx2||'">Another CMS action?</a><p>'

oo=oo||'</body></html>'

return 'var type text/html ' ||crlf||oo




/**********************/
/* check step 1 input, and then ask for more info */
step_2:

if optname.!series_file='' then optname.!SERIES_FILE=cmsdir||'\DATA\'||host_nickname||'_'||optname.!SERIES

series=optname.!series
if series='' then return 'String ERROR: you must specify a series name '

varlist=make_varlist()
if varlist=''||'0d0a'x||'' then do
   return  'string Error: you did not define any variables.'
end
else do
   parse var varlist varlist '0d0a'x vartypes
end 

/* if any "file or url" types, check if uploaddir was specified */
do wordpos('F',vartypes)>0 then do
    if optname.!UPLOADDIR='' then do
       if force_uploadir=1 then do               /* force_uploadir is set in user configurable parameters at the top of this file */
             oo='<html><head><title>Error</title></head><body>'
             oo=oo||'<b>Error</b>: You specified file variables, but you did not specify a file-storage directory'||crlf
             parse var uri xx "?" .
             oo=oo||'<p><a href="javascript:history.go(-1)">Go back to input form</a></a></body></html>'
             return 'string '||oo
          end
          else do               /* use CMSdir\UPLOADS */
             optname.!UPLOADDIR=cmsdir||'\UPLOADS'
          end 
    end
end


errs.='problem creating directory '
errs.0='Success.'
errs.3='error: Path not found'
errs.5='error: access denied'
errs.108='error: drive locked'

/* see if uploaddir exists */
if optname.!UPLOADDIR<>'' then do
   ddir_up=strip(strip(optname.!UPLOADDIR),,'\')
   if  right(ddir_up,1)=":" then ddir_up=ddir_up||'\'
   if dosisdir(ddir_up)=0 then do
      if optname.!UPLOADDIR_MAKE<>1 then do
          oo='<html><head><title>Error</title></head><body>'
          oo=oo||'<b>Error</b>: No such upload storage directory: 'optname.!UPLOADDIR||crlf
          parse var uri xx "?" .
          oo=oo||'<p><a href="javascript:history.go(-1)">Go Back and enter a directory.</a></body></html>'
          return 'string '||oo
      end
      else do
        foo=sysmkdir2(ddir_up)
        if foo<>0 then do
          oo='<html><head><title>Error</title></head><body>'
          oo=oo||'<b>Error</b>: Could not create upload storage directory: 'optname.!UPLOADDIR||' ('||errs.foo||')'||crlf
          parse var uri xx "?" .
          oo=oo||'<p><a href="javascript:history.go(-1)">Go Back and enter a directory.</a></body></html>'
          return 'string '||oo
        end 
      end
   end
end

/* see if filedir exists */
if optname.!FILEDIR<>'' then do

   ddir=strip(strip(optname.!FILEDIR),,'\')
   if  right(ddir,1)=":" then do 
      ddir=cmsdir_files||'\'
   end
   else do
       if pos(':',ddir)=0 & abbrev(ddir,'\')=0 then do
           ddir=cmsdir_files||'\'||ddir
       end 
   end 
 
   if dosisdir(ddir)=0 then do
      if optname.!FILEDIR_MAKE<>1 then do
          oo='<html><head><title>Error</title></head><body>'
          oo=oo||'<b>Error</b>: No such file storage directory: 'optname.!FILEDIR||crlf
          parse var uri xx "?" .
          oo=oo||'<p><a href="javascript:history.go(-1)">Go Back and re-enter directory name.</a></body></html>'
          return 'string '||oo
      end
      else do
        foo=sysmkdir2(ddir)
        call sre_pmprintf('CMS: mkdir of 'ddir)
        if foo<>0 then do
          oo='<html><head><title>Error</title></head><body>'
          oo=oo||'<b>Error</b>: Could not create file storage directory: 'optname.!FILEDIR||' ('||errs.foo||')'||crlf
          parse var uri xx "?" .
          oo=oo||'<p><a href="javascript:history.go(-1)">Go Back and re-enter directory name .</a></body></html>'
          return 'string '||oo
        end 
      end
   end
end


/* now, generate second round, which asks you to identify 
        1) Specially designated variables
        2) Option files for SELECT List variable
*/

dafile=cmsdir||'\CMS_DEF2.HTM'

stuff=sre_file_read(dafile,2,2,1)
if stuff='' then do
 return 'string Error: unable to find CMS data file: '||dafile
end


/* insert a bunch of hiddens */
aa=''
aa=aa||'<input type="hidden" name="SERIES" value="'||optname.!SERIES||'">'||'0d0a'x
aa=aa||'<input type="hidden" name="SERIES_FILE" value="'||optname.!SERIES_FILE||'">'||'0d0a'x
aa=aa||'<input type="hidden" name="OWNERS" value="'||optname.!OWNERS||'">'||'0d0a'x
aa=aa||'<input type="hidden" name="OWNERS_COMMENT" value="'||optname.!OWNERS_COMMENT||'">'||'0d0a'x

aa=aa||'<input type="hidden" name="ABSTRACT" value="'||optname.!ABSTRACT||'">'||'0d0a'x
aa=aa||'<input type="hidden" name="STATUS" value="'||optname.!STATUS||'">'||'0d0a'x
aa=aa||'<input type="hidden" name="VARLIST" value="'||varlist||'">'||'0d0a'x
aa=aa||'<input type="hidden" name="VARTYPES" value="'||vartypes||'">'||'0d0a'x
aa=aa||'<input type="hidden" name="DESC" value="'||optname.!desc||'">'||'0d0a'x
aa=aa||'<input type="hidden" name="COMMENT" value="'||(optname.!!comment)||'">'||'0d0a'x

do mm=1 to 50           /* max of 50 out/template files */
   oname0='!OUTPUT_'||mm
   if optname.oname0='' then iterate
   oname=translate(space(optname.oname0,0))
   tt='!TEMPLATE_'||mm
   tname=strip(translate(optname.tt))
   tt='!DESC_'||mm
   dname=strip(translate(optname.tt))
   aa=aa||'<input type="hidden" name="OUTPUT_'||mm||'"  value="'||oname||'">'||'0d0a'x
   aa=aa||'<input type="hidden" name="TEMPLATE_'||mm||'"  value="'||tname||'">'||'0d0a'x
   aa=aa||'<input type="hidden" name="DESC_'||mm||'"  value="'||dname||'">'||'0d0a'x
end
aa=aa||'<input type="hidden" name="FILEDIR" value="'||optname.!filedir||'">'||'0d0a'x
aa=aa||'<input type="hidden" name="UPLOADDIR" value="'||optname.!uploaddir||'">'||'0d0a'x

stuff=sre_replacestrg(stuff,'<!-- $REPLACE_5 -->',aa,'ALL')

stuff=sre_replacestrg(stuff,'<!-- $REPLACE_1 -->',optname.!series,'ALL')
vv=varlist

select
  when optname.!ABSTRACT=1 & optname.!STATUS=1 then do
     vv='Abstract Comment-counter, '||vv
  end
  when optname.!ABSTRACT=1 then do
     vv='Abstract, '||vv
  end
  when optname.!STATUS=1 then do
     vv='Comment-counter, '||vv
  end
  otherwise do
     nop
  end
end

stuff=sre_replacestrg(stuff,'<!-- $REPLACE_2 -->',vv,'ALL')

/* vartypes possible: M N T S C F 1 P */

/* pull out 1, N, and S variables (for "sortable" designation) */
slist=vartypes
if verify(vartypes,'P 1 N S T','M')=0 then do
   aa='<b>You did not define any variables that can be <em>sortable</em>.'
   stuff=sre_replacestrg(stuff,'<!-- $REPLACE_3 -->',aa,'ALL')
end 
else do
    aa='<select name="specials" size=5 multiple>'||'0d0a'x
    do mm=1 to words(vartypes)
       atype=strip(word(vartypes,mm))
       if pos(atype,'P1SNT')=0 then iterate
       avar=strip(word(varlist,mm))
       ischecked=''
       if atype='P' then ischecked='SELECTED'
       aa=aa||'<option value="'||avar||'" '||ischecked||' >'||avar||'0d0a'x
    end
    aa=aa||'</select>'||'0d0a'x||'0d0a'x
    stuff=sre_replacestrg(stuff,'<!-- $REPLACE_3 -->',aa,'ALL')

end


aa=''
/* now, find all .OPT files in the LIB subdirectory */
if pos('S',vartypes)=0 then do
   aa='<b>You did not define any <tt>select list</tt> variables</b>.'
   stuff=sre_replacestrg(stuff,'<!-- $REPLACE_4 -->',aa,'ALL')
end 
else do
  oo=sysfiletree(cmsdir_lib||'\*.OPT','ofiles','FO')
  if ofiles.0=0 then do
     aa='There are <b>no</b> options files (.OPT files) currently available in '||cmsdir_lib||'</b>'
     stuff=sre_replacestrg(stuff,'<!-- $REPLACE_4 -->',aa,'ALL')
  end
  else do
     do j1=1 to ofiles.0
        ofiles.j1=filespec('n',ofiles.j1)
        parse var ofiles.j1 ofiles.j1 '.' .
     end 
     aa=aa||'<table>'||'0d0a'x
     do mm=1 to words(vartypes)
       atype=strip(word(vartypes,mm))
       if atype<>'S' then iterate
       avar=strip(word(varlist,mm))
       aa=aa||'<tr><td><b>'||avar||'</b>:</td> '||'0d0a'x
       aa=aa||'<td><select onChange="update_opt(this.value,this.form)" name="sel_'||avar||'" size=1>'||'0d0a'x
        aa=aa||'<option selected value="-">Select an options file'||'0d0a'x

       do mm2=1 to ofiles.0
           aa=aa||'<option value="'||ofiles.mm2||'">'ofiles.mm2||'0d0a'x
       end 
       aa=aa||'</select></td>'||'0d0a'x
    end
    aa=aa||'<input type="hidden" name="orig_pickopt" value="'||ofiles.1||'">'||'0d0a'x
    aa=aa||'</table>'||'0d0a'x
    stuff=sre_replacestrg(stuff,'<!-- $REPLACE_4 -->',aa,'ALL')
  end    
end


/* now, find all .POL files in the LIB\POL subdirectory */

aa=''
if pos('P',vartypes)=0 then do
   aa='<b>You did not define any <tt>Poll</tt> variables</b>.'
   stuff=sre_replacestrg(stuff,'<!-- $REPLACE_7 -->',aa,'ALL')
end 
else do

  oo=sysfiletree(cmsdir_pol||'\*.POL','ofiles','FO')

  ofiles2.0=0 ;fdir=''
  if optname.!filedir<>'' then do
      fdir=translate(optname.!filedir,'\','/')
      adir=strip(strip(fdir),,'\')
      oo=sysfiletree(adir||'\POLLS\*.POL','ofiles2','FO')
  end

  if ofiles2.0+ofiles.0=0 then do
     aa='There are <b>no</b> poll-definition files (.POL files) currently available in <tt>'||cmsdir_pol||'</tt>'
     if fdir<>'' then aa=aa||', or in <tt>'||fdir||'\POLLS </tt>'
     stuff=sre_replacestrg(stuff,'<!-- $REPLACE_7 -->',aa,'ALL')
  end
  else do
     do j1=1 to ofiles.0
        ofiles.j1=filespec('n',ofiles.j1)
        parse var ofiles.j1 ofiles.j1 '.' .
     end 
     do j1=1 to ofiles2.0
        ofiles2.j1=filespec('n',ofiles2.j1)
        parse var ofiles2.j1 ofiles2.j1 '.' .
     end 
     aa=aa||'<table>'||'0d0a'x
     do mm=1 to words(vartypes)
       atype=strip(word(vartypes,mm))
       if atype<>'P' then iterate
       avar=strip(word(varlist,mm))
       aa=aa||'<tr><td><b>'||avar||'</b>:</td> '||'0d0a'x
       aa=aa||'<td><select onChange="update_poll(this.value,this.form)" name="pol_'||avar||'" size=1>'||'0d0a'x
       aa=aa||'<option selected value="-">Select a poll-definition file'||'0d0a'x

       do mm2=1 to ofiles.0
           aa=aa||'<option value="'||ofiles.mm2||'">'ofiles.mm2||'0d0a'x
       end 

       aadir2='&fdir=.'
       aadir="fdir='.';" 
       if fdir<>'' then do
          aa=aa||'<option value="-"> - Series specific files-'||'0d0a'x
          aqq="'"
          aadir='fdir='||aqq||translate(adir,'/','\')||aqq||' ; '
          aadir2='&fdir='||translate(adir,'/','\')
          do mm2=1 to ofiles2.0         /* note use of ~ in short name (~ signal filedir) */
             aa=aa||'<option value="~'||ofiles2.mm2||'">'ofiles2.mm2||'0d0a'x
           end 
      end
      aa=aa||'<option value="-"> - - -'||'0d0a'x
      
      aa=aa||'<option value="*">observation-specific'||'0d0a'x

       aa=aa||'</select></td>'||'0d0a'x
    end
    aa=aa||'<input type="hidden" name="orig_pickpol" value="'||ofiles.1||'">'||'0d0a'x
    aa=aa||'</table>'||'0d0a'x
    stuff=sre_replacestrg(stuff,'<!-- $REPLACE_7 -->',aa,'ALL')

    stuff=sre_replacestrg(stuff,'<!-- $REPLACE_11 -->',aadir,'ALL')
    stuff=sre_replacestrg(stuff,'<!-- $REPLACE_12 -->',aadir2,'ALL')


  end    
end




if optname.!FILEDIR<>'' then do
  aa='<p><input type="checkbox" name="CREATE_DIRS" value=1>'
  aa=aa||'Create <TT>UPLOADS</tt>, <tt>COMMENTS</tt>, <tt>POLLS</tt>,'||'0d0a'x
  aa=aa||'and <tt>ARCHIVES</tt> subdirectories under the chosen output directory'||'0d0a'x
  odir=strip(optname.!filedir)
  if pos(':',odir)=0 & abbrev(odir,'\')=0 then do
      odir=cmsdir_files||'\'||odir
  end 

  aa=aa||'(<tt>'||odir||')</tt>' 
  aa=aa||'0d0a'x||'<p><input type="checkbox" name="COPY_FORMS" value=1>'||,
        'Copy sample forms (such as <tt>CMS_CMT.HTM</tt>) to the chosen output directory '
  stuff=sre_replacestrg(stuff,'<!-- $REPLACE_6 -->',aa,'ALL')
end

rthing='var type text/html '||'0d0a'x||stuff
return 1



/************/
/* generate a list of variable names, using VAR1..VAR10 and TYPE1.. TYPE10
  Optname. entries */
make_varlist:

varlist=''
vtypes=''   
do mm=1 to 50           /* max of 50 variables */
   vname0='!VAR'||mm
   if optname.vname0='' then iterate
   vname=translate(space(optname.vname0,0))
   vname1=vname
   tname='!TYPE'||mm
   atype=strip(translate(optname.tname))
   select
      when atype='M' then vtypes=vtypes||' M'
      when atype='N' then vtypes=vtypes||' N'
      when atype='T' then vtypes=vtypes||' T'
      when atype='S' then vtypes=vtypes||' S'
      when atype='C' then vtypes=vtypes||' C'
      when atype='F' then vtypes=vtypes||' F'
      when atype='P' then vtypes=vtypes||' P'

      otherwise vtypes=vtypes||' 1'
   end
   varlist=varlist||' 'vname
   varlist0=varlist0||' 'vname1
end
return strip(varlist)||'0d0a'x||strip(vtypes)


/***************************/
/* generate html form */
gen_form:

nvars=optname.!num_vars ; if nvars='' then nvars=5
ntpls=optname.!num_tpls ; if ntpls='' then ntpls=2

if optname.!new_vars_flag=1 then nvars=word(optname.!new_vars,words(optname.!new_vars))
if optname.!new_tpls_flag=1 then ntpls=word(optname.!new_tpls,words(optname.!new_tpls))

dafile=cmsdir||'\CMS_DEF.HTM'

stuff=sre_file_read(dafile,2,2,1)
if stuff='' then do
 rthing='string Error: unable to find CMS data file: '||dafile
 return 1
end


aa='<input type="hidden" name="num_vars" value='||nvars||'>'||'0d0a'x
aa=aa||'<input type="hidden" name="num_tpls" value='||ntpls||'>'||'0d0a'x
stuff=sre_replacestrg(stuff,'<!-- $REPLACE_1 -->',aa,'ALL')

aa=''
do jj=1 to nvars
  aa=aa||'<li>'||'0d0a'x
  aa=aa||'<input type="text" NAME="var'||jj||'" >'||'0d0a'x
  aa=aa||'<select name="type'||jj||'" size=1>'||'0d0a'x
  aa=aa||'<option selected value="1">String'||'0d0a'x
  aa=aa||'<option value="N">Number'||'0d0a'x
  aa=aa||'<option value="T">Date-Time'||'0d0a'x

  aa=aa||'<option value="M">Lines of text '||'0d0a'x
  aa=aa||'<option value="C">Checkbox'||'0d0a'x
  aa=aa||'<option value="F">File or URL'||'0d0a'x
  aa=aa||'<option value="S">Select List'||'0d0a'x
  aa=aa||'<option value="P">Poll'||'0d0a'x

  aa=aa||'</select>'||'0d0a'x||'0d0a'x
end 
stuff=sre_replacestrg(stuff,'<!-- $REPLACE_2 -->',aa,'ALL')

aa=''
do jj=1 to ntpls
     aa=aa||'    <li><b>&nbsp;&nbsp;&nbsp;&nbsp;  Output file: </b><input type="text" size=50 name="OUTPUT_'||jj||'"><br>'||'0d0a'x
     aa=aa||'    <b>Template file: </b><input type="text" size=50 name="TEMPLATE_'||jj||'"><br>'||'0d0a'x
     aa=aa||'    <em>Description:</em><input type="text" size=50 name="DESC_'||jj||'"><p>'||'0d0a'x||'0d0a'x
end 
stuff=sre_replacestrg(stuff,'<!-- $REPLACE_3 -->',aa,'ALL')


rthing='var type text/html '||'0d0a'x||stuff
return 1


/***************************/
/* help for CMS_DEF form */
help_1:procedure expose tempfile cmsdir
parse  upper arg item

item=strip(item)
call lineout tempfile,"<HTML><HEAD><TITLE>Define CMD dataseries: help</title></head>"
call lineout tempfile,'<body>'
call lineout tempfile,'<font size=-1><a href="javascript:close()">close window</a></font>'
call lineout tempfile,'<h4>Help for: '||item||'</h4>'

select
   when item='STUFF' then do
      call lineout tempfile,'This is STUFF '
   end
   when item='NAME' then do
      call lineout tempfile,'The name of this CMS dataseries (the records file, and the comments file).<br>'
      call lineout tempfile,'This should be less then 20 characters, with no embedded spaces.<br>'
      call lineout tempfile,'You will use the name to choose this dataseries (for adding records, etc.)'
      call lineout tempfile,''
   end
   when item="FILELOCATION" then do
      call lineout tempfile,'The fully qualified file to use for this CMS dataseries (the records file).<br>'
      call lineout tempfile,'The comments file will also be created using a modification of this name.<br>'
      call lineout tempfile,'In general, it is recommended that you leave this field blank,'
      call lineout tempfile,'and CMS will create a name in the CMS\DATA subdirectory.<br>'
   end
   when item="OWNERS" then do
       call lineout tempfile,'If you want to control access to this CMS dataseries,'
       call lineout tempfile,'you can specify which <tt>users</tt> are allowed to access,'
       call lineout tempfile,'modify, and otherwise work with it.<br>'
       call lineout tempfile,'To do this, enter (in a space delimited list) the <tt>usernames</tt>'
       call lineout tempfile,'of everyone allowed to use this CMS dataseries.<p>'
       call lineout tempfile,'<b>Notes:</b><br><ul>' 
       call lineout tempfile,'<li>If you leave this field empty, there will be no access restrictions (other than resource restrictions that you can impose using SREhttp/2)'
       call lineout tempfile,'<li>Enter a <tt> * </tt> to grant  access to all registered users.'
       call lineout tempfile,'<li>The <tt>usernames</tt> are created by SREhttp/2''s username/password'
       call lineout tempfile,'<a target="config" href="/sre2k/srehttp2/demos/configs.htm">utilities</a>.'
       call lineout tempfile,'</ul>'
   end
   when item="OWNERS_COMMENT" then do
       call lineout tempfile,'Similar to OWNERS, this controls who can add comments to records in a CMS dataseries.'
       call lineout tempfile,'<br>Often, you will limit who can add and manipulate records (using OWNERS),'

       call lineout tempfile,'but allow just about anyone to add comments to records.<p>'
       call lineout tempfile,'<b>Notes:</b><br><ul>' 
       call lineout tempfile,'<li>Typically, the list of OWNERS_COMMENT will be more inclusive than the list for OWNERS.'
       call lineout tempfile,'<li>If you leave this field empty, there will be no access restrictions (other than resource restrictions that you can impose using SREhttp/2)'
       call lineout tempfile,'<li>Enter a <tt> * </tt> to grant  access to all registered users.'
       call lineout tempfile,'<li>The <tt>usernames</tt> are created by SREhttp/2''s username/password'
       call lineout tempfile,'<a target="config" href="/sre2k/srehttp2/demos/configs.htm">utilities</a>.'
       call lineout tempfile,'</ul>'
   end

   when item="VARIABLES" then do
       call lineout tempfile,'Define the names, and the types, of the variables that your '
       call lineout tempfile,'CMS dataseries will contain. <em>Some of these can be designated as being <a href="#special">sortable</a></em><br>'
       call lineout tempfile,'<br>To define a variable, give it a (case-insensitive) name (with <b>no</b> embedded spaces)'
       call lineout tempfile,'and choose the variable <tt>type</tt>.'
       call lineout tempfile,'<p>There are several variable <tt>types</tt>. The <tt>type</tt> information is used for several purposes; including'
       call lineout tempfile,'choosing the kind of input used in the add-record form, '
       call lineout tempfile,' determining how to store (or upload) the data, and determining what '
       call lineout tempfile,'manipulations are allowed to the variable.'
       call lineout tempfile,'<p>The types are:<dl>'
       call lineout tempfile,'<dt><b>An Abstract</b>'
       call lineout tempfile,'<dd>  a 50 character or less abstract, that is used for informational'
       call lineout tempfile,'  purposes (i.e.; when displaying lists of dataseries to choose from)'


       call lineout tempfile,'<dt><b>String</b><dd> A text string, without CRLFs. <em>You can sort on <b>String</b> variables.</em>' 

       call lineout tempfile,'<dt><b>Number</b><dd> an integer or real number (an empty field is treated as 0). <em>You can sort on <b>Number</b> variables.</em>'

       call lineout tempfile,'<dt><b>Time</b><dd>a date and (optionally) a time. This will be converted into an absolute format (similar to the format used to identify records)' 

       call lineout tempfile,'<dt><b>SELECT list</b><dd> A selection list.<em>You can sort on <b>Select list</b> variables</em>. <br>'
       call lineout tempfile,'You will be asked to choose from one of the currently defined <tt>options</tt> files.'
       call lineout tempfile,'These files contain lists of options; the options defined in the chosen file'
       call lineout tempfile,'will be used to populate the SELECT list.<br>'
       call lineout tempfile,'If you want, you can <a target="opts" href="/cms/cms_opts?">create your own</a> <tt>options</tt> file (and then use it)!'

       call lineout tempfile,'<dt><b>Poll</b><dd> A  poll definition.<em><b>Poll</b> variables must be sortable!</em> <br>'
       call lineout tempfile,'You will be asked to choose from one of the currently defined <tt>poll-definition</tt> files.'
       call lineout tempfile,'A poll-definition file contains the question, and a list of answers; these will be used to populate '
       call lineout tempfile,'a questionaire box.<br>'
       call lineout tempfile,'If you want, you can <a target="opts" href="/cms/cms_poll?">create your own</a> <tt>poll-definition</tt> file (and then use it)!'


       call lineout tempfile,'<dt><b>Lines of Text</b><dd> Multiple lines of text'

       call lineout tempfile,'<dt><b>Checkbox</b><dd> A checkbox -- when checked, a value of 1 is stored. '
       call lineout tempfile,'          When not checked, a value of &nbsp;''&nbsp; ''&nbsp; is stored'

       call lineout tempfile,'<dt><b>File or URL</b><dd> Allows the user to upload the contents of a file (assuming she is '
       call lineout tempfile,'    using a reasonably modern browser); or download the contents of a URL.<p>'
       call lineout tempfile,'   If you specify any <b>File or URL</b> types, you should also specify '
       call lineout tempfile,'    the <u>file storage directory</u>.'
       call lineout tempfile,'      This directory is where these uploaded files (and URLs) will be stored.<p>'
       call lineout tempfile,'      Note that when CMS generates output, it will use the contents of the file (or URL),'
       call lineout tempfile,'      not the file name (or URL).  Furthermore, this file (or URL) can be of any mimetype, '
       call lineout tempfile,'      it need not be a text file.'
       call lineout tempfile,'      <br>To upload a file, use the <tt>browse</tt> (or similar) button, that your web-browser displays, to choose a file'
       call lineout tempfile,'<br>To download (to this server) a URL, enter the full URL (you <b>must</b> start with <tt>http://</tt>).'

       call lineout tempfile,'</dl>'


       call lineout tempfile,'<a name="special"><h4>On sorting</h4></a>'
       call lineout tempfile,''
       call lineout tempfile,'Using the <tt>&lt;?</tt> Sort &gt; CMS option, you can sort a CMS dataseries'
       call lineout tempfile,'on one of the <em>sortable</em> variables (by default, the sort order is time of entry).'
       call lineout tempfile,'More precisely, you can sort on a <b>String</b>, <b>Number</b>, and <b>Select List</b> variable'
       call lineout tempfile,'that you designate to be a <em>sortable</em> variable (<tt>designation of sortable variables is done in step 2 of CMS dataseries definition</tt>).<p>'
       call lineout tempfile,'<p><b>Note:</b>There is <b>no</b> downside to designating a <em> sortable variable</em>. However, since it does '
       call lineout tempfile,'require limited resources, only 5 such designations are allowed.'

   end

   when item="DESCRIPTION" then do
       call lineout tempfile,'A short sentence that describes this dataseries.'
       call lineout tempfile,'This description will be used for informational purposes '
       call lineout tempfile,'in different CMS modules. In addition, it can be written to'
       call lineout tempfile,'the output files.'
   end

   when item="COMMENT_VARIABLES" then do
       call lineout tempfile,'The comment-variables are used when adding comments to a record -- '
       call lineout tempfile,'their values will be requested from users, and you can specify (using standard CMS elements) how to display the values for these variables.'
       call lineout tempfile,'<br><b>Hint:</b>Variable names that start with <tt>_</tt> are stored <em>verbatim</em>(crlfs are retained)'
   end

   when item="COMMENT" then do
       call lineout tempfile,'An arbitraily long comment concerning this dataseries.<br>'
       call lineout tempfile,'This comment will be stored in the CMS dataseries file.<br>'
       call lineout tempfile,'It is <b>not</b> used anywhere else.'
   end
   when item="OUTPUT" then do
       call lineout tempfile,'<b>Template</b> files are used to generate <b>output</b> files.<p>'
       call lineout tempfile,'<tt>Template</tt> files are simply HTML documents that contain special <em>CMS elements</em> '
       call lineout tempfile,'that contain <em>CMS keywords</em>. These give you access to a number of CMS '
       call lineout tempfile,'functions.  In particular, you can use these <em>keywords</em> to '
       call lineout tempfile,'output the values of variables stored in a CMS dataseries. '
       call lineout tempfile,'And you can easily do this  REPEATedly -- for each record in' 
       call lineout tempfile,'a dataseries.<p>'
       call lineout tempfile,'You can specify several template files, and the <tt>output</tt> file(s)'
       call lineout tempfile,'to write to. You can also enter a description, which is used for'
       call lineout tempfile,'informational purposes.'
       call lineout tempfile,'<h4>Notes:</h4>'
       call lineout tempfile,'<ul><li>By default (if you do not include path information), <b>template</b> &amp; <b>output</b> files are assumed to be in '
       call lineout tempfile,' the <u>output file directory</u> (that you can specify below).'
       call lineout tempfile,' If you do not specify an <u>output file directory</u>, the CMS\FILES directory (<tt>'||cmsdir||'\FILES</tt>) will be used.'
       call lineout tempfile,'<li>You can use <u>Modify a CMS dataseries template definitions</U> '
       call lineout tempfile,'to remove and add template definitions.'
       call lineout tempfile,'</ul>'
       call lineout tempfile,''

   end
   when item="UPLOAD_DIR" then do
       call lineout tempfile,'The upload directory is used to store the contents of uploaded files'
       call lineout tempfile,'(or downloaded URLS). If you do not specify a <em>fully qualified directory</em>,'
       if force_uploadir=1 then
          call lineout tempfile,'an error will occur, and you will be asked to enter one.'
        else
          call lineout tempfile,'the CMS\UPLOADS subdirectory will be used (<tt>'||cmsdir||'\UPLOADS</tt>).'
   end

   when item="FILE_DIR" then do
       call lineout tempfile,'The file directory is used to store output generated by CMS.'
       call lineout tempfile,'<p>It is also used as the default directory for template files (template files specifed with no path are assumed to be in the output-file directory)'
       call lineout tempfile,' <p>If you do not specify a <em>fully qualified directory</em>,'
        call lineout tempfile,'the CMS\FILES subdirectory will be used (<tt>'||cmsdir||'\FILES</tt>).'
   end

   otherwise do
      call lineout tempfile,'No help available.'
   end
end
      call lineout tempfile,''
call lineout tempfile,'</body></html>'
call lineout tempfile
return 'file type text/html name 'tempfile



/******************/
/* access allowed? */
sec_check:
ss=sre_value('SECURITY_LEVEL',,'SRESYS')
if ss=0 then do
  foo=sre_command('String Sorry. Remote access to configuration utilities not permitted.',,idinfo)
  return foo
end
if ss=1 then do
    myaddr=sre_extract("clientaddr",idinfo)
    moreaddr=sre_value('SERVERADDR_INHOUSE',,'SRESYS')
    who=sre_extract("serveraddr",idinfo)||' '||moreaddr
    if wordpos(myaddr,who)=0 then do
      sfoo=sre_command('String External access to configuration utilities is not permitted' ,,idinfo)
      return sfoo
   end
end

/* else, normal superuser checking */

if wordpos('CMS_DEF',translate(privset))>0 then return 0     
if wordpos('SUPERUSER',translate(privset))>0 then return 0   

/* not enough privs */
if aiter='' then return 'PRIVS Defining a CMS dataseries requires superuser privileges '
return 'AUTH Defining a CMS dataseries requires that you have superuser privileges '



/* ------------- */
sysmkdir2:procedure
parse arg adir
adir=strip(adir,'t','\')
ff=sysmkdir(adir)
if ff=0 then return ff

/* make the tree */
f2=adir'\'
dd=filespec('d',f2)
pp=filespec('p',f2)
if pp='\' | pp='' then return -1

pp2=strip(translate(pp,' ','\'))

do mm=1 to words(pp2)
   a1=subword(pp2,1,mm)
   a1=translate(a1,'\',' ')
   dd2=dd'\'a1
   hoo=sysmkdir(dd2)
   if hoo=0 then call sre_pmrintf('CMS: creating: 'dd2 )
end /* do */

return hoo

