/* The SREhttp/2 content management system (CMS) program 

   Modify template definitions
 
*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_files=cmsdir||'\FILES'
okk=dosisdir(cmsdir_files)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_files
end


cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'
root=left(uri,jj)


parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'

optname.=''
m=0
if list='' then list='action=1'
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(sre_packur(avar)))
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/

if optname.!action='1' then do   /* find the list of dataseries defined for this host*/
  call show_datafiles
  foo=result
  return foo
end

if optname.!action='2' then do   /* show current definitions */
  call show_defs
  foo=result
  return foo
end


if optname.!action='3' then do   /* modify fields in the record*/
  call change_defs
  foo=result
  return foo
end

if optname.!action='5' then do   /* save the modified record */
  call view_file
  foo=result
  return foo
end

if optname.!action='6' then do   /* save the modified record */
  call view_tplfile
  foo=result
  return foo
end

return 'string no such cms_def2.cmd action: 'optname.!action

/*******************/
/* pick one of the current cms datafiles (for this host) */
show_datafiles:

call lineout tempfile,'<html><head><title>CMS: Choose a CMS datafile</title> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||root||'cms_def3.cmd?action=1">Modify dataseries directories</a> || '
call lineout tempfile,'<a href="'||root||'cms_redo.cmd?action=1">Restructure this dataseries</a>  '

call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Select a CMS dataseries</h3><em> with template definitions to be modified...</em><p> '

ahost=host_nickname

/* look for files, in cmsDIR_index dir, of the form: ahost_nnnn.DEF
   These .DEF files define "CMS indices" --- nnnn is a number from 0 to 9999
*/

call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="2">'
ff=cmsdir_index||'\'||ahost||'*.DEF'
goo=sysfiletree(ff,'ff2','FO')

call lineout tempfile,'For host: <Tt>'||ahost||'</tt>, the following CMS dataseries have been created'

call lineout tempfile,'<table border=1>'
do jj=1 to ff2.0
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<tr><th align="left">' 
   call lineout tempfile,'<INPUT TYPE="RADIO"  name="deffile" value="'||daname||'">'
   gob=strip(stuff.!series)||'</th>'
   call lineout tempfile,gob||'<td> <em>&nbsp;'||stuff.!desc||'</em></td>'
end

call lineout tempfile,'</table>'


call lineout tempfile,''
call lineout tempfile,'<p><INPUT name="sub2" TYPE="submit" VALUE="Choose a CMS dataseries">'
call lineout tempfile,'</form>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* show template definitions */
show_defs:

call lineout tempfile,'<html><head><title>CMS: Modify template definitions</title> '

call lineout tempfile,'</head>'

call lineout tempfile,'<font size=-1>'
if optname.!CLOSEIT=1 then 
   call lineout tempfile,'<a href="javascript:close()">Close window</a> || '
else
  call lineout tempfile,'<a href="javascript:history.go(-1)">Back</a> || '
call lineout tempfile,' <a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'
call lineout tempfile,'</font>'

call lineout tempfile,'<h3>Modify a template definition for a CMS dataseries</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

ddir=stuff.!FILEDIR
if ddir='' then ddir=cmsdir_files
ddir=strip(ddir,,'\')||'\'

call lineout tempfile,'<ul><li><b>Series: </b><tt>'||stuff.!series||'</tt>'
call lineout tempfile,'<li><b>Description: </b><tt>'||stuff.!desc||'</tt>'
call lineout tempfile,'<li><b>Default output directory:</b> <tt>'||ddir||'</tt>'
call lineout tempfile,'</ul>'


call lineout tempfile,'</ul>'


tt=stuff.!TEMPLATE
call lineout tempfile,'<form name="stp2" method="POST" action="'||thisaddon||'">'
call lineout tempfile,'<input type="hidden" name="action" value="3">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'

call lineout tempfile,'<em>Click checkbox to remove a <tt>template definition</tt></em>'
call lineout tempfile,'<table>'
call lineout tempfile,'<tr><th>Remove</th><th>Output<br>file</th><th>Template<br>file</th><th>Description</th>'

do until tt=''
   parse var tt aline '0d0a'x tt
   parse var aline aout atpl0 ',' adesc

   atpl0=strip(atpl0)
   atpl=atpl0
   if pos(':',atpl0)=0  & abbrev(atpl0,'\')=0 then do
      atpl=ddir||atpl0
   end 


   atplsize=stream(atpl,'c','query size')
   if atplsize='' | atplsize=0 then  do
        atplsize='no file'
       dtpl='<u>'||atpl0||'</u>'
   end
   else do
      atplsize=atplsize||' bytes'
       dtpl='<a target="viewer" href="'||thisaddon||'?action=6&deffile='||daindx||'&tplfile='||atpl0||'">'||atpl0||'</a>'
   end
  
   call lineout tempfile,'<TR><td><input type="checkbox" name="REMOVE_THIS" value="'||atpl0||'"></td>'
   call lineout tempfile,'<th>'||aout||'</th><td>'||dtpl||'<br><tt>'||atplsize||'</tt></td><td><em>'||adesc||'</em></td>'
end 
call lineout tempfile,'<TR><td>&nbsp;</td>'
call lineout tempfile,'<TR><td><em>Add a template<br> definition</em></td>'
call lineout tempfile,'<td colspan=2><ul>'
call lineout tempfile,' <li>   <b>&nbsp;&nbsp;&nbsp;&nbsp;  Output file: </b><input type="text" size=50 name="OUTPUT"><br>'||'0d0a'x
call lineout tempfile,' <li>   <b>Template file: </b><input type="text" size=50 name="TEMPLATE"><br>'||'0d0a'x
call lineout tempfile,'  <li>  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<em>Description:&nbsp; </em> <input type="text" size=50 name="DESC"><p>'||'0d0a'x||'0d0a'x
call lineout tempfile,'</ul></td>'

call lineout tempfile,'</table>'

call lineout tempfile,'<input type="submit" value="Make changes to template definitions">'
call lineout tempfile,'<input type="reset" >'

call lineout tempfile,'</form>'

signal gooble

gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)

ith=0
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)

   ith=ith+1
   stuff0.ith=aline

   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname0=strip(translate(aname))
   aname='!'||aname0
   if stuff.aname='' then
      stuff.aname=strip(avalue)
   else
      stuff.aname=stuff.aname||'0d0a'x||strip(avalue)
   stuff.0=stuff.0||' '||aname0
end

stuff0.0=ith
return 1


/*******************/
/* change definitions */
change_defs:

call lineout tempfile,'<html><head><title>CMS:Change template definitions </title> '


call lineout tempfile,'<font size=-1>'
call lineout tempfile,'<a href="javascript:history.go(-1)">Back</a></font> || '
call lineout tempfile,'<a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Changing template definitions</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff

/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

call lineout tempfile,'<em>For series '||stuff.!series||'</em><p>'


rthis=translate(optname.!!REMOVE_THIS)

tt=stuff.!TEMPLATE
ntpls=0
do until tt=''
   parse var tt aline '0d0a'x tt
   parse upper var aline aout atpl0 ',' adesc
   atpl0=strip(atpl0)
   if wordpos(atpl0,rthis)=0 then do    /* keep as is */
        ntpls=ntpls+1
        dotpls.ntpls=aline
        iterate
   end
end                     /* else, don't include it */

/* now the new one */
if optname.!OUTPUT<>'' then do
    ntpls=ntpls+1
    dotpls.ntpls=optname.!output||' '||optname.!template||','||optname.!DESC
end /* do */

new1=''
do kk=1 to stuff0.0
   aline=stuff0.kk
   aline0=strip(translate(aline))
   if abbrev(aline0,'TEMPLATE')=1 then iterate
   new1=new1||aline||'0d0a'x
end
do jj=1 to ntpls   
   new1=new1||'Template: '||dotpls.jj||'0d0a'x
end
arf=sre_append_file(ff,new1,2,,1)
if arf>0 then do
    call lineout tempfile,'<p>Index file <tt>'ff'</tt> saved ('||arf||'bytes)'
end
else do
   call lineout tempfile,'<p><B>Error.</b> Unable to save index file 'ff
end 

gooble:         /* jump here on error */
a=sre_cache_data(stuff.!series,'CLOSE')

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode




/*******************/
/* view a stored file */
view_file:


daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'<html><head><title>CMS: View a stored file </title> '
   call lineout tempfile,'Error: could not find CMS dataseries''s index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

ff=strip(stuff.!UPLOADDIR,,'\')||'\'||optname.!file
if stream(ff,'c','query exists')='' then do
   call lineout tempfile,'<html><head><title>CMS: View a stored file </title> '
   call lineout tempfile,' Error: for 'optname.!ofile'; could not find stored file '||optname.!file
   signal gooble
end

dtype=optname.!ctype
if dtype='' | optname.!astext=1 then dtype='text/plain'
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF TYPE '||dtype||' NAME 'ff,,idinfo)
return rcode


gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/*******************/
/* view a stored tpl file */
view_tplfile:

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'<html><head><title>CMS: Viewing a template file</title></head> '
   call lineout tempfile,'Error: could not find CMS-dataseries index file: '||ff
   signal gooble
end

chlist=strip(translate(sre_packur(optname.!!tplfile)))

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

thefile=''
do until stuff.!TEMPLATE = ''
   parse var stuff.!TEMPLATE aline '0d0a'x stuff.!template
   parse upper var aline incfile tplfile ',' .
   tplfile=strip(tplfile)
   if tplfile=chlist then do
      thefile=tplfile
      leave
   end
end

if thefile='' then do
   call lineout tempfile,'<html><head><title>CMS: Viewing a template file</title></head> '
   call lineout tempfile,'Error: template file not known: '||chlist
   signal gooble
end

/* if no path info, check in FILEDIR path (if specified). If no FILEDIR path, use CMS\FILES
   directory
*/
if abbrev(chlist,'\')=0 & pos(':',chlist)=0 then do     /* relative filename */
   if stuff.!FILEDIR<>'' then do
        defdir=stuff.!FILEDIR
   end 
   else do
         defdir=cmsdir_files
   end
   defdir=strip(defdir,,'\')||'\'
   chlist=defdir||chlist
end

if stream(chlist,'c','query exists')='' then do
   call lineout tempfile,'<html><head><title>CMS: Viewing a template file</title></head> '
   call lineout tempfile,'Error: template file does not exist: '||chlist
   signal gooble
end

dtype='text/html'

rstuff=sre_read_file(chlist,2,2,1)
rstuff=sre_html_encode(rstuff)
aa='<html><head><title>TPL file display</title></head><body>'||'0d0a'x

aa=aa||'<body>'||'0d0a'x
aa=aa||'<font size=-1>'||'0d0a'x
aa=aa||'<a href="javascript:close()">Close window</a></font><br>'||'0d0a'x
aa=aa||'<h4>Contents of '||chlist||'</h4>'||'0d0a'x
aa=aa||'<pre>'||rstuff||'</pre>'
aa=aa||'</body></html>'
rcode=sre_command('VAR ETAG_AUTO EXPIRES 30s NOCACHE NOIF TYPE  '||dtype,aa,idinfo)
return rcode

gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode






/******************************/
/* check access rights. Return 1 if okay. Otherwise, return a string to be
  sent back to SREhttp/2 (an authorization response string) */
check_access:procedure expose privset host_nickname idinfo uri aiter
parse  upper arg owners,series

if owners='' then return 1      /* no owners listed, means open access */

pneeded=space(translate('CMS:'||strip(series)),0)
if wordpos(pneeded,translate(privset))>0 then return 1          /* explicit privilege for this */

/* see if a cookie exists */
look_cook='CMS_'||series
aa=sreh2_get_cookie(lookcook)
if aa<>''  then return 1

if aiter=''  then do            /* first time, so recheck privs */
  return 'PRIVS   Access to this dataseries is restricted to specific users '
end 

/* otherwise, see if a username has been sent  */
username=''
authh=sre_reqfield('Authorization')
if authh<>'' then username=sre_extract_username(authh) 
if username='' then do             /* no username available */
  return  'AUTH  Access to this dataseries is restricted to specific users '
end

/* is this one of the OWNERS? */
if pos('*',owners)=0 then do            /* * means "any user" */
if wordpos(translate(username),translate(owners))=0 then do
   return 'AUTH  Access to this dataseries is restricted to specific users '
end
end

/* One of the OWNERS, now check password */
stuff=sreh2_get_userinfo(authh,host_nickname,idinfo)
if stuff='' then do
  return 'AUTH   Access to this dataseries is restricted to specific users. Please enter a new username/password.'
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
pp=left(thisaddon,jj)

foo=sreh2_set_cookie(lookcook,1,'30m',pp,,1)

/* if here, legit user.  Record a cookie */
return 1




/************/
/* convert from CMS id  (JS time stamp) to "N" time stamp */
fig_time:procedure
parse arg atime0


parse var atime0 adate1 '.' atime
adate=adate1+726467
atime='0.'||atime

dd=dateconv(adate,'B','N')

/* else, convert to hr min second */
zz=digits()
numeric digits 16
secs=trunc(atime*86400)
tmp0=secs/3600
parse var tmp0 hour '.' tmp1 ; if tmp1='' then tmp1=0
hour=right(hour,2,'0')
tmp1='0.'||tmp1
tmp2=tmp1*60
parse var tmp2 minute '.'tmp3 ; ; if tmp3='' then tmp3=0
minute=right(minute,2,'0')
tmp3='0.'||tmp3
tmp3=tmp3*60 ; parse var tmp3 second '.' .
second=right(second,2,'0')
numeric digits zz

dd=dd||' '||hour||':'||minute||':'||second
return dd


