/* The SREhttp/2 content management system (CMS) program 

   Modify template definitions

*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_files=cmsdir||'\FILES'
okk=dosisdir(cmsdir_files)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_files
end

cmsdir_uploads=cmsdir||'\UPLOADS'
okk=dosisdir(cmsdir_uploads)
if okk=0 then do
  return 'string unable to find CMS upload files directory: 'cmsdir_uploads
end

cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'
root=left(uri,jj)

optname.=''
m=0
if list='' then list='action=1'
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(sre_packur(avar)))
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/

if optname.!action='1' then do   /* find the list of dataseries defined for this host*/
  call show_datafiles
  foo=result
  return foo
end

if optname.!action='2' then do   /* show current definitions */
  call show_defs
  foo=result
  return foo
end


if optname.!action='3' then do   /* modify fields in the record*/
  call change_defs
  foo=result
  return foo
end

return 'string no such cms_def2.cmd action: 'optname.!action

/*******************/
/* pick one of the current cms datafiles (for this host) */
show_datafiles:

call lineout tempfile,'<html><head><title>CMS: Choose a CMS datafile</title> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||root||'cms_def2.cmd?action=1">Modify dataseries templates</a> ||  '
call lineout tempfile,'<a href="'||root||'cms_redo.cmd?action=1">Restructure this dataseries</a>  '
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Select a CMS dataseries</h3><em> with directory definitions to modify ...</em><p> '

ahost=host_nickname

/* look for files, in cmsDIR_index dir, of the form: ahost_nnnn.DEF
   These .DEF files define "CMS indices" --- nnnn is a number from 0 to 9999
*/

call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="2">'
ff=cmsdir_index||'\'||ahost||'*.DEF'
goo=sysfiletree(ff,'ff2','FO')

call lineout tempfile,'For host: <Tt>'||ahost||'</tt>, the following CMS dataseries have been created'

call lineout tempfile,'<table border=1>'
do jj=1 to ff2.0
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<tr><th align="left">' 
   call lineout tempfile,'<INPUT TYPE="RADIO"  name="deffile" value="'||daname||'">'
   gob=strip(stuff.!series)||'</th>'
   call lineout tempfile,gob||'<td> <em>&nbsp;'||stuff.!desc||'</em></td>'
end

call lineout tempfile,'</table>'


call lineout tempfile,''
call lineout tempfile,'<p><INPUT name="sub2" TYPE="submit" VALUE="Choose a CMS dataseries">'
call lineout tempfile,'</form>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* show template definitions */
show_defs:

call lineout tempfile,'<html><head><title>CMS: Modify directory definitions</title> '

call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1>'
if optname.!CLOSEIT=1 then 
  call lineout tempfile,'<a href="javascript:close()">Close window</a> || '
else
  call lineout tempfile,'<a href="javascript:history.go(-1)">Back</a> || '
call lineout tempfile,' <a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'
call lineout tempfile,'</font>'

call lineout tempfile,'<h3>Modify directory definitions for a CMS dataseries</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

call lineout tempfile,'<ul><li><b>Series: </b><tt>'||stuff.!series||'</tt>'
call lineout tempfile,'<li><b>Description: </b><tt>'||stuff.!desc||'</tt>'

call lineout tempfile,'<li>The default <em>working file</em> directory is: <Tt>'||cmsdir_files||'</tt>'
call lineout tempfile,'<li>The default <em>uploaded-file-storage</em> directory is: <Tt>'||cmsdir_uploads||'</tt>'
call lineout tempfile,'</ul>'


call lineout tempfile,'<form name="stp2" method="POST" action="'||thisaddon||'">'
call lineout tempfile,'<input type="hidden" name="action" value="3">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'

call lineout tempfile,'<table><tr bgcolor="#cfcfdd"><th>Uploaded<br>files<br>directory</th>'
udir=stuff.!UPLOADDIR
udiruse=udir
if udir='' then udir='none chosen, using 'cmsdir_uploads

call lineout tempfile,'<td>Current :<tt>'||udir||'</tt>'
call lineout tempfile,'<p>Change to: <input type="text" name="NEW_UPLOADS" value="'||udiruse||'" size=50><br>'
if udiruse='' then call lineout tempfile,'<em>leave blank to continue to use the default uploaded-file-storage directory</em>'

call lineout tempfile,'<tr bgcolor="#dddddd"><th>Working<br>&amp; output<br>files<br>directory</th>'
udir=stuff.!FILEDIR
udiruse=udir
if udir='' then udir='none chosen, using 'cmsdir_files
call lineout tempfile,'<td>Current :<tt>'||udir||'</tt>'

call lineout tempfile,'<p>Change to: <input type="text" name="NEW_FILES" value="'||udiruse||'" size=50><br>'
if udiruse='' then call lineout tempfile,'<em>leave blank to continue to use the default uploaded-file-storage directory</em>'

call lineout tempfile,'</table>'

call lineout tempfile,'<br><input type="submit" value="Modify directories">'
call lineout tempfile,'<input type="Reset" >'

call lineout tempfile,'</form>'

signal gooble

gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)

ith=0
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)

   ith=ith+1
   stuff0.ith=aline

   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname0=strip(translate(aname))
   aname='!'||aname0
   if stuff.aname='' then
      stuff.aname=strip(avalue)
   else
      stuff.aname=stuff.aname||'0d0a'x||strip(avalue)
   stuff.0=stuff.0||' '||aname0
end

stuff0.0=ith
return 1


/*******************/
/* change definitions */
change_defs:
call lineout tempfile,'<html><head><title>CMS:Change directory specifications </title> '

call lineout tempfile,'<font size=-1>'
call lineout tempfile,'<a href="javascript:history.go(-1)">Back</a></font> || '
call lineout tempfile,'<a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Changing directory definitions</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end
call read_deffile ff

/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode
call lineout tempfile,'<em>For series '||stuff.!series||'</em><p>'
call lineout tempfile,'Modifying the UpLoadDIR and FileDIR parameters.'

newuploads=optname.!new_uploads
if newuploads<>'' then do
   newuploads=strip(newuploads,,'\')
   if right(newuploads,1)=':' then newuploads=newuploads||'\'
   if dosisdir(newuploads)=0 then do
        call lineout tempfile,'<br><B>Error</b>: no such upload directory: <tt>'||newuploads||'</tt>'
        signal gooble
   end
end

newfiles=optname.!new_files
if newfiles<>'' then do
   newfiles=strip(newfiles,,'\')
   if right(newfiles,1)=':' then newfiles=newfiles||'\'
   if dosisdir(newfiles)=0 then do
        call lineout tempfile,'<br><B>Error</b>: no such working/output directory: <tt>'||newfiles||'</tt>'
        signal gooble
   end
end

new1=''
do kk=1 to stuff0.0
   aline=stuff0.kk
   aline0=strip(translate(aline))
   if abbrev(aline0,'FILEDIR')=1 then iterate
   if abbrev(aline0,'UPLOADDIR')=1 then iterate
   new1=new1||aline||'0d0a'x
end


call lineout tempfile,'<ul>'

/** upload dir */

if newuploads <>''  then 
   new1=new1||'UploadDIR: '||newuploads||'0d0a'x

nn=newuploads
if nn='' then nn='using default of '||cmsdir_uploads
call lineout tempfile,'<li>UploadDIR: <tt>'||nn||'</tt>'

if newuploads<>stuff.!uploaddir then do
   farf=stuff.!uploaddir
   if farf='' then farf=cmsdir_uploads
   tt=strip(farf,,'\')||'\*.*'

   arf=sysfiletree(tt,'fils','FS')

   call lineout tempfile,'<br><b>Note:</b> There are '||fils.0||' files in the old upload directory (<tt>'||stuff.!uploaddir||'</tt>)<br>'
end 

/** filedir */

if newfiles <>''  then 
   new1=new1||'FileDIR: '||newfiles||'0d0a'x

nn=newfiles
if nn='' then nn='using default of '||cmsdir_files
call lineout tempfile,'<li>FileDIR: <tt>'||nn||'</tt>'

if newfiles<>stuff.!filedir then do
   farf=stuff.!filedir
   if farf='' then farf=cmsdir_files
   tt=strip(farf,,'\')||'\*.*'
   arf=sysfiletree(tt,'fils','FS')
   call lineout tempfile,'<br><b>Note:</b> There are '||fils.0||' files in the old working/output files directory (<tt>'||stuff.!filedir||'</tt>)<br>'
end 


call lineout tempfile,'</ul>'

arf=sre_append_file(ff,new1,2,,1)
if arf>0 then do
    call lineout tempfile,'<p>Index file <tt>'ff'</tt> saved ('||arf||'bytes)'
end
else do
   call lineout tempfile,'<p><B>Error.</b> Unable to save index file 'ff
end 

gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/******************************/
/* check access rights. Return 1 if okay. Otherwise, return a string to be
  sent back to SREhttp/2 (an authorization response string) */
check_access:procedure expose privset host_nickname idinfo uri aiter
parse  upper arg owners,series

if owners='' then return 1      /* no owners listed, means open access */

pneeded=space(translate('CMS:'||strip(series)),0)
if wordpos(pneeded,translate(privset))>0 then return 1          /* explicit privilege for this */

/* see if a cookie exists */
look_cook='CMS_'||series
aa=sreh2_get_cookie(lookcook)
if aa<>''  then return 1

if aiter=''  then do            /* first time, so recheck privs */
  return 'PRIVS   Access to this dataseries is restricted to specific users '
end 

/* otherwise, see if a username has been sent  */
username=''
authh=sre_reqfield('Authorization')
if authh<>'' then username=sre_extract_username(authh) 
if username='' then do             /* no username available */
  return  'AUTH  Access to this dataseries is restricted to specific users '
end

/* is this one of the OWNERS? */
if pos('*',owners)=0 then do            /* * means "any user" */
if wordpos(translate(username),translate(owners))=0 then do
   return 'AUTH  Access to this dataseries is restricted to specific users '
end
end

/* One of the OWNERS, now check password */
stuff=sreh2_get_userinfo(authh,host_nickname,idinfo)
if stuff='' then do
  return 'AUTH   Access to this dataseries is restricted to specific users. Please enter a new username/password.'
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
pp=left(thisaddon,jj)

foo=sreh2_set_cookie(lookcook,1,'30m',pp,,1)

/* if here, legit user.  Record a cookie */
return 1




/************/
/* convert from CMS id  (JS time stamp) to "N" time stamp */
fig_time:procedure
parse arg atime0


parse var atime0 adate1 '.' atime
adate=adate1+726467
atime='0.'||atime

dd=dateconv(adate,'B','N')

/* else, convert to hr min second */
zz=digits()
numeric digits 16
secs=trunc(atime*86400)
tmp0=secs/3600
parse var tmp0 hour '.' tmp1 ; if tmp1='' then tmp1=0
hour=right(hour,2,'0')
tmp1='0.'||tmp1
tmp2=tmp1*60
parse var tmp2 minute '.'tmp3 ; ; if tmp3='' then tmp3=0
minute=right(minute,2,'0')
tmp3='0.'||tmp3
tmp3=tmp3*60 ; parse var tmp3 second '.' .
second=right(second,2,'0')
numeric digits zz

dd=dd||' '||hour||':'||minute||':'||second
return dd


