/* Srehttp/2 Daemon: the handling CMS scheduler


*/

/*******************  USER CONFIGURABLE PARAMETERS ******************/

max_semwait=2000                        /* in 1/1000th seconds */


/******/

parse arg thisid,cmsdir

signal on error name iserror
signal on syntax name iserror
signal on novalue name iserror

parse upper arg dmnid,maxfiles,def_duration,sport
foo=sre_pmprintf('| SREhttp/2 CMS Scheduler: daemon id = 'dmnid)

datestamp=''
mypid=dospid()

nowtime=sre_gmt(0,,'JS',0)
starttime=nowtime
starttime_display=fig_time(nowtime)

next_time=9999999.              /* large number means "no next time */

doit=''
doit_history=starttime_display||': CMS Scheduler started '

foo=sre_flag_open('SRE_CMS_BUSY',0,mypid)
if abbrev(foo,'error')=1 then do
   call sre_pmprintf('CMS_DMN error opening flag: 'foo
   exit
end 

/* Initialization now done == start waiting for requests for user info */

/* ============ TOP OF FOREVER LOOP ========= */

bakme:
if sre_flag_set('#SHUTDOWN')=1 then do  /* shutdown all of sre2003 */
    foo=sre_dmn_command(dmnid,'DISCONNECT')
    call pmprintf('SREhttp/2 CMS Scheduler daemon exiting ')
    exit
end

wow=sre_dmn_listen(dmnid,max_semwait)      

if wow='' then do
  call check_doit 'empty'
  signal bakme
end

nowtime=sre_gmt(0,,'JS',0)
nowtime_disp=fig_time(nowtime)

   
if wow='EXIT' then do    
   call pmprintf("CMS Scheduler is exiting")
   exit 0
end 
 
if abbrev(wow,'error')=1 then do
   foo=sre_pmprintf(' SREhttp/2 CMS Scheduler ERROR: '||wow)
   exit 1
end
parse var wow astamp','isit0
ISIT=STRIP(ISIT0)

if astamp='EXIT' then do    
   call pmprintf("CMS Scheduler is exiting")
   exit 0
end 


 /* die command? */
if abbrev(isit,'!DIE')=1 then do 
   call pmprintf("CMS Scheduler is now exiting")
   exit 0
end 

foo='0d0a'x
parse var isit0 action  '0d0a'x alist

action=strip(translate(action))


select
  when action='ADD' then do
    call add_schedule    
    dog1=result
  end 
  when action='SHOW' then do
     dog1=doit
  end 
  when action='HISTORY' then do
     dog1=doit_history
  end 
  when wow='EXIT' then do    
     call pmprintf("The CMS Scheduler is exiting")
     exit 0
  end 
  when action='REMOVE' then do
     call remove_schedule
     dog1=result
  end 
  otherwise do
     dog1='Warning: Unknown action 'action
  end
end
foo=sre_dmn_respond(astamp,dog1)

call check_doit 'request'

signal bakme

iserror:
signal off error ; signal off syntax
call sre_pmprintf(' error in cms scheduler at 'sigl' 'rc)
foo=sre_write_error('| SREhttp/2 CMS scheduler thread at 'sigl ','rc,1)
exit

return 1

/**************/
/* check to see if any updates needed */
check_doit:
parse arg whycall

if doit='' then return 0
nowtime=sre_gmt(0,,'JS',0)
if nowtime< next_time  then return 0

next_time=9999999               /* zap old next_time */
nowtime_disp=fig_time(nowtime)

dtmp=doit
newdoit=''

foo=sre_flag_open('SRE_CMS_BUSY',1,mypid)  /* suspend scheduler operations (we might be getting busy */
do until dtmp=''       /* stop when doit is done */
       parse var dtmp aline '0d0a'x dtmp
       if aline='' then iterate
       parse var aline atime '09'x .
       if atime > nowtime then do               /* not time for this */
          next_time=min(next_time,atime)        /* but maybe it's next */
          newdoit=newdoit||'0d0a'x||aline
          iterate
       end 

/* otherwise, update using this one. Update may also add re-schedule of this to doit */
       call update_it aline
       res1=result
       doit_history=doit_history||'0d0a'x||nowtime_disp||': '||res1
       if length(doit_history)>15000 then parse var doit_history . '0d0a'x doit_history

end
doit=newdoit
foo=sre_flag_open('SRE_CMS_BUSY',0,mypid)

return 1


/*******/
/* do the update */
update_it:
parse arg aline
parse var aline update_time '09'x ct '09'x freq '09'x series '09'x ,
      sfile '09'x sfile_mdate '09'x cfile '09'x cfile_mdate  '09'x , 
      desc '09'x docheck '09'x  gstuff '01'x dosel

/* if missing file, kill this scheduled update (that is, do NOT reschedule it */
if sfile='' then return 'error - missing file ('||filespec('n',sfile)||' while updating 'series '('desc')'
if cfile='' then return 'error - missing file ('||filespec('n',cfile)||' while updating 'series '('desc')'

sfile_lastmod=get_moddate(sfile)
cfile_lastmod=get_moddate(cfile)

/* set up reschedule vars (nb: ct=0 means infinite loop) */
dd=''
if ct=0 | ct> 1 then do         
   if ct>1 then ct=ct-1
   ttime=sre_gmt(freq,,'JS',0)
   dd=ttime||'09'x||ct||'09'x||freq||'09'x||series||'09'x||,
      sfile||'09'x||sfile_lastmod||'09'x||cfile||'09'x||cfile_lastmod||'09'x||,
      desc||'09'x||docheck||'09'x||gstuff||'01'x||dosel
end

/* 2: check for dataseries file changes? */
if docheck=1 then do
  if sfile_lastmod = sfile_mdate & cfile_lastmod = cfile_mdate then do
     if dd<>'' then do
       next_time=min(next_time,ttime)
       newdoit=newdoit||'0d0a'x||dd
     end
     return 'No dataseries file change, so no update of 'series '(' desc ')'
  end
end

/* 4: now do the update */
fuf=sreh2_cms_make_m(dosel,cmsdir,'UPDATE')
if abbrev(strip(translate(fuf)),'STRING')=1 then do
   parse var fuf . fuf
   return 'Updating 'series '(' desc ') :'||fuf
end 

/* 5: record a rescheduling */
if dd<>'' then  do              
  sfile_lastmod=get_moddate(sfile)
  cfile_lastmod=get_moddate(cfile)
  ttime=sre_gmt(freq,,'JS',0)
  next_time=min(next_time,ttime)
  dd=ttime||'09'x||ct||'09'x||freq||'09'x||series||'09'x||,
      sfile||'09'x||sfile_lastmod||'09'x||cfile||'09'x||cfile_lastmod||'09'x||,
      desc||'09'x||docheck||'09'x||gstuff||'01'x||dosel

  newdoit=newdoit||'0d0a'x||dd
end


return 'Update of 'series '(' desc '): 'fuf


/*******/
/* add to list of scheduled items. The item added contains info on when
to start, when to restart, and # of times to do */
add_schedule:

parse var alist aseries '0d0a'x tfiles '0d0a'x sfile '0d0a'x cfile '0d0a'x alist 
list=strip(sre_packur(translate(alist,' ','+')))
sfile=strip(sfile);cfile=strip(cfile)

sdate=get_moddate(sfile)
if sdate='' then  return 'error.Unable to find data series file: 'sfile

cdate=get_moddate(cfile)
if cdate='' then   return 'error.Unable to find data series comment file: 'cfile

optname.=''
do until list=""
    parse var list opt1 '&' list
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end


freq=optname.!FREQ
if datatype(freq)<>'NUM' then do
     return 'error. Bad frequency: '||freq
end

if optname.!IMMEDIATE=1 then 
   aoffset=0
else
   aoffset=optname.!FREQ

dotime=sre_gmt(aoffset,,'JS',0)
ndo=optname.!COUNT
if datatype(ndo)<>'NUM' then do
     return 'error. Bad #times: '||ndo
end
/*  In a '09'x delimited list:
      update_time ct freq series sfile sfile_mdate cfile cfile_mdate  
      desc do_check do_main do_arc do_cmt how_update
      deffile tfiles sortit_var sortit_order  arg
   tfiles may be more then one word. Arg may be more than one word. 
*/
  
doit1=strip(dotime)||'09'x||ndo||'09'x||optname.!FREQ||'09'x||optname.!SERIES||'09'x
doit1=doit1||sfile||'09'x||sdate||'09'x||cfile||'09'x||cdate||'09'x||optname.!desc||'09'x
doit1=doit1||optname.!do_check||'09'x||optname.!do_main||'09'x||optname.!do_arc||'09'x
doit1=doit1||optname.!do_cmt||'09'x||optname.!how_update||'09'x
/* use tfiles, instead of optname.!tfile (tfiles has not crlfs) */
doit1=doit1||optname.!deffile||'09'x||tfiles||'09'x||optname.!sortit_var
doit1=doit1||'09'x||optname.!sortit_order||'09'x||optname.!ARG||'09'x

doit1=translate(doit1,' ','0d0a'x)  /* to avoid problems ... */
doit=doit||'0d0a'x||doit1||'01'x||alist


doit_history=doit_history||'0d0a'x||nowtime_disp||': Update of '||optname.!SERIES||' scheduled to start at '||fig_time(dotime)||'; ct='||ndo||', freq='||optname.!freq
if length(doit_history)>15000 then parse var doit_history . '0d0a'x doit_history

next_time=min(next_time,dotime)        /* but maybe it's next */

return 'Update of '||optname.!SERIES||' scheduled to start at '||fig_time(dotime)



/*******/
/* remove from list of scheduled items.*/
remove_schedule:

rems.=''
do until alist=''
   parse var alist a1 alist
   a1='!'||strip(translate(a1))
   rems.a1=1
end 
newlist=''
dol=doit
nrem=0 ; nleft=0
do until dol=''
   parse var dol aline '0d0a'x dol
   if aline=''  then iterate
   parse var aline dotime  '09'x ndo '09'x  fREQ '09'x   aSERIES '09'x .
   a2=strip(translate('!'||dotime||';'||aseries))
   if  rems.a2=1 then do
     nrem=nrem+1
     iterate                   /* remove this */
   end
   nleft=nleft+1
   newlist=newlist||aline||'0d0a'x
end
doit=newlist

doit_history=doit_history||'0d0a'x||nowtime_disp||': Number of scheduled items removed= '||nrem||'.  Number remaining= '||nleft
if length(doit_history)>15000 then parse var doit_history . '0d0a'x doit_history

return 'Number of scheduled items removed= '||nrem||'.  Number remaining= '||nleft

/************/
/* convert from CMS id  (JS time stamp) to "N" time stamp */
fig_time:procedure
parse arg atime0

if datatype(atime0)<>'NUM' then return ''

parse var atime0 adate1 '.' atime
adate=adate1+726467
atime='0.'||atime

dd=dateconv(adate,'B','N')

/* else, convert to hr min second */
zz=digits()
numeric digits 16
secs=trunc(atime*86400)
tmp0=secs/3600
parse var tmp0 hour '.' tmp1 ; if tmp1='' then tmp1=0
hour=right(hour,2,'0')
tmp1='0.'||tmp1
tmp2=tmp1*60
parse var tmp2 minute '.'tmp3 ; ; if tmp3='' then tmp3=0
minute=right(minute,2,'0')
tmp3='0.'||tmp3
tmp3=tmp3*60 ; parse var tmp3 second '.' .
second=right(second,2,'0')
numeric digits zz

dd=dd||' '||hour||':'||minute||':'||second
return dd

/***********/
/* js format for last mod date for file */
get_Moddate:procedure
parse arg sfile
sdate=dosfileinfo(sfile,'W')         /* 04/12/04 20:12:20 */
if sdate='' then return ''
parse var sdate amonth '/' aday '/' ayr ahr ':' aminute ':' asec
tmp=space(ayr'/'amonth'/'aday'/'ahr'/'aminute'/'asec,0)
sdate=sre_gmt(0,tmp,'JS',0)
return sdate

