/* The SREhttp/2 content management system (CMS) program 

List CMS-procedures.

*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end


cmsdir_files=cmsdir||'\FILES'
okk=dosisdir(cmsdir_files)
if okk=0 then do
  return 'string unable to find CMS input/output files directory: 'cmsdir_files
end

cmsdir_lib=cmsdir||'\LIB'
okk=dosisdir(cmsdir_lib)
if okk=0 then do
  return 'string unable to find CMS lib directory: 'cmsdir_lib
end

cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'
root=left(uri,jj)

optname.=''
m=0
if list='' then list='action=1'
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/

if optname.!action='1' then do   /* find the list of dataseries defined for this host*/
  call show_files
  foo=result
  return foo
end

return 'string no such cms_lc2 action: 'action


/*******************/
/* List cms procedures */
show_files:

call lineout tempfile,'<html><head><title>CMS: CMS-procedures</title></head><body> '

call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'
call lineout tempfile,'<h3>Currently available CMS-procedures</h3>'
call lineout tempfile,'<em>These are the CMS procedures in the main CMS library.</em>'
call lineout tempfile,'Other procedures, that you may have stored in other directories, will not be listed.'
call lineout tempfile,'<p>'
aa=cmsdir_lib||'\*.CMS'
foo=sysfiletree(aa,'FILS','T')
call lineout tempfile,'<ul>'
do mm=1 to fils.0
 parse var fils.mm adate asize . afile
 aname=filespec('n',afile)
 call lineout tempfile,'<li><a href="'||thisaddon||'?action=1&showme='||aname||'">'||aname||'</a>&nbsp;&nbsp; <tt>'||asize||' bytes </tt>'
end 
call lineout tempfile,'</ul>'

if optname.!SHOWME<>'' then do
   call lineout tempfile,'<hr>'
   aa=cmsdir_lib||'\'||optname.!showme
   stuff=sre_read_file(aa,2,2,1)
   if stuff='' then do
      call lineout tempfile,'<em>Could not find CMS-procedure file: '||optname.!showme||'</em>'
   end 
   else do
      parse var stuff stuff . '/*' stuff2 '*/' .
      stuff2=sre_html_encode(stuff2)
      call lineout tempfile,'<em>Description of: '||optname.!showme||'</em>'
      call lineout tempfile,'<pre>'||stuff2||'</pre>'
   end

end 

call lineout tempfile,''
call lineout tempfile,'</form>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode




/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname='!'||strip(translate(aname))
   stuff.aname=strip(avalue)
end

return 1




/******************************/
/* check access rights. Return 1 if okay. Otherwise, return a string to be
  sent back to SREhttp/2 (an authorization response string) */
check_access:procedure expose privset host_nickname idinfo uri aiter
parse  upper arg owners,series

if owners='' then return 1      /* no owners listed, means open access */


tpr=translate(privset)
pneeded=space(translate('CMS:'||strip(series)),0)
if wordpos(pneeded,tpr)>0 then return 1          /* explicit privilege for this */
if wordpos('SUPERUSER',tpr)>0 then return 1

/* see if a cookie exists */
look_cook='CMS_'||series
aa=sreh2_get_cookie(lookcook)
if aa<>''  then return 1 

if aiter=''  then do            /* first time, so recheck privs */
  return 'PRIVS   Access to this dataseries is restricted to specific users '
end 

/* otherwise, see if a username has been sent  */
username=''
authh=sre_reqfield('Authorization')
if authh<>'' then username=sre_extract_username(authh) 
if username='' then do             /* no username available */
  return  'AUTH  Access to this dataseries is restricted to specific users '
end

/* is this one of the OWNERS? */
if pos('*',owners)=0 then do            /* * means "any user" */
if wordpos(translate(username),translate(owners))=0 then do
   return 'AUTH  Access to this dataseries is restricted to specific users '
end
end

/* One of the OWNERS, now check password */
stuff=sreh2_get_userinfo(authh,host_nickname,idinfo)
if stuff='' then do
  return 'AUTH   Access to this dataseries is restricted to specific users. Please enter a new username/password.'
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
pp=left(thisaddon,jj)

foo=sreh2_set_cookie(lookcook,1,'30m',pp,,1)

/* if here, legit user.  Record a cookie */
return 1

/************/
/* convert from CMS id  (JS time stamp) to "N" time stamp */
fig_time:procedure
parse arg atime0


parse var atime0 adate1 '.' atime
adate=adate1+726467
atime='0.'||atime

dd=dateconv(adate,'B','N')

/* else, convert to hr min second */
zz=digits()
numeric digits 16
secs=trunc(atime*86400)
tmp0=secs/3600
parse var tmp0 hour '.' tmp1 ; if tmp1='' then tmp1=0
hour=right(hour,2,'0')
tmp1='0.'||tmp1
tmp2=tmp1*60
parse var tmp2 minute '.'tmp3 ; ; if tmp3='' then tmp3=0
minute=right(minute,2,'0')
tmp3='0.'||tmp3
tmp3=tmp3*60 ; parse var tmp3 second '.' .
second=right(second,2,'0')
numeric digits zz

dd=dd||' '||hour||':'||minute||':'||second
return dd



/************/
/* figure out a filename, possibly randomized, possibly relative to a directory of a 
reference file*/
fix_file:procedure
parse arg afile,reffile,noast,ith,doover

afile=strip(afile)
if abbrev(afile,'\')=0 & pos(':',afile)=0 then do     /* relative filename */
  afile=strip(filespec('d',reffile)||filespec('p',reffile),,'\')||'\'||afile
end
if pos('*',afile)+pos('?',afile)=0 then return afile  /* no randomization component */

if noast=1 then return afile

if doover=1  then do                    /* use ITH to determine file name (don't search for unused name)*/
  if pos('*',afile)=0 then return afile||'_'||ith
   parse var afile p1 '*' p2 ; afile=p1||ith||p2
  return afile
end

if pos('*',afile)>0 then do
     parse var afile p1 '*' p2 ; afile=p1||'????'||p2
end 
fpath=filespec('d',afile)||filespec('p',afile)
fname=filespec('n',afile)
aname=sre_tempfile(fname,'?',fpath)

return aname


