/* The SREhttp/2 content management system (CMS) program 

Install a pre-defined blog.
 

*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/* maximum size, in bytes, of a record. This does NOT include size of uploaded files & URLS */
max_record_size=10000



/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_upload=cmsdir||'\UPLOADS'
okk=dosisdir(cmsdir_upload)
if okk=0 then do
  return 'string unable to find CMS uploads directory: 'cmsdir_upload
end


cmsdir_file=cmsdir||'\FILES'
okk=dosisdir(cmsdir_file)
if okk=0 then do
  return 'string unable to find CMS working files directory: 'cmsdir_file
end

cmsdir_lib=cmsdir||'\LIB'
okk=dosisdir(cmsdir_lib)
if okk=0 then do
  return 'string unable to find CMS lib directory: 'cmsdir_lib
end


cmsdir_mkb=cmsdir_lib||'\PREDEF'
okk=dosisdir(cmsdir_mkb)
if okk=0 then do
  return 'string unable to find CMS pre-defined-blogs directory: 'cmsdir_mkb
end


cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'
root=left(uri,jj)

optname.=''
m=0
if list='' then list='action=1'
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    avar=sre_packur(avar)
    if wordpos(avar,optname.0)=0 then optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/

/* check for access rights */
/*call sec_check   
ares=result
if ares<>0 then return ares
 */      

if optname.!action='1' then do   /* find the list of dataseries defined for this host*/
  call show_datafiles
  foo=result
  return foo
end

if optname.!action=12 then do
    ahost=host_nickname
    call view_dirs
    pull foo
    return foo
end

if optname.!action='2' then do  
  call step2
  foo=result
  return foo
end


if optname.!action='3' then do  
  call step3
  foo=result
  return foo
end

return 'string unknown action 'action


/*******************/
/* pick one of the current cms datafiles (for this host) */
show_datafiles:

call lineout tempfile,'<html><head><title>CMS: Install a pre-defined blog</title> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> ||'
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Install a pre-defined blog</h3><p> '
call lineout tempfile,'<em>Install a pre-defined blog -- initialize a database, and set up response, etc. files.'
call lineout tempfile,'</em><br>'
ahost=host_nickname

/* look for files, in cmsDIR_index dir, of the form: ahost_nnnn.DEF
   These .DEF files define "CMS indices" --- nnnn is a number from 0 to 9999
*/

call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="2">'
ff=cmsdir_mkb||'\*.DEF'
goo=sysfiletree(ff,'ff2','FO')
call lineout tempfile,' The following pre-defined blogs are currently available'

call lineout tempfile,'<table border=1>'
do jj=1 to ff2.0
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<tr><th align="left">' 
   call lineout tempfile,'<INPUT TYPE="RADIO"  name="deffile" value="'||daname||'">'
   gob=strip(stuff.!PreDefName)||'</th>'
   call lineout tempfile,gob||'<td> <em>&nbsp;'||stuff.!abstract||'</em></td>'
end

call lineout tempfile,'</table>'


call lineout tempfile,''
call lineout tempfile,'<p><INPUT name="sub2" TYPE="submit" VALUE="Install the predefined blog">'
call lineout tempfile,'</form>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* show current structure, ask for changes */
step2:

call lineout tempfile,'<html><head><title>CMS: Install a pre-defined blog</title> '
call lineout tempfile,'<script language="javascript">'
call lineout tempfile,' var the_select="NEW_SELECT"; '
call lineout tempfile,'var DIR_LISTED=0;'



call lineout tempfile,'function numwords(astring) {'
call lineout tempfile,'  slen=astring.length ; nwords=0; inword=0;'
call lineout tempfile,'  for (var ii= 0; ii < slen ; ii++ ) {'
call lineout tempfile,'     achar=astring.substr(ii,1);'
call lineout tempfile,'     if (achar != " ") {'
call lineout tempfile,'        if (inword==0){inword=1;nwords+=1 } '
call lineout tempfile,'     }'
call lineout tempfile,'     else {'
call lineout tempfile,'        if (inword==1) {inword=0} '
call lineout tempfile,'     }'
call lineout tempfile,'   }'
call lineout tempfile,' return nwords ;}'
call lineout tempfile,' '

call lineout tempfile,'function putit(sfile) {'
call lineout tempfile,'  eval("document.doredo." + the_select + ".value= ''" +  sfile + "''" ) ;'
call lineout tempfile,' return 0 ;}'


call lineout tempfile,'function Open_viewtree(isblur)'
call lineout tempfile,'{eek="";   '
call lineout tempfile,'daVIEWTREE=window.open("'||thisaddon||'?action=12","VIEWTREE", '
call lineout tempfile,'"location=NO,MENUBAR=NO,RESIZABLE,DEPENDENT,SCROLLBARS=YES,STATUS=YES,TITLEBAR,TOOLBAR=NO,SCREENX=12,SCREENY=30,height=440,width=200");' 
call lineout tempfile,' var openVIEWTREE=1;  '
call lineout tempfile,'if (isblur==1) ; {daVIEWTREE.blur() }'
call lineout tempfile,' }'
 
call lineout tempfile,'</script>'
call lineout tempfile,'</head>'

daindx=optname.!deffile
goo=lastpos('/',mainaddon)
goo3=left(mainaddon,goo)||'/cms_redo.cmd'

call lineout tempfile,'<font size=-1>'
if optname.!CLOSEIT=1 then 
   call lineout tempfile,'<a href="javascript:close()">Close window</a> || '
else
   call lineout tempfile,'<a href="javascript:history.go(-1)">Back</a> || '
call lineout tempfile,' <a href="'||mainaddon||'?action=1">Another CMS action</a>  || '

call lineout tempfile,'<a href=""'
call lineout tempfile,'  onCLick="Open_viewtree(); DIR_LISTED=1; daVIEWTREE.focus() ;  return false " '
call lineout tempfile,'  onMouseOut="window.status=''CMS'' ; return true "  '
call lineout tempfile,'  onMouseOver="window.status=''Display directory list in separate window'' ;return true"> '
call lineout tempfile,' List directories </a>'

call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Install a pre-defined blog: customize some variables</h3> '

if daindx='' then do
   call lineout tempfile,'<b>Error</b>: you forgot to select a pre-defined blog.<br>'
   call lineout tempfile,'Please <a href="javascript:history.go(-1)">go back</a> and select one!'
   signal gooble
end

call lineout tempfile,'<FORM  name="GSW2" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="3">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'


ff=cmsdir_mkb||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'<b>Error</b>: could not find blog definition file: '||ff
   signal gooble
end

call read_deffile ff

call lineout tempfile,'<Table bgcolor="cyan">'
call lineout tempfile,"<tr><th>Pre-defintion name:</th><Td> "||stuff.!PreDefName'</td>'
call lineout tempfile,"<tr><th>Abstract:</th><Td> "||stuff.!abstract'</td>'
call lineout tempfile,"<tr bgcolor="tan"><th>Description:</th><Td> "||stuff.!!desc'</td>'
call lineout tempfile,'</Table>'

/* first: get directories */
tt=stuff.!!inquire_dir||' '||stuff.!!INQUIRE_D
if tt<>'' then call lineout tempfile,'<table border=1><tr><th>Enter some directory names<br>(they will be created if they <br>do not exist):</th><td><ul>'


call lineout tempfile,'<br><em>Current</em> '
call lineout tempfile,'<a href=""'
call lineout tempfile,'  onCLick="Open_viewtree(); DIR_LISTED=1; daVIEWTREE.focus() ;  return false " '
call lineout tempfile,'  onMouseOut="window.status=''CMS'' ; return true "  '
call lineout tempfile,'  onMouseOver="window.status=''Display directory list in separate window'' ;return true"> '
call lineout tempfile,'  chosen directory</a>: <input size=60 type="text" name="sel" value=""> </em>'
gooba=0
dlist=''
do until  tt=''
    gooba=1
    parse var tt a1 '0d0a'x  tt
    if a1='' then iterate
    parse var a1 dirname '|' aprompt ;dirname=strip(translate(dirname))
    dlist=dlist||' '||dirname
    call lineout tempfile,'<li>'||aprompt||'<br>'
    call lineout tempfile,'<input type="Text" name="_DIR_'||dirname||'" '
    call lineout tempfile,' size=60'
    call lineout tempfile,' onChange="if (this.value=='' '') {this.value=document.GSW2.sel.value} " '
    call lineout tempfile,'>'
    call lineout tempfile,'<p>'
end 
if gooba=1 then call lineout tempfile,'</table>'

inqlist=''

/* 2: Inquire_w: variables */
tt=stuff.!!inquire_w
if tt<>'' then call lineout tempfile,'<table border=1><tr><th>Customize some 1-word strings:</th><td><ul>'
gooba=0
do until  tt=''
    gooba=1
    parse var tt a1 '0d0a'x  tt
    if a1='' then iterate
    parse var a1 iname '=' idef '|' aprompt
    iname=strip(translate(iname))
    inqlist=inqlist||' '||iname
    call lineout tempfile,'<li>'||aprompt||'<br>'
    call lineout tempfile,'<input type="Text" name="_INQUIRE_'||iname||'" '
    if idef<>'' then
       call lineout tempfile,' value="'||idef||'" '
    call lineout tempfile,' size=80'
    call lineout tempfile,' onChange="nn=numwords(this.value); ;'
    call lineout tempfile,'          if (nn > 1){alert(''Please enter a 1-word string (spaces are not allowed)'');'
    call lineout tempfile,'                    this.value='' '';} "' 
    call lineout tempfile,'>'
    call lineout tempfile,'<p>'
end 
if gooba=1 then call lineout tempfile,'</table>'


/* 3: Inquire: strings */
tt=stuff.!!inquire_s||'0d0a'x||stuff.!!inquire
if tt<>'' then call lineout tempfile,'<table border=1><tr><th>Customize some 1-line strings:</th><td><ul>'
gooba=0
do until  tt=''
    gooba=1
    parse var tt a1 '0d0a'x  tt
    if a1='' then iterate
    parse var a1 iname '=' idef '|' aprompt
    iname=strip(translate(iname))
    inqlist=inqlist||' '||iname

    call lineout tempfile,'<li>'||aprompt||'<br>'
    call lineout tempfile,'<input type="Text" name="_INQUIRE_'||iname||'" '

    if idef<>'' then
       call lineout tempfile,' value="'||idef||'" '
    call lineout tempfile,' size=80'
    call lineout tempfile,'>'
    call lineout tempfile,'<p>'
end 
if gooba=1 then call lineout tempfile,'</table>'


/* 4: Inquire: paragraphs */
tt=stuff.!!inquire_p
if tt<>'' then call lineout tempfile,'<table border=1><tr><th>Customize some <br>multi-line strings:</th><td><ul>'
gooba=0
do until  tt=''
    gooba=1
    parse var tt a1 '0d0a'x  tt
    parse var a1 iname '=' idef '|' aprompt
    iname=strip(translate(iname))
    inqlist=inqlist||' '||iname

    call lineout tempfile,'<li>'||aprompt||'<br>'
    call lineout tempfile,'<Textarea name="_INQUIRE_'||iname||'" '
    call lineout tempfile,' rows=3 cols=80 '
    call lineout tempfile,'>'
    if idef<>'' then
       call lineout tempfile,idef
    call lineout tempfile,'</Textarea>'
    call lineout tempfile,'<p>'
end 
if gooba=1 then call lineout tempfile,'</table>'



if inqlist<>"" then call lineout tempfile,'<input type="hidden" name="_INQUIRE_" value="'||strip(inqlist)||'"> '
if dlist<>"" then call lineout tempfile,'<input type="hidden" name="_DIR_" value="'||strip(dlist)||'"> '
call lineout tempfile,'<input type="hidden" name="daindx" value="'||daindx||'">'
call lineout tempfile,'<input type="checkbox" checked name="overwrite" value=1>Overwrite pre-existing files?<br>'
call lineout tempfile,'<input type="submit" value="Create the blog">'
call lineout tempfile,'<input type="reset">'

call lineout tempfile,'</form>'

signal gooble


gooble:         /* jump here on error */


call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/**********************************************************************/
/* make the changes */
step3:

call lineout tempfile,'<html><head><title>CMS: creating a blog</title> '

call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1>'
call lineout tempfile,'<a href="'||mainaddon||'?action=1">Another CMS action</a> ||'
call lineout tempfile,'<a href="javascript:history.go(-1)">Back</a> '

call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Creating blog, using pre-definition</h3> '

merrs=0

daindx=optname.!deffile
ff=cmsdir_mkb||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'<b>Error</b>: could not find index file: '||ff
   signal gooble
end

call read_deffile ff

call lineout tempfile,'<Table bgcolor="cyan">'
call lineout tempfile,"<tr><th>Pre-defined-blog name:</th><Td> "||stuff.!PreDefName'</td>'
call lineout tempfile,"<tr><th>Abstract:</th><Td> "||stuff.!abstract'</td>'
call lineout tempfile,"<tr bgcolor="tan"><th>Description:</th><Td> "||stuff.!!desc'</td>'
call lineout tempfile,'</Table>'


dlists=stuff.!!inquire_dir||' '||stuff.!!INQUIRE_D

dlisto=optname.!_DIR_

reps.=''
reps.0=3

reps.1='$CMSDIR$'
reps.1.1=strip(cmsdir,,'\')

reps.2='$TIMEDATE$'
reps.2.1=time('n')||' '||date('n')

reps.3='$HOST$'
reps.3.1=host_nickname

call lineout tempfile,'<Table>'
if dlists<>'' then do
  call lineout tempfile,'<tr><th>Directories</th><Td> '

/* for each inquire_dir ... */
call lineout tempfile,'<ul>'
goterr=0
do until dlists=''
    parse var dlists a1 '0d0a'x  dlists
    if a1='' then iterate
    parse var a1 dirname '|' aprompt ;dirname=strip(translate(dirname))
    tt='!_DIR_'||dirname
    reps.0=reps.0+1

    adir2=optname.tt
    if adir2='' then do
      call lineout tempfile,'<li>For: <tt>'||aprompt||'</tt><br><b>No Directory specified </b><p>'
      goterr=1
      iterate
    end
    adirc=strip(adir2,,'\')
    if right(adirc,1)=':' then
        adirc=adirc||'\'
    isdir=dosisdir(adirc)
    if isdir=1 then do
       call lineout tempfile,'<li>For: <tt>'||aprompt||'</tt><br><u>'||adirc||'</u> <b>already  exists</b><p> '
    end
    else do
       foo=sysmkdir2(adirc)       
       call lineout tempfile,'<li>For: <tt>'||aprompt||'</tt><br>  <u>'||adirc||'</u>  <b>created</b><p> '
    end 
    itt=reps.0
    reps.itt=dirname
    reps.itt.1=strip(adirc,,'\')
end
call lineout tempfile,'</ul></td></table>'
end             /* dlists */
if goterr=1 then signal gooble

/* inquire variables */
inqs=optname.!_INQUIRE_
do until inqs=''
   parse var inqs ainq inqs
   ainq=strip(translate(ainq))
   tt='!_INQUIRE_'||ainq
   aval=optname.tt
   reps.0=reps.0+1
   itt=reps.0
   reps.itt=ainq
   reps.itt.1=strip(aval)
end 
call lineout tempfile,'<em>Note:</em> there are '||reps.0||' replacement strings (including directories)'

/* use "inquire" values to substitute for strings in:
   a) the files pointed to by FILE variables
   b) the DIR variables 
*/

call lineout tempfile,'</Table>'

/* now, do make_dir creation */
makedlists=stuff.!!make_dir
call lineout tempfile,'<h4>Creating pre-defined directories ... </h4><ul>'
do until makedlists=''
   parse var makedlists a1 '0d0a'x makedlists ; parse var a1 a1 '=' .
   a1=strip(a1); 
   mdir=do_reps(a1)
   call lineout tempfile,'<li>Creating directory:<tt> '|| mdir ||'</tt>'

   adirc=strip(mdir,,'\')
   if right(adirc,1)=':' then
       adirc=adirc||'\'
   isdir=dosisdir(adirc)
   if isdir=1 then do
       call lineout tempfile,'<br><u>'||adirc||'</u> <b>already  exists</b><p> '
    end
    else do
       foo=sysmkdir2(adirc)       
       call lineout tempfile,'<br><u>'||adirc||'</u>  <b>created</b><p> '
    end 

end

call lineout tempfile,'</ul>'
/* now, do the file replacements */
dofiles=stuff.!!FILE
dooverwrite=optname.!OVERWRITE
call lineout tempfile,'<h4>Creating files ... </h4><ul>'
do until dofiles=''
   parse var dofiles a1 '0d0a'x dofiles
   parse var a1 ofile dfile . ; ofile=strip(ofile)
   dfile=do_reps(dfile)
   call lineout tempfile,'<li>Using pre-defined file:<tt> '|| Ofile ||'</tt><br>to create:<tt>'||dfile||'</tt>'

   if stream(dfile,'c','query exists')<>'' then do
      if dooverwrite<>1 then do
          merrs=merrs+1
          call lineout tempfile,'<p><b>Error</b>: attempting to overwrite existing file, '||dfile||', but <tt>overwrite</tt> checkbox was <b>not</b> checked '
          iterate       
      end 
   end 

   ff=cmsdir_mkb||'\'||ofile
   goo=stream(ff,'c','query exists')
   if goo='' then do
      merrs=merrs+1
      call lineout tempfile,'<p><b>Error</b>: could not find pre-defined file: '||ff
      signal gooble
   end
   fstuff=sre_read_file(ff,2,2,1)
   call lineout tempfile,'<br>Bytes in pre-defined file= '||length(fstuff)
   fstuff=do_reps(fstuff) 
   call lineout tempfile,'<br>Bytes in pre-defined file after replacement= '||length(fstuff)

   astat=sre_append_file(dfile,fstuff,2,,1)
   if astat<0 then do
      merrs=merrs+1
      call lineout tempfile,'<br> <b>Error</b>: unable to write file: 'dfile
   end
   else do
      call lineout tempfile,'<br>'astat' bytes written.'
   end
end 
call lineout tempfile,'</ul>'


/* now, do the file_2 (fixed record length) replacements */
dofiles=stuff.!!FILE_2
dooverwrite=optname.!OVERWRITE
call lineout tempfile,'<h4>Creating fixed-record length files ... </h4><ul>'
do until dofiles=''
   parse var dofiles a1 '0d0a'x dofiles
   parse var a1 ofile dfile . ; ofile=strip(ofile)
   dfile=do_reps(dfile)
   call lineout tempfile,'<li>Using pre-defined file:<tt> '|| Ofile ||'</tt><br>to create:<tt>'||dfile||'</tt>'

   if stream(dfile,'c','query exists')<>'' then do
      if dooverwrite<>1 then do
          merrs=merrs+1
          call lineout tempfile,'<p><b>Error</b>: attempting to overwrite existing file ('||dfile||')), but <tt>overwrite</tt> checkbox was <b>not</b> checked '
          iterate       
      end 
   end 

   ff=cmsdir_mkb||'\'||ofile
   goo=stream(ff,'c','query exists')
   if goo='' then do
      merrs=merrs+1
      call lineout tempfile,'<p><b>Error</b>: could not find pre-defined file: '||ff
      signal gooble
   end
   fstuff=sre_read_file(ff,2,2,1)
   call lineout tempfile,'<br>Bytes in pre-defined file= '||length(fstuff)
   fstuff=do_reps2(fstuff) 
   call lineout tempfile,'<br>Bytes in pre-defined file after replacement= '||length(fstuff)

   astat=sre_append_file(dfile,fstuff,2,,1)
   if astat<0 then do
      merrs=merrs+1
      call lineout tempfile,'<br> <b>Error</b>: unable to write file: 'dfile
   end
   else do
      call lineout tempfile,'<br>'astat' bytes written.'
   end
end 
call lineout tempfile,'</ul>'



gooble:         /* jump here on error */
if merrs>0 then do
  call lineout tempfile,'<p><B>Warning:</b> 'merrs||' errors occurred. Check status lines above for the details.<p>'
end
else do         /* success -- display a "start link" ? */
  if stuff.!!start_link<>'' then do
      parse var stuff.!start_link auri '|' astring
      auri=do_reps(auri)
      call lineout tempfile,'<p><table bgcolor="#dddddd"><Tr><td><a href="'||auri||'">'||astring||'</a></td></table>'
  end 
end 

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*************/
/* do replacements,retaining record length */
do_reps2:procedure expose reps.
parse arg daword
nustuff=''
do until daword=''
   parse var daword aline '0d0a'x daword
   lenline=length(aline)
   do ii=1 to reps.0
      aline=sre_replacestrg(aline,reps.ii,reps.ii.1,'ALL')
   end 
   if nustuff='' then
      nustuff=left(aline,lenline,' ')||'0d0a'x
   else
      nustuff=nustuff||left(aline,lenline,' ')||'0d0a'x
end
return nustuff


/*************/
/* do replacements */
do_reps:procedure expose reps.
parse arg daword
do ii=1 to reps.0
  daword=sre_replacestrg(daword,reps.ii,reps.ii.1,'ALL')
end 

return daword 

/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)
ilines=0
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   ilines=ilines+1
   stuff.!lines.ilines=aline
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname='!'||strip(translate(aname))
   stuff.aname=strip(avalue)
   bname='!'||aname
   if stuff.bname='' then
      stuff.bname=strip(avalue)
   else
      stuff.bname=stuff.bname||'0d0a'x||strip(avalue)
end
stuff.!lines.0=ilines
return 1





/******************/
/* access allowed? */
sec_check:
ss=sre_value('SECURITY_LEVEL',,'SRESYS')
if ss=0 then do
  foo=sre_command('String Sorry. Remote access to configuration utilities not permitted.',,idinfo)
  return foo
end
if ss=1 then do
    myaddr=sre_extract("clientaddr",idinfo)
    moreaddr=sre_value('SERVERADDR_INHOUSE',,'SRESYS')
    who=sre_extract("serveraddr",idinfo)||' '||moreaddr
    if wordpos(myaddr,who)=0 then do
      sfoo=sre_command('String External access to configuration utilities is not permitted' ,,idinfo)
      return sfoo
   end
end

/* else, normal superuser checking */

if wordpos('CMS_DEF',translate(privset))>0 then return 0     
if wordpos('SUPERUSER',translate(privset))>0 then return 0   

/* not enough privs */
if aiter='' then return 'PRIVS Defining a CMS dataseries requires superuser privileges '
return 'AUTH Defining a CMS dataseries requires that you have superuser privileges '



/**********************/
/* make a directory listing of all directories under /
  (display as relative to / */
view_dirs:
try1b=''

dahost=sre_hostinfo('!SEEK',ahost) 
if dahost='' then do
  dahost=SRE_servername('default')
  ddir=sre_datadir('default')
end
else do
    goo=sre_hostinfo(dahost)
    parse var goo . ',' .  ddir ; ddir=strip(ddir)
end 

rdir=strip(ddir,,'\')
if dosisdir(rdir)=0 then do
    merrs=merrs+1
    call lineout tempfile, '<B>ERROR</b>: Could not find directory= 'rdir
    signal arf3
end 
oof=rdir||'\*.*'

oof2=sysfiletree(oof,'dirs.','DOS')
 call lineout tempfile, '<html><HEAD><TITLE>Directory listing</title></head>'
  call lineout tempfile, '<script language="javascript">'
  call lineout tempfile, '<!--'
  call lineout tempfile, 'var vstore="'||try1b||'" ;'   
  call lineout tempfile, 'var totdir='dirs.0 ' ;'
  call lineout tempfile, 'var nowdir=0  ;'
  call lineout tempfile, 'var callwin=self.opener; '
  call lineout tempfile, ' '
  call lineout tempfile, 'function do_chosen(thedir,dirnum) { ;'
  call lineout tempfile, 'window.document.TT.CHOSEN.value= dirarray2[dirnum]  ;'
  call lineout tempfile, ' vstore=thedir ; nowdir=dirnum ;'
  call lineout tempfile, ' callwin.document.GSW2.sel.value;'
  call lineout tempfile, 'if (callwin.document.forms.length>0){'
 /* call lineout tempfile, ' callwin.document.GSW2.sel.value=callwin.document.GSW2.sel.value + " " + vstore;}'  */
  call lineout tempfile, ' callwin.document.GSW2.sel.value=dirarray2[dirnum];}'  
  call lineout tempfile, ' return true }'
  call lineout tempfile, ' '
  call lineout tempfile, 'function next_dir() {'
  call lineout tempfile, 'idir=nowdir+1; '
  call lineout tempfile, 'if (idir>totdir) {idir=0}'
  call lineout tempfile, ' '
  call lineout tempfile, ' window.document.TT.CHOSEN.value="'||try1b||'"+dirarray[idir] ;'
  call lineout tempfile, " vstore='"||try1b||"'+ dirarray[idir] ; nowdir=idir ;"
  call lineout tempfile, ' return true }'

  call lineout tempfile, 'function show_files() {'
  call lineout tempfile, ' msgwin=window.open("/!dir?" + dirarray[nowdir],"msg","width=400,height=400");'
  call lineout tempfile, ' return 0 } '

  call lineout tempfile, '// end of hiding -->'
  call lineout tempfile, '</script></head><body>'

call lineout tempfile, ' <font size=-1><a href="javascript:close()">close</a></font><br>'
call lineout tempfile, '<nobr><b>For host: </b><tt>'||dahost||'</tt><br>'
call lineout tempfile, 'Default data dir: <tt>'||ddir||'</tt><br>'
call lineout tempfile, '<form name="TT" onSubmit="return false;">'
call lineout tempfile, '<table bgcolor="#aabbaa"><tr ><td><font size=-1>Chosen Dir:</font></td>'
call lineout tempfile, '<td><input type="TEXT" '
call lineout tempfile, '  value="'||try1b||'" size=60 '
call lineout tempfile, '  onChange="if (callwin.document.forms.length>0){'
call lineout tempfile, '     vstore=this.value ;'
call lineout tempfile, '     callwin.document.CALL_THUMB.SEL.value=vstore};' 
call lineout tempfile, '     return false; }"'
call lineout tempfile, ' name="CHOSEN">'
call lineout tempfile, '</td>'

/* 
call lineout tempfile, '<tr> '
call lineout tempfile, ' <td colspan=2><Input type="checkbox" value=1 name="WHAT_DIRAT"'
call lineout tempfile, ' onClick="next_dir() ; window.document.TT.WHAT_DIRAT.checked=false; return true"'
call lineout tempfile, '   Get the <b>next</b> directory.'
*/

call lineout tempfile, '<tr> '
call lineout tempfile, ' <td colspan=2><a href="javascript:void(0)" onClick="ff=show_files(); return false;">'
call lineout tempfile, '   View contents of chosen directory</a> '

call lineout tempfile, '</td>'
call lineout tempfile, '</table></form>'
call lineout tempfile, '<ul compact type="CIRCLE">'
ddlist.=''

ndirs=dirs.0
dirs.0=rdir

nddir=length(rdir)

do mm=0 to ndirs
  acdir=dirs.mm
  founds=''
  thissel=substr(translate(acdir,'/','\'),nddir+1)
  if thissel='' then thissel='/'
  npics=0
  call lineout tempfile, '<li> <a href="'||thissel||'" '

  call lineout tempfile, 'onClick="do_chosen(this.pathname,'mm');return false">'
  call lineout tempfile, thissel||'</a>'||founds

  ddlist.mm=thissel
  ddlist.!all=mm

end 
call lineout tempfile, ' </ul>'
call lineout tempfile, '</nobr>'
call lineout tempfile, ' '
call lineout tempfile, '<script language="javascript">'
call lineout tempfile, '<!-- '
call lineout tempfile, 'dirarray=new Array('||ddlist.!all||') ;'
call lineout tempfile, 'dirarray2=new Array('||ddlist.!all||') ;'

do jjj=0 to ddlist.!all
   tt=ddlist.jjj
   if tt='' then tt='/'
   call lineout tempfile, ' dirarray['||jjj||']="'||tt||'";'
  sdir=sre_replacestrg(dirs.jjj,'\','\\','ALL')
   call lineout tempfile, ' dirarray2['||jjj||']="'||sdir||'";'

end
call lineout tempfile, ' // end of hiding -->'
call lineout tempfile,' </script>'


arf3:
call lineout tempfile,'<body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)

return rcode

return 1

/* ------------- */
sysmkdir2:procedure
parse arg adir

adir=strip(adir,'t','\')
ff=sysmkdir(adir)
if ff=0 then return ff

/* make the tree */
f2=adir'\'
dd=filespec('d',f2)
pp=filespec('p',f2)
if pp='\' | pp='' then return -1

pp2=strip(translate(pp,' ','\'))

do mm=1 to words(pp2)
   a1=subword(pp2,1,mm)
   a1=translate(a1,'\',' ')
   dd2=dd'\'a1
   hoo=sysmkdir(dd2)
end /* do */

return hoo


