/* The SREhttp/2 content management system (CMS) program 

   This module will display and create .OPT files (for use by Select List variables)


*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_lib=cmsdir||'\LIB'
okk=dosisdir(cmsdir_lib)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_lib
end

cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'

optname.=''
m=0
if list='' then list='action=1'
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/


if optname.!action='1' then do   /* choose a record */
  call build_optfile
  r1=result
  return r1
end

if optname.!action='2' then do   /* choose a record */
  call show_optfile
  r1=result
  return r1
end

if optname.!action='4' then do   /* choose a record */
  call write_optfile
  r1=result
  return r1
end

if optname.!action='5' then do   /* choose a record */
  call show_optfiles
  r1=result
  return r1
end

return 'String Unknown CMS_OPTS action: 'optname.!action


/*******************/
/* view a stored file */
build_optfile:

call lineout tempfile,'<html><head><title>CMS: Build an options file </title> </head>'

call lineout tempfile,'<font size=-1><a href="#notes">Description</a> || '
call lineout tempfile,'<a href="'||thisaddon||'?action=5">View an options file</a> ||'
call lineout tempfile,'<a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<h3>Build an options file</h3><em>for use with <tt>Select List</tt> variables </em><p>'

call lineout tempfile,' You can use this form to create an option''s file containing up to 25 options.'
call lineout tempfile,' <br>If you need a longer list of options, you''ll have to create a text-file'
call lineout tempfile,'using your favorite edtior<br>(see <a href="#notes">below</a> for some details).'
call lineout tempfile,' '
call lineout tempfile,'<form method="POST" name="build" action="'||thisaddon||'">'
call lineout tempfile,'<input type="hidden" name="action" value=4><br> '

call lineout tempfile,'<b>Name of file</b> (no path, no extension): '
call lineout tempfile,'<input type="text" name="OPTNAME" size=15><br> '
call lineout tempfile,'Description: <input type="text" name="desc" size=60>'
call lineout tempfile,'<table><tr><th>Value </th><th>displayed</th> '
do mm=1 to 25
   call lineout tempfile,'<tr><td><input type="text" name="OPT_'||mm||'" size=10></td> '
   call lineout tempfile,'<td><input type="text" name="DISP_'||mm||'" size=40></td> '
end
call lineout tempfile,'</table>'
call lineout tempfile,'<input type="submit" value="Create the option file"><input type="reset"><br> '
call lineout tempfile,' '
call lineout tempfile,' '
call lineout tempfile,' '
call lineout tempfile,' '
call lineout tempfile,'</form> '

call lineout tempfile,'<a name="notes"><h3>Notes</h3></a> '
call lineout tempfile,'CMS uses <tt>option files</tt> to build the option list for '
call lineout tempfile,'<tt>Select List</tt> variables. '
call lineout tempfile,'<ul><li> These options files are simple text files.'
call lineout tempfile,'<li> They all have a <tt>.OPT</tt> extension,'
call lineout tempfile,'<li> They are stored in the '||cmsdir_lib||' directory.'
call lineout tempfile,'</ul>'
call lineout tempfile,''
call lineout tempfile,'The structure of these .OPT files is simple:'
call lineout tempfile,'<menu>'
call lineout tempfile,'<li> Each option will be on a seperate line'
call lineout tempfile,'<li> Each line has the structure: <tt>opt_value = opt_description</tt>'
call lineout tempfile,'<br>where <tt>opt_value</tt> is the value that is stored in the CMS dataseries,'
call lineout tempfile,'and <tt>opt_description</tt> is displayed on the <tt>add record</tt> input form.'
call lineout tempfile,'<li>Or, you can use the simpler form:<tt>opt_value</tt><br><em> the opt_value is used'
call lineout tempfile,'both for the option''s and its description</em>'
call lineout tempfile,'<li><b>Hint:</b> to choose <u>one</u> option as the default,'
call lineout tempfile,'put the value between parenthesis.'
call lineout tempfile,' <br><em>Example:</em><tt> (5)= Average </tt>'

call lineout tempfile,'<li>Lines that begin with a semi-colon (;) are comments, and are ignored.'
call lineout tempfile,'<li>You can have one line that begins with <tt>; DESC= a description </tt><br>'
call lineout tempfile,' <em>(the <tt>a description</tt> will be displayed in the Option-File viewer window)</em>'

call lineout tempfile,'</menu>'



gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* write to  a stored file */
write_optfile:


call lineout tempfile,'<html><head><title>CMS: Write an options file </title> </head>'
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'

call lineout tempfile,'<body><h3>Creating a Options File</h3>'
daindx=optname.!optname
ff=cmsdir_lib||'\'||daindx||'.OPT'
goo=stream(ff,'c','query exists')
if goo<>'' then do
   call lineout tempfile,'<b>Error</b>: file already exists: '||ff
   signal gooble
end

aa='; DESC= '||optname.!DESC||'0d0a'x
aa=aa||';Created '||date('n')||' '||time('n')||'0d0a'x
aa=aa||'0d0a'x
do mm=1 to 25
   vv='!OPT_'||mm
   if optname.vv='' then iterate
   vv2='!DISP_'||mm
   aa=aa||optname.vv||' = '||optname.vv2||'0d0a'x
end 

arf=sre_append_file(ff,aa,2,,1)
if arf<0 then do
   call lineout tempfile,'<b>Error</b>: unable to write .OPT file 'ff
   signal gooble
end 
call lineout tempfile,'<br> File succesfully created:<tt> 'ff||'</tt><p>'
call lineout tempfile,'It can be used with <tt>Select List</tt> variables -- choose <u>'daindx'</u>'
call lineout tempfile,'<p>Would you like to <a href="'||thisaddon||'?action=5">view the contents</a> of an options file?'
gooble:
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* choose a stored file to view*/
show_optfiles:
call lineout tempfile,'<html><head><title>CMS: Choose an options file to view </title> '

call lineout tempfile,'<script language="javascript">'

call lineout tempfile,'function show_opts(isblur,afile){'
call lineout tempfile,'dahelp=window.open("/cms/cms_opts?action=2&file="+afile,"HELPER",' ||,
        '"location=NO,MENUBAR=NO,RESIZABLE,DEPENDENT,SCROLLBARS=YES,STATUS=YES,TITLEBAR,TOOLBAR=NO,SCREENX=12,SCREENY=30,height=350,width=350");' 
call lineout tempfile,''
call lineout tempfile,'if (isblur==1) ; {dahelp.blur() }'
call lineout tempfile,' }'
call lineout tempfile,' '
call lineout tempfile,'</script>'
call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a></font><br>'
call lineout tempfile,'<h3>CMS: Choose an options file to view </h3> '

oo=sysfiletree(cmsdir_lib||'\*.OPT','ofiles','FO')
if ofiles.0=0 then do
   call lineout tempfile,   aa='There are <b>no</b> options files (.OPT files) currently available in '||cmsdir_lib||'</b>'
   signal gooble
end

call lineout tempfile,'<form target="HELPER" name="viewopt" action="'||thisaddon||'" method="POST" '
call lineout tempfile,'onSubmit="show_opts(0,document.viewopt.file.value); ">'

call lineout tempfile,'<input type="hidden" name="action" value=2>'

call lineout tempfile,'Select one of these '||ofiles.0||' to view, then hit the <input type="submit" value="View file"> button.'

do j1=1 to ofiles.0
    ofiles_name.j1=translate(filespec('n',ofiles.j1))
    parse var ofiles_name.j1 ofiles_name.j1 '.' .
end 
call lineout tempfile,'<p><table>'
bg.1='bgcolor="#ddeedd"'
bg.2='bgcolor="#ddddcc"'
do jj=1 to ofiles.0
  ijj=jj//2 + 1
  aa=sre_read_file(ofiles.jj,2,2,1,400)   
  adesc=''
  do until aa=''
    parse var aa aline '0d0a'x aa
    aline=strip(aline); 
    if abbrev(aline,';')=0 then iterate
    parse var aline . ';' aword '=' aline
    if strip(translate(aword))='DESC' then do
      adesc=aline
      leave
    end
  end 

  call lineout tempfile,'<tr '||bg.ijj||'><td> <input type="radio" name="file" value="'||ofiles_name.jj||'">'||ofiles_name.jj||'</td>'
  call lineout tempfile,'<td>'
  if adesc<>'' then call lineout tempfile,'  <em>'||adesc||'</em>'
  call lineout tempfile,'</td>'
end
call lineout tempfile,'</table><br>'
call lineout tempfile,'<input type="submit" value="View file">.'

call lineout tempfile,'</form>'


gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode

/*******************/
/* view a stored file */
show_optfile:

 call lineout tempfile,'<html><head><title>CMS: View an options file </title></head> '

daindx=optname.!file
ff=cmsdir_lib||'\'||daindx||'.OPT'
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find a CMS Select-option file: '||ff
   signal gooble
end

stuff=sre_file_read(ff,2,2,1)
if stuff='' then do
   call lineout tempfile,'Error: empty a CMS Select-option file: '||ff
   signal gooble
end

adesc=''
ith=0
do until stuff=''
   parse var stuff aline '0d0a'x stuff
   aline=strip(aline)
   if abbrev(aline,';')=1 then do
      parse var aline . ';' aword '=' aline
      if strip(translate(aword))='DESC' then adesc=aline
      iterate
   end
   ith=ith+1
   if pos('=',aline)=0 then do
      opt.ith=strip(aline)
      opt.ith.!disp=opt.ith
   end
   else do
       parse var aline o1 '=' o2
       opt.ith=strip(o1)
       opt.ith.!disp=strip(o2)
   end
end
call lineout tempfile,'<font size=-1><a href="javascript:close()">close window</a></font><p>'
call lineout tempfile,'<u>Description</u>: <b>'||adesc||'</b><p>'

call lineout tempfile,'<table>'
   call lineout tempfile,'<tr><th>Value</th><th>Display</th>'

do jj=1 to ith
   call lineout tempfile,'<tr><td><tt>'||opt.jj||'</tt>'
   call lineout tempfile,'<td><em>'||opt.jj.!disp||'</td>'
end
call lineout tempfile,'</table>'


gooble:         /* jump here on error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode

