/* The SREhttp/2 content management system (CMS) program 

Restructure a cms dataseries.
  

*/

/******** User changeable parameters ***/
/* root directory for the SREhttp/2 CMS addon.
   Leave blank to use default (CMS subdirectory of srehttp/2 addon directory */
cmsdir=''


/* maximum size, in bytes, of a record. This does NOT include size of uploaded files & URLS */
max_record_size=10000



/******** end of user changeable parameters ***/


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,client_ip,privset,,
          uri,host_nickname,idinfo,aiter,attribs,seluse2

crlf='0d0a'x

if verb=" " then do
   say "This SREhttp/2 procedure is not meant to be run in standalone mode "
   exit
end  

addon_dir=sre_value('H2_ADDON_DIR_DEFAULT',,'SRE')
if cmsdir='' then cmsdir=strip(addon_dir,,'\')||'\CMS'
foo=dosisdir(cmsdir)
if foo=0 then return 'String Error:unable to find CMS directory: ('cmsdir

cmsdir_data=cmsdir||'\DATA'
okk=dosisdir(cmsdir_data)
if okk=0 then do
  return 'string unable to find CMS data directory: 'cmsdir_data
end

cmsdir_upload=cmsdir||'\UPLOADS'
okk=dosisdir(cmsdir_upload)
if okk=0 then do
  return 'string unable to find CMS uploads directory: 'cmsdir_upload
end


cmsdir_file=cmsdir||'\FILES'
okk=dosisdir(cmsdir_file)
if okk=0 then do
  return 'string unable to find CMS working files directory: 'cmsdir_file
end

cmsdir_lib=cmsdir||'\LIB'
okk=dosisdir(cmsdir_lib)
if okk=0 then do
  return 'string unable to find CMS lib directory: 'cmsdir_lib
end

cmsdir_index=cmsdir||'\INDEX'
okk=dosisdir(cmsdir_index)
if okk=0 then do
  return 'string unable to find CMS index directory: 'cmsdir_index
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
mainaddon=left(uri,jj)||'cms.cmd'
root=left(uri,jj)

optname.=''
m=0
if list='' then list='action=1'
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) 
    if wordpos(avar,optname.0)=0 then optname.0=optname.0||' '||avar
    aval=translate(aval,' ', '+')
    aval=sre_packur(aval)
    avar1='!!'avar
    if optname.avar1<>'' then
       optname.avar1=optname.avar1||' '||aval
    else
       optname.avar1=aval
    avar2='!'avar
    aval2=strip(translate(aval,' ','090a0d'x))
    optname.avar2=aval2
end

/***** End of GENERIC CMS addon code *****/

if optname.!action='1' then do   /* find the list of dataseries defined for this host*/
  call show_datafiles
  foo=result
  return foo
end

if optname.!action='2' then do  
  call step2
  foo=result
  return foo
end


if optname.!action='3' then do  
  call step3
  foo=result
  return foo
end

return 'string unknown action 'action


/*******************/
/* pick one of the current cms datafiles (for this host) */
show_datafiles:

call lineout tempfile,'<html><head><title>CMS: Replicate a CMS datafile</title> '


call lineout tempfile,'<font size=-1><a href="'||mainaddon||'?action=1">Another CMS action</a> ||'
call lineout tempfile,'<a href="'||root||'cms_bak.cmd?action=1">Backup a CMS dataseries</a> '
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Replicate a CMS dataseries</h3><p> '
call lineout tempfile,'<em>Create a new dataseries, using the structure (and possibly the records) of a currently existing dataseries </em><br>'
ahost=host_nickname

/* look for files, in cmsDIR_index dir, of the form: ahost_nnnn.DEF
   These .DEF files define "CMS indices" --- nnnn is a number from 0 to 9999
*/

call lineout tempfile,'<FORM name="" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="2">'
ff=cmsdir_index||'\'||ahost||'*.DEF'
goo=sysfiletree(ff,'ff2','FO')

call lineout tempfile,'For host: <Tt>'||ahost||'</tt>, the following CMS dataseries currently exist'

call lineout tempfile,'<table border=1>'
do jj=1 to ff2.0
   daname=filespec('n',ff2.jj)
   call read_deffile ff2.jj
   call lineout tempfile,'<tr><th align="left">' 
   call lineout tempfile,'<INPUT TYPE="RADIO"  name="deffile" value="'||daname||'">'
   gob=strip(stuff.!series)||'</th>'
   call lineout tempfile,gob||'<td> <em>&nbsp;'||stuff.!desc||'</em></td>'
end

call lineout tempfile,'</table>'


call lineout tempfile,''
call lineout tempfile,'<p><INPUT name="sub2" TYPE="submit" VALUE="Replicate the selected dataseries">'
call lineout tempfile,'</form>'
call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/*******************/
/* show current structure, ask for changes */
step2:

call lineout tempfile,'<html><head><title>CMS: Replicate a dataseries</title> '
call lineout tempfile,'<script language="javascript">'
call lineout tempfile,' var the_select="NEW_SELECT"; '
call lineout tempfile,'function putit(sfile) {'
call lineout tempfile,'  eval("document.doredo." + the_select + ".value= ''" +  sfile + "''" ) ;'
call lineout tempfile,' return 0 ;}'
 call lineout tempfile,'</script>'
call lineout tempfile,'</head>'

daindx=optname.!deffile
goo=lastpos('/',mainaddon)
goo3=left(mainaddon,goo)||'/cms_redo.cmd'

call lineout tempfile,'<font size=-1>'
if optname.!CLOSEIT=1 then 
   call lineout tempfile,'<a href="javascript:close()">Close window</a> || '
else
   call lineout tempfile,'<a href="javascript:history.go(-1)">Back</a> || '
call lineout tempfile,' <a href="'||mainaddon||'?action=1">Another CMS action</a> || '
call lineout tempfile,'<a href="'||goo3||'?action=2&deffile='||daindx||'">Restructure old dataseries</a>  ' 
call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Replicate a CMS dataseries</h3> '

if daindx='' then do
   call lineout tempfile,'Error: you forgot to select a dataseries.<br>'
   call lineout tempfile,'Please <a href="javascript:history.go(-1)">go back</a> and select one!'
   signal gooble
end


ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

a=sre_cache_data(stuff.!series,'OPEN  INDEX',stuff.!file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,stuff.!file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

a=sre_cache_data(stuff.!series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   amess=sre_cache_data('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving info:</b> '||amess
   signal gooble
end

parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords '09'x  varlist '09'x  desc
ii=0
do until varlist=''
   parse var varlist avar varlist
   ii=ii+1
   varnames.ii=strip(translate(avar))
end
varnames.0=ii

call lineout tempfile,'<FORM  name="doredo" action="'||thisaddon||'" method="POST">'
call lineout tempfile,'<input type="hidden" name="action" value="3">'
call lineout tempfile,'<input type="hidden" name="deffile" value="'||daindx||'">'

call lineout tempfile,'<em>Replicating the CMS dataseries </eM>&nbsp;<b>'||stuff.!series||'</b>'


allvars=translate(stuff.!VARNAMES)
packvars=translate(stuff.!PACK)
specialVars=translate(stuff.!specials)
alltypes=translate(stuff.!vartypes)
call lineout tempfile,'<hr width="20%">'

call lineout tempfile,'<table><tr><td bgcolor="#a898a9">You can:</td>'
call lineout tempfile,'<td> <ul>'
call lineout tempfile,'<li>Start with no records, or copy the records in the old dataseries'
call lineout tempfile,'<li>Select which variables to include in the new dataseries'
call lineout tempfile,'<li>Modify the description '
call lineout tempfile,'<li>Change the list of usernames in OWNERS and OWNERS-Comment  '
call lineout tempfile,'<li>Modify the template files, and output &amp; upload directories'

call lineout tempfile,'</ul> </td></table>'


typenames.='undefined type'
typenames.!1='string'
typenames.!A='abstract'
typenames.!N='number'
typenames.!M='lines of text'
typenames.!C='checkbox'
typenames.!T='Date-time'
typenames.!S='select list'
typenames.!P='poll'
typenames.!F='file or url'

gotabs=0
selects=stuff.!SELECT
call lineout tempfile,'<hr width="20%">'

ii=lastpos('_',stuff.!series)
if ii=0 then do
   newseries=stuff.!series||'_2'
end 
else do
   iistring=substr(stuff.!series.ii+1)
   if datatype(iistring)='NUM' then do
       newseries=left(stuff.!series,ii)||(iistring+1)
   end 
   else do
       newseries=stuff.!series,ii||'_'||(iistring+1)
   end 
end

call lineout tempfile,'Series name: <input type="text" size=20 name="SERIES" value="'||newseries||'">'
call lineout tempfile,' <font size=-1><em>Required!</em></font><br>'
call lineout tempfile,'Series description: <input type="text" size=70 name="DESC" value="Copy of '||stuff.!DESC||'">'

call lineout tempfile,'<p><input type="checkbox" name="RETAINALL" value="1"> <b>Retain</b> all the 'nrecords' current records?' 

call lineout tempfile,'<p><em>You can remove zero, one, or more of the variables</em><br>'
call lineout tempfile,'<table  >'
call lineout tempfile,'<tr bgcolor="#aaaaaa" >'
call lineout tempfile,'<th>Remove</th><th>Name</th><th>Type</th>'
do mm=1 to words(allvars)
    avar1=strip(word(allvars,mm))
    atype1=strip(word(alltypes,mm))
    vtype1='!'||atype1
    call lineout tempfile,'<tr>'
    if avar1='$STATUS' then iterate
    call lineout tempfile,'<td><input type="checkbox" name="REMOVE" value="'||avar1||'"></td>'
    call lineout tempfile,'<th>'||avar1||'</th>'

    call lineout tempfile,'<td>'
    select 
      when atype1='A' then do
         call lineout tempfile,'(<tt>abstract</tt>)'
      end 
      otherwise do
        call lineout tempfile,'(<tt>'||typenames.vtype1||'</tt>)'
      end
    end
    call lineout tempfile,'</td>'

end 

call lineout tempfile,'</table>'

/* new variables */


call lineout tempfile,'<p><eM>Limit access to usernames (leave blank for open access)...</em><table border=1>'
call lineout tempfile,'<tr><th>Owners</th>'
msize=min(max(55,length(stuff.!OWNERS)+10),70)
call lineout tempfile,'<td><input type="text" name="OWNERS" '||,
                      ' value="'||stuff.!OWNERS||'" size='||msize||'></td>'

call lineout tempfile,'<tr><th>Owners-Comment</th>'
msize=min(max(55,length(stuff.!OWNERSCOMMENT)+10),70)
call lineout tempfile,'<td><input type="text" name="OWNERS_COMMENT" '||,
                      ' value="'||stuff.!OWNERSCOMMENT||'" size='||msize||'></td>'
call lineout tempfile,'</table>'

call lineout tempfile,'<p><em>Template file definitions</em><br><table border=1>'
tt=stuff.!!template
itt=0
do until tt=''
   parse var tt t1 '0d0a'x tt
   parse var t1 outfile tplfile ',' tdesc
   itt=itt+1
   call lineout tempfile,'<tr><td><b>Output file:</b><input type="text" name="OUTPUT_'||itt||'" '||,
                      ' value="'||outfile||'" size='||50||'>'
   call lineout tempfile,'<br><b>Template file:</b><input type="text" name="TEMPLATE_'||itt||'" '||,
                      ' value="'||tplfile||'" size='||50||'>'
   call lineout tempfile,'<br><b>Description:</b><input type="text" name="DESC_'||itt||'" '||,
                      ' value="'||tdesc||'" size='||80||'></td>'
end
call lineout tempfile,'</table>'



call lineout tempfile,'<p><eM>Modify upload &amp; file-storage directories (leave blank to use default)</em>'
call lineout tempfile,'<br><table border=1>'

call lineout tempfile,'<tr><th>Upload Directory</th>'
call lineout tempfile,'<td><input type="text" name="UPLOADDIR" '||,
                      ' value="'||stuff.!UPLOADDIR||'" size='||60||'></td>'

call lineout tempfile,'<tr><th>File-Storage Directory</th>'
call lineout tempfile,'<td><input type="text" name="FILEDIR" '||,
                      ' value="'||stuff.!FILEDIR||'" size='||60||'></td>'


call lineout tempfile,'</table>'


call lineout tempfile,'<p><eM>You can remove zero, one, or more comment variables</em>'
call lineout tempfile,'<br><table border=1>'
call lineout tempfile,'<tr bgcolor="#aaaaaa" >'
call lineout tempfile,'<th>Remove</th><th>Name</th><th>Type</th>'
cvars=stuff.!commentvars
do mm=1 to words(cvars)
    avar1=strip(word(cvars,mm))
    call lineout tempfile,'<tr>'
    if avar1='$STATUS' | avar1='$RECID' then iterate
    call lineout tempfile,'<td><input type="checkbox" name="CREMOVE" value="'||avar1||'"></td>'
    call lineout tempfile,'<th>'||avar1||'</th>'

    call lineout tempfile,'<td>'
    select 
      when abbrev(avar1,'_')=1 then do
         call lineout tempfile,'(<tt>multiple-line</tt>)'
      end 
      otherwise do
        call lineout tempfile,'(<tt>string</tt>)'
      end
    end
    call lineout tempfile,'</td>'

end 
call lineout tempfile,'</table>'


call lineout tempfile,'<p><input type="submit" value="Replicate the dataseries">'
call lineout tempfile,'<input type="reset" >'

call lineout tempfile,'</form>'


gooble:         /* jump here on error */

a=sre_cache_data(stuff.!series,'CLOSE',stuff.!file)

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode


/**********************************************************************/
/* replicate the dataseries */
step3:

call lineout tempfile,'<html><head><title>CMS: Replicating a dataseries </title> '
call lineout tempfile,'<script language="javascript">'


call lineout tempfile,'</head>'
call lineout tempfile,'<font size=-1>'
call lineout tempfile,'<a href="'||mainaddon||'?action=1">Another CMS action</a> ||'
call lineout tempfile,'<a href="javascript:history.go(-1)">Back</a> '

call lineout tempfile,'</font><br>'

call lineout tempfile,'<h3>Replicating a CMS dataseries</h3> '

daindx=optname.!deffile
ff=cmsdir_index||'\'||daindx
goo=stream(ff,'c','query exists')
if goo='' then do
   call lineout tempfile,'Error: could not find index file: '||ff
   signal gooble
end

call read_deffile ff
/* check for access rights */
rcode=check_access(stuff.!OWNERS,stuff.!SERIES)
if rcode<>1 then return rcode

old_Filename=stuff.!file
if pos('.',old_Filename)=0 then old_Filename=old_Filename||'.SDS'

old_commentfilename=stuff.!commentfile
if pos('.',old_commentFilename)=0 then old_commentFilename=old_commentFilename||'.SDS'

/* overwrite? */
new_series=strip(translate(optname.!series))
if new_series='' then do
   call lineout tempfile,'Error: you must specify a name for the new dataseries<br>'
   call lineout tempfile,'Please <a href="javascript:history.go(-1)">go back</a> and select one!'
   signal gooble
end

new_series_file=cmsdir||'\DATA\'||host_nickname||'_'||new_series||'.SDS'
if stream(new_series_file,'c','query exists')<>'' then do
   call lineout tempfile,'Error: a series with the name 'new_series' already exists.<br>'
   call lineout tempfile,'Please <a href="javascript:history.go(-1)">go back</a> and select one!'
   signal gooble
end

new_Desc=strip(optname.!desc)

old_series=strip(translate(stuff.!series))
old_series_file=strip(translate(stuff.!file))

/**
call lineout tempfile,'<ul>'
do until optname.0=''
   parse var optname.0 avv optname.0
   vv='!!'||strip(avv)
  call lineout tempfile,'<li>'avv '=' optname.vv
end
call lineout tempfile,'</ul>' 
*/

vstore='VALS VALINDEX '
dropvars=translate(optname.!!REMOVE)
chk1=stuff.!SPECIALS
do jj=1 to words(chk1)
   aw=strip(translate(word(chk1,jj)))
   if wordpos(aw,dropvars)>0 then iterate
   vstore=vstore||' '||aw
end

vstore=strip(vstore)
a=sre_cache_data(new_series,'DEFINE',new_series_file,vstore,optname.!!desc,,
                'Replication of '||old_Filename)
if a<>0 then do
  amess=sre_cache_data('DEFINE','ERROR',a,new_series_file)
  call lineout tempfile,'<b>Error</b>: '||amess||crlf
  signal gooble
end

/* create a !STATUS and !INFORM record */
newvarnames=''
newvartypes=''
varnames=stuff.!varnames
vartypes=stuff.!vartypes
do ii=1 to words(varnames)
   aw=strip(translate(word(varnames,ii)))
   if wordpos(aw,dropvars)>0 then iterate
   atype=strip(translate(word(vartypes,ii)))
   newvarnames=newvarnames||' '||aw
   newvartypes=newvartypes||' '||atype
end


sortables=stuff.!Specials
newsortables=''
do ii=1 to words(sortables)
   aw=strip(translate(word(sortables,ii)))
   if wordpos(aw,dropvars)>0 then iterate
   newsortables=newsortables||' '||aw
end


packs=stuff.!pack
newpacks=''
do ii=1 to words(packs)
   aw=strip(translate(word(packs,ii)))
   if wordpos(aw,dropvars)>0 then iterate
   newpacks=newpacks||' '||aw
end


selects=stuff.!Select
newselects=''
do until selects=''
  parse var selects aselect ';' selects
  if aselect='' then iterate
  parse var aselect aname '=' sfile
  aw=strip(translate(aname))
  if wordpos(aw,dropvars)>0 then iterate
  newselects=newselects||' '||aselect
end


polls=stuff.!Poll
newpolls=''
do until polls=''
  parse var polls apoll ';' polls
  if apoll='' then iterate
  parse var apoll aname '=' sfile
  aw=strip(translate(aname))
  if wordpos(aw,dropvars)>0 then iterate
  newpolls=newpolls||' '||apoll
end


newcommentvars=''
cdropvars=translate(optname.!!CREMOVE)
chk1=stuff.!commentvars
do jj=1 to words(chk1)
   aw=strip(translate(word(chk1,jj)))
   if wordpos(aw,cdropvars)>0 then iterate
   newcommentvars=newcommentvars||' '||aw
end
newcommentvars=strip(newcommentvars)

nuseries='_TMP_'
a=sre_cache_data(nuseries,'OPEN',new_series_file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,new_series_file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

poo=sre_cache_data(nuseries,'ADD WRITE ID7','_INFORM ', ,
   'Varnames='||strip(newvarnames)||,
   ' ; VarTypes='||strip(newvartypes)||,
   ' ; SORTABLE='||strip(newsortables)||,
   ' ; SELECTS='strip(newselects)||, 
   ' ; POLLS='strip(newpolls)) 

poo=sre_cache_data(nuseries,'ADD WRITE ID7','_LOOKUP',space(' ',70,' '))
poo=sre_cache_data(nuseries,'ADD WRITE ID7','_STATUS','                 ')
oii=sre_cache_data(nuseries,'close')


/* write index file */

tt=new_series_file
ii=lastpos('.',tt)
if ii=0 then do
   new_series_commentfile=tt||'_CMT'
end 
else do
   new_series_commentfile=left(tt,ii-1)||'$CMT'||substr(tt,ii)
end

oo='; CMS index file created '||time('n')||' '||date('n')||crlf
oo=oo||'Series: '||new_series||crlf
oo=oo||'File: '||new_series_file||crlf
oo=oo||'CommentFile: '||new_series_commentfile||crlf
oo=oo||'Created: '||time('n')||' '||date('n')||crlf
oo=oo||'Desc: '||optname.!desc||crlf
oo=oo||'Owners: '||optname.!OWNERS||crlf
oo=oo||'OwnersComment: '||optname.!OWNERS_COMMENT||crlf

oo=oo||'VarNames: '||strip(newvarnames)||crlf
oo=oo||'VarTypes: '||strip(newvartypes)||crlf
oo=oo||'Pack: '||strip(newpacks)||crlf
oo=oo||'Specials: '||strip(newsortables)||crlf
oo=oo||'CommentVars: '||newcommentvars||crlf

oo=oo||'Select: '||newselects||crlf
oo=oo||'Poll: '||newpolls||crlf

if optname.!UPLOADDIR<>'' then do
  oo=oo||'UploadDir: '||optname.!uploaddir||crlf
end

if optname.!FILEDIR<>'' then do
  oo=oo||'FileDir: '||optname.!filedir||crlf
end

/* template files */
vv=optname.0
tlist.='' ; tlist.0=0
do until vv=''
  parse upper var vv avv vv
  if abbrev(avv,'OUTPUT_')+abbrev(avv,'TEMPLATE_')+abbrev(avv,'DESC_')=0 then iterate
  parse var avv att '_' nn
  att='!'||STrip(att)
  avv0='!'||avv
  tlist.nn.att=optname.avv0
  tlist.0=max(nn,tlist.0)
end

do jj=1 to tlist.0
   if tlist.jj.!OUTPUT='' | tlist.jj.!TEMPLATE='' then iterate
   oo=oo||'Template: '||tlist.jj.!OUTPUT||' '||tlist.jj.!TEMPLATE||' , '||tlist.jj.!DESC||crlf
end 

t0=strip(left(new_series,6,' '))
t1=host_nickname||'_'||t0||'_???.DEF'
cmsindx_file=sre_tempfile(t1,,cmsdir_index)

arf=sre_append_file(cmsindx_file,oo,2,,1)
if arf<0 then return 'String Error: data series created, but unable to write CMS index file 'cmsindx_file


/* now do comment file */

a=sre_cache_data(new_series,'DEFINE',new_series_commentfile,newcommentvars,'Comments for:'||optname.!!desc,,
                'Replication of '||old_commentFilename)
if a<>0 then do
  amess=sre_cache_data('DEFINE','ERROR',a,new_series_commentfile)
  call lineout tempfile,'<b>Error</b>: '||amess||crlf
  signal gooble
end

/* create a !STATUS and !INFORM record */
cseries='OOGA'
a=sre_cache_data(cseries,'OPEN',new_series_commentfile)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,new_series_commentfile)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

poo=sre_cache_data(cseries,'ADD WRITE ID7','_INFORM ',left('Comments for 'new_series_file,70,' '))
poo=sre_cache_data(cseries,'ADD WRITE ID7','_STATUS',left(' ',70,' '))
a=sre_cache_data(cseries,'CLOSE')

call lineout tempfile,'<p>A new dataseries (<tt>'||new_series||')</tt> has been created '
call lineout tempfile,'(a replication of <tt> '||stuff.!SERIES||')</tt>.'

call lineout tempfile,'<table border=2><tr><td><pre>'||oo||'</pre></td></table>'

/***** Possibly write records to new dataseries ***/

if optname.!RETAINALL<>1 then signal gooble
call lineout tempfile,'<h3>Writing records to new dataseries </h3>'

a=sre_cache_data(old_series,'OPEN',old_series_file)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,old_series_file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end
a=sre_cache_data(old_series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   a=sre_cache_data(new_series,'CLOSE')
   amess=sre_cache_data('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving info:</b> '||amess
   signal gooble
end
parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords '09'x  varlist '09'x  desc

a=sre_cache_data(new_series,'OPEN',new_series_file)
if a>0 then do
   a=sre_cache_data(new_series,'CLOSE')
   a=sre_cache_data(old_series,'CLOSE')
   amess=sre_cache_data('OPEN','ERROR',a,old_series_file)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end

/* list of which sortables to use */
iss=0
nsorts=words(sortables)
do ii=1 to nsorts
   aw=strip(translate(word(sortables,ii)))
   if wordpos(aw,dropvars)>0 then iterate
   iss=iss+1
   suse.iss=ii
end
suse.0=iss

/* list of which packs to use */
ipp=0
npacks=words(packs)
do ii=1 to npacks
   aw=strip(translate(word(packs,ii)))
   if wordpos(aw,dropvars)>0 then iterate
   ipp=ipp+1
   puse.ipp=ii
end
puse.0=ipp

ierrs=0 ; ndid=0

do mm=1 to nrecords by 100       /* read 100 at a time */
   m1=mm
   m2=min(m1+99,nrecords)
   stuff=sre_cache_data(old_series,'EXTRACT',m1||'-'||m2)
   parse var stuff astat nthis '0d0a'x stuff
   if strip(astat)<>0 then do
      amess=sre_cache_data('EXTRACT','ERROR',astat)
      call lineout tempfile,'<b>Error retrieving info:</b> '||amess
      a=sre_cache_data(new_series,'CLOSE')
      a=sre_cache_data(old_series,'CLOSE')
      signal gooble
   end

   do mm2=1 to nthis
     parse var stuff aline '0d0a'x stuff
     parse var aline id7 ',' id '09'x vals '09'x valindex '09'x aline  /* $status treated as a sortable */

     if pos('*',id7)>0 | id7=id then iterate

/* get variables (sorted and packed) */
     do mm3=1 to nsorts
        parse var aline svals.mm3 '09'x aline
     end 

     iat=1
     do mm4=1 to npacks
       ilen=strip(word(valindex,mm4))
       if ilen=0 then iterate
       pvals.mm4=substr(vals,iat,ilen)
       iat=iat+ilen
     end

/* write to new dataseries. First, create new packed variables */
     newvals='' ; newindx=''
     if puse.0=0 then do
        newindx='0'
     end 
     else do
      do ipp=1 to puse.0   
        itt=puse.ipp
        gval=pvals.itt
        wlen=length(gval)
        newvals=newvals||gval
        newindx=newindx||' '||wlen
      end
     end

/* now, select retained sortables */
     sp.=''
     do iss=1 to suse.0
        itt=suse.iss
        sp.iss=svals.itt
     end 

     poo=sre_cache_data(new_series,'ADD ',id,,
              newvals,newindx,sp.1,sp.2,sp.3,sp.4,sp.5,sp.6,sp.7,sp.8)
     if length(poo)=1 then do
       ierrs=ierrs+1
     end   
     else do  
        ndid=ndid+1
     end 

  end            /* this set of 100 */
end             /* by 100's */

a=sre_cache_data(new_series,'CLOSE')
a=sre_cache_data(old_series,'CLOSE')

if ierrs>0 then do
   call lineout tempfile,'<B>ERROR</b>: There were 'ierrs' errors when writing records to new dataseries'
end
else do
   call lineout tempfile,'# of records copied: '||ndid
end 


/***** write comments to new dataseries ***/
old_commentfilename=stuff.!commentfile

a=sre_cache_data(old_series,'OPEN',old_commentfilename)
if a>0 then do
   amess=sre_cache_data('OPEN','ERROR',a,old_commentfilename)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end
a=sre_cache_data(old_series,'INFO',,'MODIFIED RECORDS VARS DESCRIPTION')
parse var a astat a ; astat=strip(astat)
if astat<>'0' then do
   a=sre_cache_data(new_series,'CLOSE')
   amess=sre_cache_data('INFO','ERROR',astat)
   call lineout tempfile,'<b>Error retrieving info:</b> '||amess
   signal gooble
end
parse var a . '0d0a'x . '09'x modified  '=' . '09'x nrecords '09'x  varlist '09'x  desc

a=sre_cache_data(new_series,'OPEN',new_series_commentfile)
if a>0 then do
   a=sre_cache_data(new_series,'CLOSE')
   a=sre_cache_data(old_series,'CLOSE')
   amess=sre_cache_data('OPEN','ERROR',a,new_series_commentfile)
   call lineout tempfile,'<b>Error:</b> '||amess
   signal gooble
end


/* list of which commentvars to use */
icc=0
ncmts=words(stuff.!commentvars)
do ii=1 to ncmts
   aw=strip(translate(word(stuff.!commentvars,ii)))
   if wordpos(aw,cdropvars)>0 then iterate
   icc=icc+1
   cuse.icc=ii
end
cuse.0=icc


ierrs=0 ; ndid=0

do mm=1 to nrecords by 100       /* read 100 at a time */
   m1=mm
   m2=min(m1+99,nrecords)
   stuff=sre_cache_data(old_series,'EXTRACT',m1||'-'||m2)
   parse var stuff astat nthis '0d0a'x stuff
   if strip(astat)<>0 then do
      amess=sre_cache_data('EXTRACT','ERROR',astat)
      call lineout tempfile,'<b>Error retrieving info:</b> '||amess
      a=sre_cache_data(new_series,'CLOSE')
      a=sre_cache_data(old_series,'CLOSE')
      signal gooble
   end

   do mm2=1 to nthis
     parse var stuff aline '0d0a'x stuff
     parse var aline id7 ',' id '09'x  aline  /* $status and $RECID treated as a sortable */

/* get variables */
     do mm3=1 to ncmts
        parse var aline cvals.mm3 '09'x aline
     end 


/* now, select retained sortables */
     sp.=''
     do iss=1 to cuse.0
        itt=cuse.iss
        sp.iss=cvals.itt
     end 

     poo=sre_cache_data(new_series,'ADD ',id,,
              sp.1,sp.2,sp.3,sp.4,sp.5,sp.6,sp.7,sp.8,sp.9,sp.10)
     if length(poo)=1 then do
       ierrs=ierrs+1
     end   
     else do  
        ndid=ndid+1
     end 

  end            /* this set of 100 */
end             /* by 100's */

a=sre_cache_data(new_series,'CLOSE')
a=sre_cache_data(old_series,'CLOSE')

call lineout tempfile,'<p>'
if ierrs>0 then do
   call lineout tempfile,'<B>ERROR</b>: There were 'ierrs' errors when writing comment to new dataseries'
end
else do
   call lineout tempfile,'# of comments copied: '||ndid
end 
call lineout tempfile,'<p>'

gooble:         /* jump here on error */
a=sre_cache_data(nuseries,'CLOSE')
a=sre_cache_data(stuff.!series,'CLOSE')

gooble2:        /* jump here on non-error */

call lineout tempfile,'</body> </html>'
call lineout tempfile
rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,idinfo)
return rcode



/*************/
/* read a definition file */
read_deffile:
parse arg afile
stuff.=''
stuff=sre_read_file(afile,2,2,1)
ilines=0
do until stuff=''
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   ilines=ilines+1
   stuff.!lines.ilines=aline
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline aname ':' avalue
   aname='!'||strip(translate(aname))
   stuff.aname=strip(avalue)
   bname='!'||aname
   if stuff.bname='' then
      stuff.bname=strip(avalue)
   else
      stuff.bname=stuff.bname||'0d0a'x||strip(avalue)
end
stuff.!lines.0=ilines
return 1




/******************************/
/* check access rights. Return 1 if okay. Otherwise, return a string to be
  sent back to SREhttp/2 (an authorization response string) */
check_access:procedure expose privset host_nickname idinfo uri aiter
parse  upper arg owners,series

if owners='' then return 1      /* no owners listed, means open access */

tpr=translate(privset)
pneeded=space(translate('CMS:'||strip(series)),0)
if wordpos(pneeded,tpr)>0 then return 1          /* explicit privilege for this */
if wordpos('SUPERUSER',tpr)>0 then return 1


/* see if a cookie exists */
look_cook='CMS_'||series
aa=sreh2_get_cookie(lookcook)
if aa<>''  then return 1

if aiter=''  then do            /* first time, so recheck privs */
  return 'PRIVS   Access to this dataseries is restricted to specific users '
end 

/* otherwise, see if a username has been sent  */
username=''
authh=sre_reqfield('Authorization')
if authh<>'' then username=sre_extract_username(authh) 
if username='' then do             /* no username available */
  return  'AUTH  Access to this dataseries is restricted to specific users '
end

/* is this one of the OWNERS? */
if pos('*',owners)=0 then do            /* * means "any user" */
if wordpos(translate(username),translate(owners))=0 then do
   return 'AUTH  Access to this dataseries is restricted to specific users '
end
end

/* One of the OWNERS, now check password */
stuff=sreh2_get_userinfo(authh,host_nickname,idinfo)
if stuff='' then do
  return 'AUTH   Access to this dataseries is restricted to specific users. Please enter a new username/password.'
end

parse var uri thisaddon '?' .
jj=lastpos('/',thisaddon)
pp=left(thisaddon,jj)

foo=sreh2_set_cookie(lookcook,1,'30m',pp,,1)

/* if here, legit user.  Record a cookie */
return 1

