/* this is the cms addon for  SREhttp/2 installation program */     

/* Load up advanced REXX functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

crlf='0d0a'x
copyall=0

/*---   Load REXX libraries ----- */
/* Load up advanced REXX functions */
foo=rxfuncquery('sysloadfuncs')
if foo=1 then do
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
  call SysLoadFuncs
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
   say "Caution: could not find REXXLIB (is it in your LIBPATH?) "
   say "(hit ENTER to continue)"
   pull ff
end /* do */


ansion=checkansi()
if ansion=1 then do
  aesc='1B'x
  cy_ye=aesc||'[37;46;m'
  normal=aesc||'[0;m'
  bold=aesc||'[1;m'
  re_wh=aesc||'[31;47;m'
  reverse=aesc||'[7;m'
end
else do
  say " Warning: Could not detect ANSI....  Install will look ugly ! "
  parse pull .
  cy_ye="" ; normal="" ; bold="" ;re_wh="" ;
  reverse=""
end  /* Do */

cls
say  " " ; say

call lineout, bold cy_ye
call lineout, "This is the CMS (ver 1.02v) installation program (June 2004)." 
call lineout, "      (for the SREhttp/2 web server) "
say "" 
say " This program will ask for the names of a few directories,"
say " and will copy a number of files to these directories."||normal
say ' '
if yesno(" Are you ready to continue ")=1 then
 nop
else do
 say " See you later?.. "
 exit
end


nowdir=directory()

sre2002_dir=sysini('USER','SRE2K','SRV_DIR')
filtername=sysini('USER','SRE2K','FILTER')
work_dir=sysini('USER','SRE2K','FILTER_DIR')
datadir=sysini('USER','SRE2K','DATADIR')

if sre2002_dir='' | abbrev(sre2002_dir,'ERROR:')=1 then do
  say "Before installing this addon, you must run SRE2003 (with SREhttp/2"
  say "as the filter) once -- this will initialize a few permanent variables"
  say "needed to guide addon installation. If you wish, you can run SRE2003, "
  say "immediately shut SRE2003 down, and then install this addon."
  exit
end

foo=work_dir||'\SREHTTP2.RXX'
if stream(foo,'c','query exists')=' ' then do
   say ' Could not find main SREhttp/2 program (SREHTTP2.RXX)'
   if yesno("  Are you sure you want to install this addon? ")=0 then exit
end  


dcshfile=sre2002_dir||'\BIN\SRE_DCSH.RXX'
oo=sysfiletree(dcshfile,'ARF','T')
parse var arf.1 adate .
if right(adate,2)<80 then
  adate='20'||adate
else
  adate='19'||adate

if adate<'2003/10/30/00/00' then do
  say 'CMS requires an up to date (ver 1.12c, circa Oct 2003) version of SRE2003.'
  say 'Please download the latest version from http://sre2003.srehttp.org/'
  exit
end


addondir=work_dir||'\ADDON'

cmsdir=addondir||'\CMS'

upload_dir=cmsdir||'\UPLOADS'
files_dir=cmsdir||'\FILES'
lib_dir=cmsdir||'\LIB'
pol_dir=cmsdir||'\LIB\POL'

predef_dir=cmsdir||'\LIB\PREDEF'

data_dir=cmsdir||'\DATA'
index_dir=cmsdir||'\INDEX'
archive_dir=cmsdir||'\DATA\ARCHIVE'

ddrive=left(cmsdir,1)
ftype=dosfilesys(ddrive)
if ftype='FAT' then do
   say 'Sorry. SREhttp/2 is installed on drive 'ddrive', but CMS requires a non-FAT drive.'
  exit
end 

say "CMS components will be installed to: "
say 
say bold"       Program files and documentation file: "normal||cmsdir

if yesno(" Are you ready to copy the files ")=0 then do
   say " Okay, you can try again later "
   exit
end 

foo=is_dir(cmsdir)
if foo=0 then do
    say "         Creating " cmsdir
    wow=dosmkdir(cmsdir)
    if wow=0 then do
      say "       Could not create " cmsdir
      exit
    end
end


foo=is_dir(lib_dir)
if foo=0 then do
    say "         Creating " lib_dir
    wow=dosmkdir(lib_dir)
    if wow=0 then do
      say "       Could not create " lib_dir
      exit
    end
end


foo=is_dir(predef_dir)
if foo=0 then do
    say "         Creating " predef_dir
    wow=dosmkdir(predef_dir)
    if wow=0 then do
      say "       Could not create " predef_dir
      exit
    end
end

foo=is_dir(pol_dir)
if foo=0 then do
    say "         Creating " pol_dir
    wow=dosmkdir(pol_dir)
    if wow=0 then do
      say "       Could not create " pol_dir
      exit
    end
end



foo=is_dir(upload_dir)
if foo=0 then do
    say "         Creating " upload_dir
    wow=dosmkdir(upload_dir)
    if wow=0 then do
      say "       Could not create " upload_dir
      exit
    end
end

foo=is_dir(files_dir)
if foo=0 then do
    say "         Creating " files_dir
    wow=dosmkdir(files_dir)
    if wow=0 then do
      say "       Could not create " files_dir
      exit
    end
end

foo=is_dir(data_dir)
if foo=0 then do
    say "         Creating " data_dir
    wow=dosmkdir(data_dir)
    if wow=0 then do
      say "       Could not create " data_dir
      exit
    end
end

foo=is_dir(archive_dir)
if foo=0 then do
    say "         Creating " archive_dir
    wow=dosmkdir(archive_dir)
    if wow=0 then do
      say "       Could not create " archive_dir
      exit
    end
end

foo=is_dir(index_dir)
if foo=0 then do
    say "         Creating " index_dir
    wow=dosmkdir(index_dir)
    if wow=0 then do
      say "       Could not create " index_dir
      exit
    end
end

say " "


say "Copying program files"

foo=check_copy('C*.CMD',cmsdir)
foo=check_copy('*.TXT',cmsdir)
foo=check_copy('CMS_DEF.HTM',cmsdir)
foo=check_copy('CMS_DEF2.HTM',cmsdir)
foo=check_copy('CMS_1.HTM',cmsdir)
foo=check_copy('CMS_c.HTM',cmsdir)

foo=check_copy('CMS.HTM',cmsdir)


say "Copying LIBRARY files "
foo=check_copy('*.OPT',lib_dir)
foo=check_copy('*.TXT',lib_dir)

foo=check_copy('*.CMS',lib_dir)
foo=check_copy('CMS_CMT.HTM',lib_dir)
foo=check_copy('CMT_RESP.HTM',lib_dir)
foo=check_copy('CMS_ADD.HTM',lib_dir)
foo=check_copy('ADD_RESP.HTM',lib_dir)

foo=check_copy('BLOG1.*',predef_dir)
foo=check_copy('BLOG2.*',predef_dir)

foo=check_copy('*.POL',pol_dir)
foo=check_copy('*_BOX.GIF',pol_dir)


say "Copying example  files"
foo=check_copy('*.TPL',files_dir)
foo=check_copy('*.SDS',data_dir)
foo=check_copy('*.SDI',data_dir)
foo=check_copy('*.DEF',index_dir)

adesc=' CMS is a content management system. It uses SRE2003''s built in database to'
adesc=adesc||'provide a flexible and powerful means for creating dynamic web pages, such as blogs.'

inifile=work_dir||'\ADDON\ADDONS.INI'
oo=sysini(inifile,'CMS','DESC',adesc)
oo=sysini(inifile,'CMS','URL','/cms/cms.CMD?')
oo=sysini(inifile,'CMS','DOC','/cms/cms.cmd?ACTION=2')
oo=sysini(inifile,'CMS','TEMP',archive_dir' 'upload_dir' 'files_dir)


say " "
say reverse " ------------------------------------------------- "normal
say bold " The CMS files and directories have been created. " normal
say " "
say " For some further hints, see the CMS.HTM file. "
say" "
if stream('CMS.TXT','c','query exists')<>'' then do
     ii=yesno(normal"      "bold"Would you like to view CMS.TXT ?"normal,,'N')
     if ii=1 then '@START  "The CMS Manual" /C /F /WIN e CMS.txt'
end


exit

/* ------------------------------------------------------------------ */
 /* function: Check if ANSI is activated                               */
 /*                                                                    */
 /* call:     CheckAnsi                                                */
 /*                                                                    */
 /* where:    -                                                        */
 /*                                                                    */
 /* returns:  1 - ANSI support detected                                */
 /*           0 - no ANSI support available                            */
 /*          -1 - error detecting ansi                                 */
 /*                                                                    */
 /* note:     Tested with the German and the US version of OS/2 3.0    */
 /*                                                                    */
 /*                                                                    */
 CheckAnsi: PROCEDURE
   thisRC = -1
 
   trace off
                         /* install a local error handler              */
   SIGNAL ON ERROR Name InitAnsiEnd
 
   "@ANSI 2>NUL | rxqueue 2>NUL"
 
   thisRC = 0
 
   do while queued() <> 0
     queueLine = lineIN( "QUEUE:" )
     if pos( " on.", queueLine ) <> 0 | ,                       /* USA */
        pos( " (ON).", queueLine ) <> 0 then                    /* GER */
       thisRC = 1
   end /* do while queued() <> 0 */
 
 InitAnsiEnd:
 signal off error
 RETURN thisRC


/* -------------------- */
/* get a yes or no , return 1 if yes */
yesno:procedure expose normal reverse bold
parse arg fooa , allopt,altans
if altans<>" " & words(altans)>1 then do
   w1=strip(word(altans,1))
   w2=strip(word(altans,2))
   a1=left(w1,1) ; a2=left(w2,1)
   a1a=substr(w1,2) ; a2a=substr(w2,2)
end
else do
    a1='Y' ; a1a='es'
    a2='N' ; a2a='o'
end  /* Do */
ayn='  '||bold||a1||normal||a1a||'\'||bold||a2||normal||a2a
if allopt=1 then  ayn=ayn||'\'||bold||'A'||normal||'ll'

do forever
 foo1=normal||reverse||fooa||normal||ayn
 call charout,  foo1 normal ':'
 pull anans
 if abbrev(anans,a1)=1 then return 1
 if abbrev(anans,a2)=1 then return 0
 if allopt=1 & abbrev(anans,'A')=1 then return 2
end



/*******************************************/
/* check for existence of file, then ask user to copy or not */
/* note that for X.* type copies, it only checks once
   (not for each file, but just for any one of them */
/********************************************/
check_copy: procedure expose copyall reverse bold normal
parse arg file1, dest1 , asis
amess=''

if asis="" then do
  dest2=strip(dest1,'t','\')||'\'
  filename=dest2||file1
end
else do
  filename=dest1
end /* do */

if copyall=1 then signal doit3

aa=sysfiletree(filename,isit,'F')

ok=1
if aa<>0 then do
   say " Warning: error when looking for pre-existing copy of: " filename
   ok=yesno(" Do you want to copy this file (or files) anyways? ")
   if ok=1 & amess<>""  then
      ok=yesno(amess)
end

if isit.0>0 then do
  if pos('*',file1)=0 then do
      say " "
      say " A file exists with the name: " filename
      ok=yesno(" Do you want to overwrite this file? ",1)
       say ' '
      if ok=1 & amess<>""  then
           ok=yesno(amess)
  end
  else do
    say " "
      say " There is at least one file that matches: " filename
      say "  (this match may " bold " not " normal " be one of the files that will be copied!) "
      ok=yesno(" Do you want to copy these files? ",1)
      say ' '
      if ok=1 & amess<>""  then
           ok=yesno(amess)
  end  /* Do */

end

if ok=2 then do
  say " "
  say "A number of files will be overwritten (not just this one) "
  copyall=yesno(" Are you sure you want to do this?")
  if copyall=0 then
      ok=yesno(" Do you want to overwrite the current file (or files)? ")
      say ' '
end

if ok=0  then return 0

doit3:          /* jump here if copyall is on, or noask=1 */
'@COPY ' file1 dest1 ' > NUL '

return 1


/* return 1 if adir is an existing (possibly empty) directory , 0 if not */
is_dir:procedure 
parse arg adir

adir=strip(adir)
adir=strip(adir,'t','\')
nowdir=directory()
nowdrive=filespec('d',nowdir'\')
nowpath=filespec('p',nowdir'\')
adr=filespec('d',adir)
if adr='' then do
   if abbrev(adir,'\')=0 then 
       adir=nowdrive||nowpath||adir
   else
       adir=nowdrive||adir
end /* do */

foo=sysfiletree(adir,goo,'D')
if  goo.0>0  then return 1
return 0



